      PROGRAM flame

      IMPLICIT NONE

      INCLUDE 'param.txt'
      INCLUDE 'param2.txt'
      INCLUDE 'common.txt'

      INTEGER ib,ie,jb,je,kb,ke,ini

      REAL time1
      
      LOGICAL mkflam

      REAL upipe(0:pi1,0:pj1,0:pk1)
      REAL vpipe(0:pi1,0:pj1,0:pk1)
      REAL wpipe(0:pi1,0:pj1,0:pk1)
      REAL drpipe
      INTEGER aup(0:i1)

      REAL rhs(imax,jmax,kmax)

      REAL alpha,beta,preexp,incrho,rhoi
      INTEGER iout

      COMMON /indata/ upipe,vpipe,wpipe,drpipe,aup
      COMMON /heatrl/ alpha,beta,preexp,incrho,rhoi

      DATA ib,ie,jb,je,kb,ke /1,imax,1,jmax,1,kmax/

c-------------------------------------------------------------------

c.....read in the stuff from the file "invoer".....

      READ(5,*) istart
      READ(5,*) nstep
      READ(5,*) nsteps
      READ(5,*) ioutp

      READ(5,*) time1
      READ(5,*) time
      READ(5,*) dtmax

      READ(5,*) Re
      READ(5,*) Pr
      READ(5,*) Le
      READ(5,*) Cs
      READ(5,*) Cl

      rdfile='start'
      flname='start'

c.....start main program.....

      CALL mkgrid
      
      CALL pipe(ijet)
      CALL interp

      incrho = 1.0
      rhoi   = 1.0
      alpha  = 0.4
      beta   = 7.0
      preexp = 0! 2000.0 
c      preexp = 0.0 

      IF (istart.eq.3) CALL fkdat
      IF (istart.eq.2) THEN
         CALL loadd(0)
      END IF

      CALL bound(unew,vnew,wnew,tnew,ynew,rhonew,time,ijet,dt,zp,zw,1,ru,rp)

      istep  = nsteps
      dt     = dtmax
      mkflam = .false.

c      CALL dynamic(ib,ie,jb,je,kb,ke)
c      CALL smagor(ib,ie,jb,je,kb,ke)
      CALL viscos(ib,ie,jb,je,kb,ke)

      CALL chkdt

c...................START MAIN LOOP..........................
c............................................................

      ini  = 0
      iout = 0
      DO istep=1+nsteps,nstep+nsteps

         IF(MOD(istep,1) .EQ. 0) CALL chkdt

         time=time+dt

            incrho=incrho+dt
            if(incrho .gt. 1.0) incrho=1.0

c         CALL dynamic(ib,ie,jb,je,kb,ke)
c         CALL smagor(ib,ie,jb,je,kb,ke)
         CALL viscos(ib,ie,jb,je,kb,ke)

c...predictor from sandia scheme...

         CALL advec(ib,ie,jb,je,kb,ke)
         CALL diffu(ib,ie,jb,je,kb,ke)

         CALL predic

         CALL fillps
         CALL psolver(ini,p,ru,rp,dphi,zp,zw)
         ini = 1
         CALL correc

         CALL bound(unew,vnew,wnew,tnew,ynew,rhonew,time,ijet,dt,zp,zw,1,ru,rp)

c...corrector from sandia scheme...

         CALL viscos(ib,ie,jb,je,kb,ke)

         CALL advec2(ib,ie,jb,je,kb,ke)
         CALL diffu2(ib,ie,jb,je,kb,ke)

         CALL predc2

         CALL fillps
         CALL psolver(ini,p,ru,rp,dphi,zp,zw)
         CALL correc

         CALL bound(unew,vnew,wnew,tnew,ynew,rhonew,time,ijet,dt,zp,zw,1,ru,rp)

c...dump fields...

         IF( MOD(istep,1).EQ. 0)THEN

            PRINT*,'dt=',dt,' time=',time
            PRINT*,'alpha=',alpha,'incrho=',incrho,'rhoi=',rhoi

            CALL chkdiv

c            IF(time .GT. 4.) STOP

         END IF

c...filter the scalar fields...

         IF(MOD(istep,1) .EQ. 0 .AND. 1.EQ.0)THEN
            DO k=1,kmax
               DO j=1,jmax
                  DO i=1,imax

                     IF(ynew(i,j,k).gt.1.0) ynew(i,j,k)=1.0
                     IF(ynew(i,j,k).lt.0.0) ynew(i,j,k)=0.0

                     IF(tnew(i,j,k).gt.1.0)THEN
                        tnew(i,j,k)=1.0
                        rhonew(i,j,k)=1.0/((incrho*alpha/(1.0-incrho
     $                       *alpha))*tnew(i,j,k)+rhoi)
                     END IF

                     IF(tnew(i,j,k).lt.0.0)THEN
                        tnew(i,j,k)=0.0
                        rhonew(i,j,k)=1.0/((incrho*alpha/(1.0-incrho
     $                       *alpha))*tnew(i,j,k)+rhoi)
                     END IF

                  END DO
               END DO
            END DO

            CALL scbndy(tnew,ynew,rhonew,ijet)
            
         END IF

c...update fields...

         CALL update

         IF(MOD(istep,100) .EQ. 0)THEN
            PRINT*,'output'

            iout=iout+1

            CALL output(iout)
c            CALL loadd(1)
c            CALL tec3d
         END IF

c.....................DONE ONE TIME ADVANCEMENT.............
c...........................................................

      END DO

      END

      SUBROUTINE interp

      IMPLICIT NONE

      INCLUDE 'param.txt'
      INCLUDE 'param2.txt'
      INCLUDE 'common.txt'

      INTEGER cnt

      REAL upipe(0:pi1,0:pj1,0:pk1)
      REAL vpipe(0:pi1,0:pj1,0:pk1)
      REAL wpipe(0:pi1,0:pj1,0:pk1)
      REAL drpipe
      INTEGER aup(0:i1)

      COMMON /indata/ upipe,vpipe,wpipe,drpipe,aup

c-------------------------------------------------------------------------

      drpipe=0.5/pimax

      cnt=1
      DO i=0,ijet
         
         IF(ru(i) .gt. cnt*drpipe) cnt=cnt+1
         aup(i)=cnt-1

      END DO

      RETURN
      END

      SUBROUTINE diffu2(ib,ie,jb,je,kb,ke)

      IMPLICIT NONE

      INCLUDE 'param.txt'
      INCLUDE 'common.txt'

      INTEGER  ib,ie,jb,je,kb,ke

c********************************************************************
c
c     Diffus calculates the diffusion for all variables over the
c     indicated domain. The indices ib,ie,jb,je,kb and ke ("i,j,k" for
c     the direction and "b" and "e" for begin and end) determine the
c     points for which the diffusion is calculated.
c
c     In this numerical model, we substituted the Euler-forward scheme
c     by a partly explicit and partly implicit method. In a fully
c     explicit scheme (like Euler-scheme) stability conditions limit
c     the maximum admissible timestep in a very severe way. Therefore,
c     we treat the diffusion in r- and z-direction explicitly in time,
c     whereas we treat the diffusion in phi-direction implicitly in time
c     to avoid stability problems.
c
c*********************************************************************


      CALL diffua(dudtnm,unew,vnew,wnew,munew,ru,rp,dphi,zw,zp,i1,j1,k1
     $     ,ib,ie,jb,je,kb,ke)

      CALL diffva(dvdtnm,unew,vnew,wnew,munew,ru,rp,dr,dphi,zw,zp,i1,j1
     $     ,k1,ib,ie,jb,je,kb,ke)

      CALL diffwa(dwdtnm,unew,vnew,wnew,munew,ru,rp,dphi,zw,zp,i1,j1,k1
     $     ,ib,ie,jb,je,kb,ke)

      CALL difftb(dtdtnm,unew,vnew,wnew,lmbnew,tnew,ynew,rhonew,ru,rp
     $     ,dphi,zw,zp,i1,j1,k1,ib,ie,jb,je,kb,ke,time)

      CALL diffyb(dydtnm,unew,vnew,wnew,difnew,tnew,ynew,rhonew,ru,rp
     $     ,dphi,zw,zp,i1,j1,k1,ib,ie,jb,je,kb,ke,time)

      RETURN
      END 

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------
      SUBROUTINE difftb(dtdt,u,v,w,lmb,t,y,rho,ru,rp,dphi,zw,zp,i1,j1,k1
     $     ,ib,ie,jb,je,kb,ke,time)

      IMPLICIT NONE

      INCLUDE 'param2.txt'

      INTEGER i1,j1,k1,ib,ie,jb,je,kb,ke
      INTEGER i,j,k,im,ip,jm,jp,km,kp

      REAL t(0:i1,0:j1,0:k1),rho(0:i1,0:j1,0:k1)
      REAL dtdt(0:i1,0:j1,0:k1),u(0:i1,0:j1,0:k1)
      REAL v(0:i1,0:j1,0:k1),w(0:i1,0:j1,0:k1)
      REAL lmb(0:i1,0:j1,0:k1),y(0:i1,0:j1,0:k1)

      REAL ru(0:i1),rp(0:i1),dphi,zw(0:k1),zp(0:k1)

      REAL Rei,Pri

      REAL time

      REAL Re,Pr,Le

      REAL alpha,beta,preexp,incrho,rhoi

      COMMON /nonnum/ Re,Pr,Le

      COMMON /heatrl/ alpha,beta,preexp,incrho,rhoi
c----------------------------------------------------------------------

      DO k=kb,ke

         kp=k+1
         km=k-1

         DO j=jb,je

            jp=j+1
            jm=j-1

            DO i=ib,ie

               ip=i+1
               im=i-1

               dtdt(i,j,k)=dtdt(i,j,k) + (1.0/rho(i,j,k))*(
     1              (ru(i)*(lmb(i,j,k)+lmb(ip,j,k))*(t(ip,j,k)-t(i,j,k
     1              ))/(rp(ip)-rp(i)) - ru(im)*(lmb(i,j,k)+lmb(im,j,k)
     1              )*(t(i,j,k)-t(im,j,k))/(rp(i)-rp(im)))/(2.0*rp(i)
     1              *(ru(i)-ru(im)))
     2              +((lmb(i,jp,k)+lmb(i,j,k))*(t(i,jp,k)-t(i,j,k)) -
     2              (lmb(i,j,k)+lmb(i,jm,k))*(t(i,j,k)-t(i,jm,k)))/(2
     2              .0*rp(i)**2*dphi**2)
     3              +((lmb(i,j,kp)+lmb(i,j,k))*(t(i,j,kp)-t(i,j,k))
     3              /(zp(kp)-zp(k)) - (lmb(i,j,k)+lmb(i,j,km))*(t(i,j
     3              ,k)-t(i,j,km))/(zp(k)-zp(km)))/(2.0*(zw(k)-zw(km))))
     4                    +
     4              preexp*y(i,j,k)*EXP((-beta*(1.0-t(i,j
     4              ,k)))/(1-alpha*(1.0-t(i,j,k))))


            END DO

         END DO

      END DO

      RETURN
      END 

c-----------------------------------------------------------------------
c-----------------------------------------------------------------------
      SUBROUTINE diffyb(dydt,u,v,w,dif,t,y,rho,ru,rp,dphi,zw,zp,i1,j1,k1
     $     ,ib,ie,jb,je,kb,ke,time)

      IMPLICIT NONE

      INCLUDE 'param2.txt'

      INTEGER i1,j1,k1,ib,ie,jb,je,kb,ke
      INTEGER i,j,k,im,ip,jm,jp,km,kp

      REAL y(0:i1,0:j1,0:k1),rho(0:i1,0:j1,0:k1)
      REAL dydt(0:i1,0:j1,0:k1),u(0:i1,0:j1,0:k1)
      REAL v(0:i1,0:j1,0:k1),w(0:i1,0:j1,0:k1)
      REAL dif(0:i1,0:j1,0:k1),t(0:i1,0:j1,0:k1)

      REAL ru(0:i1),rp(0:i1),dphi,zw(0:k1),zp(0:k1)

      REAL Rei,Pri,Lei

      REAL time

      REAL Re,Pr,Le

      REAL alpha,beta,preexp,incrho,rhoi

      COMMON /nonnum/ Re,Pr,Le

      COMMON /heatrl/ alpha,beta,preexp,incrho,rhoi
c----------------------------------------------------------------------

      DO k=kb,ke

         kp=k+1
         km=k-1

         DO j=jb,je

            jp=j+1
            jm=j-1

            DO i=ib,ie

               ip=i+1
               im=i-1

               dydt(i,j,k)=dydt(i,j,k) + (
     1              (ru(i)*(dif(i,j,k)+dif(ip,j,k))*(y(ip,j,k)-y(i,j,k
     1              ))/(rp(ip)-rp(i)) - ru(im)*(dif(i,j,k)+dif(im,j,k)
     1              )*(y(i,j,k)-y(im,j,k))/(rp(i)-rp(im)))/(2.0*rp(i)
     1              *(ru(i)-ru(im)))
     2              +((dif(i,jp,k)+dif(i,j,k))*(y(i,jp,k)-y(i,j,k)) -
     2              (dif(i,j,k)+dif(i,jm,k))*(y(i,j,k)-y(i,jm,k)))/(2
     2              .0*rp(i)**2*dphi**2)
     3              +((dif(i,j,kp)+dif(i,j,k))*(y(i,j,kp)-y(i,j,k))
     3              /(zp(kp)-zp(k)) - (dif(i,j,k)+dif(i,j,km))*(y(i,j
     3              ,k)-y(i,j,km))/(zp(k)-zp(km)))/(2.0*(zw(k)-zw(km))))
     4                    -
     4               preexp*rho(i,j,k)*y(i,j,k)*EXP((-beta*(1.0-t(i,j
     4              ,k)))/(1-alpha*(1.0-t(i,j,k))))

            END DO

         END DO

      END DO

      RETURN
      END 

      SUBROUTINE predc2

      IMPLICIT NONE

      INCLUDE 'param.txt'
      INCLUDE 'param2.txt'
      INCLUDE 'common.txt'

      REAL alpha,beta,preexp,incrho,rhoi

      COMMON /heatrl/ alpha,beta,preexp,incrho,rhoi
c----------------------------------------------------------------

c     compute the new values of the temperature and scalar.

c **** temperature prediction *****

      IF (1.EQ.1)THEN

         DO k=1,kmax
            DO j=1,jmax
               DO i=1,imax

                  tnew(i,j,k)=told(i,j,k) + dt*0.5*(dtdtn(i,j,k)+dtdtnm(i,j
     $                 ,k))
               
                  rhonew(i,j,k) = 1.0/((incrho*alpha/(1.0-incrho*alpha))
     $                 *tnew(i,j,k)+rhoi)

               END DO
            END DO
         END DO

         CALL scbndy(tnew,ynew,rhonew,ijet)
         
      END IF

c **** scalar prediction ****

      IF (1.EQ.1)THEN

         DO k=1,kmax
            DO j=1,jmax
               DO i=1,imax

                  ymnew(i,j,k)=ymold(i,j,k) + dt*0.5*(dydtn(i,j,k)+dydtnm(i
     $                 ,j,k))

                  ynew(i,j,k)=ymnew(i,j,k)/rhonew(i,j,k)

               END DO
            END DO
         END DO

         CALL scbndy(tnew,ynew,rhonew,ijet)
         
      END IF

c **** velocity prediction ****

      DO k=1,kmax
         DO j=1,jmax
            DO i=1,imax

               umnew(i,j,k)=umold(i,j,k)+0.5*dt*(dudtn(i,j,k) + 
     $              dudtnm(i,j,k))

               unew(i,j,k)=umnew(i,j,k)/(0.5*(rhonew(i,j,k)+rhonew(i+1,j
     $             ,k)))
               
               vmnew(i,j,k)=vmold(i,j,k)+0.5*dt*(dvdtn(i,j,k) +
     $              dvdtnm(i,j,k))

               vnew(i,j,k)=vmnew(i,j,k)/(0.5*(rhonew(i,j,k)+rhonew(i,j+1
     $             ,k)))
               
            END DO
         END DO
      END DO

      
      DO k=1,kmax-1
         DO j=1,jmax
            DO i=1,imax

               wmnew(i,j,k)=wmold(i,j,k)+0.5*dt*(dwdtn(i,j,k) +
     $              dwdtnm(i,j,k))

               wnew(i,j,k)=wmnew(i,j,k)/(0.5*(rhonew(i,j,k)+rhonew(i,j
     $              ,k+1)))

            END DO
         END DO
      END DO

      CALL bound(unew,vnew,wnew,tnew,ynew,rhonew,time,ijet,dt,zp,zw,0,ru,rp)

      RETURN
      END

      SUBROUTINE psolver(ini,rhs,Ru,Rp,dphi,zp,zw)
      implicit none
c
c     RHS(IMAX,JMAX,KMAX)  on entry is the right hand side of the Poisson
c                          equation. On exit it contains the solution.
c
c     Ru(0:i1), Rp(0:i1)   arrays with the radial locations of velocity and
c                          pressure points
c
c     dphi                 azimuthal grid spacing
c
c     dz                   axial grid spacing
c
c
c

      include   'param.txt'
      REAL      RHS(IMAX,JMAX,KMAX),Ru(0:IMAX+1),Rp(0:IMAX+1),DPHI
      REAL      Y  (IMAX,KMAX)
      REAL      work(3*imax*kmax),pi,SW(10*imax*kmax),WW(10*imax*kmax)
c
c     Locals
c
      real      dz,dzi,bbb,z
      real      ar(imax),br(imax),cr(imax),dm(imax),brr(imax)
      real      az(kmax),bz(kmax),cz(kmax)
      real      yrt(jmax),wj(jmax+15)
      real      vfftj(imax*kmax,jmax)
      real      zp(0:kmax+1),zw(0:kmax+1)

c     WJ and WK are arrays with tables for Fourier transforms.
c

      integer   ipos,ier,ini
c
      call bvrffti(jmax,wj)

      pi = 4.*atan(1.)

c  J --> direction      (yrt)
      yrt(1    ) = 0.
      yrt(jmax ) = -4./(dphi*dphi)
      do j=3,jmax,2
      yrt(j-1)=(-4./(dphi*dphi))*(sin(float((j-1))*pi/(2.*jmax)))**2
      yrt(j  )= yrt(j-1)
      enddo

     
      do k=1,kmax
         do i=1,imax
         ipos = (k-1)*imax+i
           do j=1,jmax
             vfftj(ipos,j)=rhs(i,j,k)
           enddo
         enddo
      enddo

c     FFT in j direction

      call bvrfftf(imax*kmax,jmax,vfftj,rhs,imax*kmax,wj)
      do k=1,kmax
         do i=1,imax
         ipos = (k-1)*imax+i
            do j=1,jmax
               rhs(i,j,k) =vfftj(ipos,j)
            enddo
         enddo
      enddo
c
c
c
c  

      do j=1,jmax



	do k=1,kmax
	  do i=1,imax
	   Y(i,k) = rhs(i,j,k)
          enddo
        enddo

       do i=1,imax
       ar(i)=  Ru(I-1)/((Rp(I)-Rp(I-1))*Rp(I)*(Ru(I)-Ru(I-1)))
       br(i)=-(Ru(I)/(Rp(I+1)-Rp(I))+Ru(I-1)/(Rp(I)-Rp(I-1)))/
     $      (Rp(I)*(Ru(I)-Ru(I-1)))
       cr(i)=  Ru(I  ) /((Rp(I+1)-Rp(I))*Rp(I)*(Ru(I)-Ru(I-1)))
       dm(i)=1./((Rp(i)*dphi)**2)
       end do

       br(1)=   -(Ru(1)/(Rp(2)-Rp(1)))/(Rp(1)*(Ru(1)-Ru(0)))
       ar(1)=0.
       br(imax)=br(imax)-cr(imax)  ! dirichlet
c      br(imax)=br(imax)+cr(imax)   ! neumann
       cr(imax)=0.

       do k=1,kmax
           az(k)=1./( ( Zw(k)-Zw(k-1))*(Zp(k)-Zp(k-1)) )
           cz(k)=1./( ( Zw(k)-Zw(k-1))*(Zp(k+1)-Zp(k)) )
           bz(k)=-(az(k)+cz(k))
       enddo
       bz(1)=bz(1)+az(1)
       az(1)=0.
       bz(kmax)=bz(kmax)+cz(kmax)    ! orginal - neumann
c      bz(kmax)=bz(kmax)-cz(kmax)   ! dirichlet
       cz(kmax)=0.

      do i=1,imax
	brr(i)=br(i)+yrt(j)/(rp(i)**2)
      enddo 

      call blktri(0,1,kmax,az,bz,cz,1,
     $               imax,ar,brr,cr,imax,y,ier,work)
      call blktri(1,1,kmax,az,bz,cz,1,imax,ar,brr,cr,imax,y,
     $               ier,work)


c... these are crayfish routines which are on vn...

c      call S2GCIS(imax,ar,brr,cr,kmax,az,bz,cz,imax,ier,SW,WW)
c      call S2GCSS(imax,y,SW,WW) 

      do k=1,kmax
          do i=1,imax
          rhs(i,j,k)=Y(i,k)
          enddo
        enddo



      enddo  ! end j-loop


      do k=1,kmax
         do i=1,imax
         ipos = (k-1)*imax+i
           do j=1,jmax
             vfftj(ipos,j)=rhs(i,j,k)
           enddo
         enddo
      enddo
      call bvrfftb(imax*kmax,jmax,vfftj,rhs,imax*kmax,wj)
      do k=1,kmax
         do i=1,imax
         ipos = (k-1)*imax+i
            do j=1,jmax
               rhs(i,j,k) =vfftj(ipos,j)
            enddo
         enddo
      enddo
      end

      SUBROUTINE predic

      IMPLICIT NONE

      INCLUDE 'param.txt'
      INCLUDE 'param2.txt'
      INCLUDE 'common.txt'

      REAL alpha,beta,preexp,incrho,rhoi

      COMMON /heatrl/ alpha,beta,preexp,incrho,rhoi
c--------------------------------------------------------------------

c     compute the star values of the temperature and scalar.

      IF(1.eq.1)THEN

      DO k=1,kmax
         DO j=1,jmax
            DO i=1,imax

               tnew(i,j,k)=told(i,j,k)+dt*(1.5*dtdtn(i,j,k)-0.5
     $              *dtdtnm(i,j,k))

               ymnew(i,j,k)=ymold(i,j,k)+dt*(1.5*dydtn(i,j,k)-0.5
     $              *dydtnm(i,j,k))

               rhonew(i,j,k) = 1.0/((incrho*alpha/(1.0-incrho*alpha))
     $              *tnew(i,j,k)+rhoi)

               ynew(i,j,k)=ymnew(i,j,k)/rhonew(i,j,k)

            END DO
         END DO
      END DO

      CALL scbndy(tnew,ynew,rhonew,ijet)

      END IF

c     compute the predicted star values for the velocity.

      DO k=1,kmax
         DO j=1,jmax
            DO i=1,imax

               umnew(i,j,k)=umold(i,j,k)+dt*(1.5*dudtn(i,j,k)-0.5
     $              *dudtnm(i,j,k))

               unew(i,j,k)=umnew(i,j,k)/(0.5*(rhonew(i,j,k)+rhonew(i+1,j
     $             ,k)))

               
               vmnew(i,j,k)=vmold(i,j,k)+dt*(1.5*dvdtn(i,j,k)-0.5
     $              *dvdtnm(i,j,k))

               vnew(i,j,k)=vmnew(i,j,k)/(0.5*(rhonew(i,j,k)+rhonew(i,j+1
     $             ,k)))
               
            END DO
         END DO
      END DO

      
      DO k=1,kmax-1
         DO j=1,jmax
            DO i=1,imax

               wmnew(i,j,k)=wmold(i,j,k)+dt*(1.5*dwdtn(i,j,k)-0.5
     $              *dwdtnm(i,j,k))

               wnew(i,j,k)=wmnew(i,j,k)/(0.5*(rhonew(i,j,k)+rhonew(i,j
     $              ,k+1)))

            END DO
         END DO
      END DO


      CALL bound(unew,vnew,wnew,tnew,ynew,rhonew,time,ijet,dt,zp,zw,1,ru,rp)


      RETURN
      END

      SUBROUTINE correc
       
      IMPLICIT NONE

      INCLUDE 'param.txt'
      INCLUDE 'common.txt'


      real flux,flux1,flux2,flux3,sum


c****************************************************************
c
c     Subroutine correc corrects the predicted velocities dUdt, dVdt
c     and dWdt in order to satisfy continuity. All other variables
c     (i.e. all scalars) do not need this correction, which means that
c     the predicted values (subroutine predic) are O.K.
c
c     The predicted velocities, normal to the wall, at the boundary
c     r=R are known (set at end of subroutine predic):
c
c                dUdt(imax,j,k) = 0.0    (r=R).
c
c     Therefore we do not need pressure points outside of the domain
c     for the calculation of the U-velocity on the boundary.
c     For the V- and W-velocity we have to take periodic boundary
c     conditions for the pressure in theta- and z-direction.
c     This means:
c
c                p(i,j1,k) = p(i,1,k)
c                p(i,j,k1) = p(i,j,1)
c
c****************************************************************
c
c
c ***************** CORRECTION  U-VELOCITY **********************


      DO k=1,kmax
        DO j=1,jmax
           DO i=1,imax-1

              umnew(i,j,k) = umnew(i,j,k) -
     +        dt * ( p(i+1,j,k) - p(i,j,k) ) /
     +                ( Rp(i+1) - Rp(i) )

              unew(i,j,k)=umnew(i,j,k)/(0.5*(rhonew(i,j,k)+rhonew(i+1,j
     $             ,k)))


           END DO
        END DO
      END DO


      if(1.eq.1)then

      DO k=1,kmax
         DO j=1,jmax

            umnew(imax,j,k)=umnew(imax,j,k)-dt*(-2*P(imax,j,k))
     $             /(Rp(imax+1)-Rp(imax))

            unew(imax,j,k)=umnew(imax,j,k)/(0.5*(rhonew(imax,j,k)
     $             +rhonew(i1,j,k)))
            
         END DO
      END DO
        
      end if

c ******************** END U-VELOCITY ***************************
c
c
c ******************** CORRECTION  V-VELOCITY *******************


      DO k=1,kmax
         DO j=1,jmax-1
           DO i=1,imax

              vmnew(i,j,k) = vmnew(i,j,k) -
     +        dt * ( p(i,j+1,k) - p(i,j,k) ) /
     +                ( Rp(i) * dphi )

              vnew(i,j,k)=vmnew(i,j,k)/(0.5*(rhonew(i,j,k)+rhonew(i,j+1
     $             ,k)))

           END DO
        END DO
      END DO

c *** Treat j=jmax as a special case: ***


      DO k=1,kmax
        DO i=1,imax

           vmnew(i,jmax,k) = vmnew(i,jmax,k) -
     +       dt * ( p(i,1,k) - p(i,jmax,k) ) /
     +              ( Rp(i) * dphi )

           vnew(i,jmax,k)=vmnew(i,jmax,k)/(0.5*(rhonew(i,jmax,k)
     $          +rhonew(i,j1,k)))

        END DO
      END DO


c ******************** END V-VELOCITY **************************
c
c
c ***************** CORRECTION  W-VELOCITY *********************


      DO k=1,kmax-1
         DO j=1,jmax
            DO i=1,imax
             
               wmnew(i,j,k) = wmnew(i,j,k) -
     +         dt * ( p(i,j,k+1) - p(i,j,k) ) / (zp(k+1)-zp(k))

               wnew(i,j,k)=wmnew(i,j,k)/(0.5*(rhonew(i,j,k)+rhonew(i,j
     $              ,k+1)))

            END DO
         END DO
      END DO


c ******************** END W-VELOCITY **************************


      RETURN
      END

      SUBROUTINE output(iout)

      IMPLICIT NONE

      INCLUDE 'param.txt'
      INCLUDE 'param2.txt'
      INCLUDE 'common.txt'

      REAL react
      INTEGER ktmp,iout
      CHARACTER*6 intfil

      REAL alpha,beta,preexp,incrho,rhoi

      COMMON /heatrl/ alpha,beta,preexp,incrho,rhoi
c--------------------------------------------------------------------

      WRITE(intfil,'(i6)') iout
      intfil=ADJUSTL(intfil)

      OPEN(15,file='burnout'//intfil)

      WRITE(15,*
     $     )' VARIABLES = "R","Z","U","V","W","P","T","Y","Rx","Rho"'
      WRITE(15,*)'ZONE F=POINT, I= ',2*imax,  ' J= ',kmax

      DO k=1,kmax

         ktmp =k 
         IF(k.EQ.0) ktmp=1
      
         j=jmax/2
         DO i=imax,1,-1

            react=preexp*ynew(i,j,k)*EXP((-beta*(1.0-tnew(i
     $           ,j,k)))/(1-alpha*(1.0-tnew(i,j,k))))


            WRITE(15,1129) -ru(i),zw(k),-unew(i,j,k),vnew(i,j,k),
     1           wnew(i,j,k),p(i,j,ktmp),tnew(i,j,k),ynew(i,j,k),react
     $           ,rhonew(i,j,k)

         END DO

         j=1
         DO i=1,imax

            react=preexp*ynew(i,j,k)*EXP((-beta*(1.0-tnew(i
     $           ,j,k)))/(1-alpha*(1.0-tnew(i,j,k))))

            WRITE(15,1129) ru(i),zw(k),unew(i,j,k),vnew(i,j,k),
     1           wnew(i,j,k),p(i,j,ktmp),tnew(i,j,k),ynew(i,j,k),react
     $           ,rhonew(i,j,k)

         END DO
      END DO

      CLOSE(15)

1129  FORMAT(10E14.6)

      RETURN
      END

      SUBROUTINE mkgrid

      IMPLICIT NONE

      INCLUDE 'param.txt'
      INCLUDE 'param2.txt'
      INCLUDE 'common.txt'
      
      REAL pi
      
      LOGICAL done

      real x,dx

      real gam1,ksi1,gam2,ksi2,kk1,kk2,h
      integer ns
      real eta,zuni(0:kmax),runi(0:imax)
      real xacc
      parameter (xacc=1.0E-6)
      real lambda,theta
      external funcd
      real sech,rtnewt

      REAL yplus
c--------------------------------------------------------------------

      pi=4.0*ATAN(1.0)


c     theta-grid...


      dphi=2.0*pi/jmax


c     r-grid...

      IF(1.EQ.1)THEN  ! non-uniform grid

         DO i=0,imax
            runi(i)=i*(lr/2.0)/imax
         END DO

         ns=imax/1.5
         h=.55*(lr/2.0)
         eta=runi(ns)
         gam1=0.5
         ksi1=0.5*(lr/2.0)
         kk1=h/(ksi1*(1.0-tanh(gam1*(ksi1-eta))/tanh(gam1*ksi1)))

         DO i=0,ns
            ru(i)=kk1*ksi1*(1.0-tanh(gam1*(ksi1-runi(i)))/tanh(gam1*ksi1
     $           ))
         END DO

         kk2  = ((lr/2.0)-h)/((lr/2.0)-eta)
         ksi2 = (lr/2.0)

         lambda=kk1*gam1*ksi1*(sech(gam1*(ksi1-eta)))**2/tanh(gam1*ksi1)
      
         theta=rtnewt(funcd,0.5,5.0,xacc,kk2,lambda)
         gam2=theta/(2.0*(ksi2-eta))
      
         DO i=ns+1,imax
            ru(i)=h+kk2*(ksi2-eta)*(1.0-tanh(gam2*(ksi2-runi(i)))
     $           /tanh(gam2*(ksi2-eta)))
         END DO

         ru(0)=0.0
      
      ELSE   ! uniform grid

         ru(0)=0
         DO i=1,imax
            x= 1.*i/imax
            dx= 1.0
            ru(i)=ru(i-1)+dx
         END DO
         DO i=0,imax
            ru(i)=ru(i)*0.5*lr/ru(imax)
         END DO
      
      END IF

      DO i=1,imax
         rp(i)=(ru(i)+ru(i-1))/2.0
         dr(i)=(ru(i)-ru(i-1))
      END DO

      ru(i1)=ru(imax) + (ru(imax)-ru(imax-1))

      dr(i1) = dr(imax)
      dr(0)  = dr(1)

      rp(i1)=2.0*ru(imax) - rp(imax)

      rp(0)=ru(0) - (ru(1)-ru(0))/2.0


      done=.FALSE.
      ijet=i1
      DO i=1,imax
         IF(ru(i) .GT. 0.5 .AND. .NOT. done)THEN 
            ijet=i-1
            done=.TRUE.
         END IF
      END DO
            
c     z-grid...

      IF(1.eq.0)THEN    ! non-uniform grid



         DO k=0,kmax
            zuni(k)=k*lz/kmax
         END DO

c      ns=kmax/3.25
c      h=.65*lz
c      eta=zuni(ns)
c      gam1=7.

         ns=kmax/2.2
         h=.5*lz
         eta=zuni(ns)
         gam1=3.0


         ksi1=0.01
         kk1=h/(ksi1*(1.0-tanh(gam1*(ksi1-eta))/tanh(gam1*ksi1)))

         DO k=0,ns
            zw(k)=kk1*ksi1*(1.0-tanh(gam1*(ksi1-zuni(k)))/tanh(gam1*ksi1
     $           ))
         END DO

         kk2=(lz-h)/(lz-eta)
         ksi2=lz

         lambda=kk1*gam1*ksi1*(sech(gam1*(ksi1-eta)))**2/tanh(gam1*ksi1)

         theta=rtnewt(funcd,0.25,8.0,xacc,kk2,lambda)
         gam2=theta/(2.0*(ksi2-eta))
      
         DO k=ns+1,kmax
            zw(k)=h+kk2*(ksi2-eta)*(1.0-tanh(gam2*(ksi2-zuni(k)))
     $           /tanh(gam2*(ksi2-eta)))
         END DO

      ELSE   ! uniform grid

         zw(0)=0.  
         DO  k=1,kmax
            x = 1.*k/kmax 
            dx = 1.0
            zw(k)=zw(k-1)+dx 
         END DO
         DO k=0,kmax
            zw(k)=zw(k)*lz/zw(kmax)
         END DO

      END IF


      DO k=1,kmax
         zp(k)=(zw(k)+zw(k-1))/2.0
         dz(k)=(zw(k)-zw(k-1))
      END DO

      zw(k1)=zw(kmax) + (zw(kmax)-zw(kmax-1))

      dz(k1) = dz(kmax)
      dz(0)  = dz(1)

      zp(k1)=2.0*zw(kmax) - zp(kmax)

      zp(0)=zw(0) - (zw(1)-zw(0))/2.0


c *** Calculate mixing length of the subgrid scale motions:

      DO i=1,imax
         DO k=1,kmax

            delta(i,k) = ( rp(i) * dphi )**2 +
     &                   (     dr(i)    )**2 +
     &                   (     dz(k)    )**2 

            delbr(i,k) = ( rp(i) * dphi )**2 +
     &                   (     dr(i)    )**2 +
     &                   (     dz(k)    )**2

            delht(i,k) = ( 2*rp(i)*dphi )**2 +
     &                   (     dr(i)    )**2 +
     &                   (    2*dz(k)   )**2

         END DO
      END DO


      DO i=1,imax
         DO k=1,kmax

            lmix(i,k) = Cs * delta(i,k)
            
         END DO
      END DO

c...output r-phi grid to file to use in the program interpolating
c...turbulence in a box onto a cylinderical domain

      OPEN(15,FILE='grid.out',STATUS='UNKNOWN')

      WRITE(15,10) ijet,dphi
 10   FORMAT(1(I5),F17.12)

      DO i=0,i1
         WRITE(15,20) ru(i),rp(i)
 20      FORMAT(2(F17.12))
      END DO

      CLOSE(15)


      RETURN
      END

c---------------------------------------------------------------------
c---------------------------------------------------------------------

      
      function sech(x)
      real x
      
      sech=1.0/cosh(x)

      return
      end



      function rtnewt(funcd,x1,x2,xacc,k,l)

      integer jmax
      real rtnewt,x1,x2,xacc
      external funcd
      parameter (jmax=200)
      integer j
      real df,dx,f,k,l

      rtnewt=.5*(x1+x2)
      do j=1,jmax
         call funcd(rtnewt,k,l,f,df)
         dx=f/df
         rtnewt=rtnewt-dx
         if((x1-rtnewt)*(rtnewt-x2) .lt. 0.0) pause 'out brackets'
         if(abs(dx) .lt. xacc) return
      end do
      pause 'rtnewt exceeded maximum iterations'
      end 



      subroutine funcd(x,k,l,f,df)
      real k,l,x,f,df

      f=k*x - l*sinh(x)
      df=k-l*cosh(x)

      return
      end

      SUBROUTINE chkdiv

      IMPLICIT NONE

      INCLUDE 'param.txt'
      INCLUDE 'common.txt'

      REAL diverg,divmax,divbar

c--------------------------------------------------------------------

      divbar = 0.0
      divmax = 0.0

      DO k=1,kmax
         DO j=1,jmax
            DO i=1,imax

               diverg = 
     1  (3.0*rhonew(i,j,k)-4.0*rhold1(i,j,k)+rhold2(i,j,k))/(2.0*dt) *
     1   rp(i)*dr(i)*dphi*dz(k)
     +         +
     2  (ru(i)*0.5*(rhonew(i+1,j,k)+rhonew(i,j,k))*unew(i,j,k) - 
     2   ru(i-1)*0.5*(rhonew(i,j,k)+rhonew(i-1,j,k))*unew(i-1,j,k)) * 
     2   dphi*dz(k)
     +         +
     3  (0.5*(rhonew(i,j+1,k)+rhonew(i,j,k))*vnew(i,j,k) - 
     3   0.5*(rhonew(i,j,k)+rhonew(i,j-1,k))*vnew(i,j-1,k)) * 
     3   dr(i)*dz(k)
     +         +
     4  (0.5*(rhonew(i,j,k+1)+rhonew(i,j,k))*wnew(i,j,k) - 
     4   0.5*(rhonew(i,j,k)+rhonew(i,j,k-1))*wnew(i,j,k-1)) *
     4   rp(i)*dphi*dr(i)

               divbar = divbar + diverg
               diverg = ABS(diverg)
               divmax = MAX( divmax , diverg )


c               if(diverg .gt. 1e-8)then
c                  print*,i,j,k,diverg
c               end if


               
            END DO
         END DO
      END DO

      WRITE(6,100) divbar,divmax
100   FORMAT('Mass loss/gain : Tot = ',e13.6,
     +                      '  Max = ',e13.6)

      RETURN
      END

       function pimach(xxx)
      real xxx
       pimach = 4.*atan(xxx)
       end
      SUBROUTINE BVRADB2 (MP,IDO,L1,CC,CH,MDIMC,WA1)
      DIMENSION  CC(MDIMC,IDO,2,L1)    ,CH(MDIMC,IDO,L1,2),
     1                WA1(IDO)
      DO 101 K=1,L1
          DO 1001 M=1,MP
         CH(M,1,K,1) = CC(M,1,1,K)+CC(M,IDO,2,K)
         CH(M,1,K,2) = CC(M,1,1,K)-CC(M,IDO,2,K)
 1001     CONTINUE
  101 CONTINUE
      IF (IDO-2) 107,105,102
  102 IDP2 = IDO+2
      DO 104 K=1,L1
         DO 103 I=3,IDO,2
            IC = IDP2-I
               DO 1002 M=1,MP
            CH(M,I-1,K,1) = CC(M,I-1,1,K)+CC(M,IC-1,2,K)
            CH(M,I,K,1) = CC(M,I,1,K)-CC(M,IC,2,K)
            CH(M,I-1,K,2) = WA1(I-2)*(CC(M,I-1,1,K)-CC(M,IC-1,2,K))
     1      -WA1(I-1)*(CC(M,I,1,K)+CC(M,IC,2,K))
            CH(M,I,K,2) = WA1(I-2)*(CC(M,I,1,K)+CC(M,IC,2,K))+WA1(I-1)
     1      *(CC(M,I-1,1,K)-CC(M,IC-1,2,K))
 1002          CONTINUE
  103    CONTINUE
  104 CONTINUE
      IF (MOD(IDO,2) .EQ. 1) RETURN
  105 DO 106 K=1,L1
          DO 1003 M=1,MP
         CH(M,IDO,K,1) = CC(M,IDO,1,K)+CC(M,IDO,1,K)
         CH(M,IDO,K,2) = -(CC(M,1,2,K)+CC(M,1,2,K))
 1003     CONTINUE
  106 CONTINUE
  107 RETURN
      END
      SUBROUTINE BVRADB3 (MP,IDO,L1,CC,CH,MDIMC,WA1,WA2)
      DIMENSION  CC(MDIMC,IDO,3,L1)    ,CH(MDIMC,IDO,L1,3),
     1                WA1(IDO)   ,WA2(IDO)
      ARG=2.*PIMACH(1.0)/3.
      TAUR=COS(ARG)
      TAUI=SIN(ARG)
      DO 101 K=1,L1
          DO 1001 M=1,MP
         CH(M,1,K,1) = CC(M,1,1,K)+2.*CC(M,IDO,2,K)
         CH(M,1,K,2) = CC(M,1,1,K)+(2.*TAUR)*CC(M,IDO,2,K)
     1   -(2.*TAUI)*CC(M,1,3,K)
         CH(M,1,K,3) = CC(M,1,1,K)+(2.*TAUR)*CC(M,IDO,2,K)
     1   +2.*TAUI*CC(M,1,3,K)
 1001     CONTINUE
  101 CONTINUE
      IF (IDO .EQ. 1) RETURN
      IDP2 = IDO+2
      DO 103 K=1,L1
         DO 102 I=3,IDO,2
            IC = IDP2-I
               DO 1002 M=1,MP
            CH(M,I-1,K,1) = CC(M,I-1,1,K)+(CC(M,I-1,3,K)+CC(M,IC-1,2,K))
            CH(M,I,K,1) = CC(M,I,1,K)+(CC(M,I,3,K)-CC(M,IC,2,K))
            CH(M,I-1,K,2) = WA1(I-2)*
     1 ((CC(M,I-1,1,K)+TAUR*(CC(M,I-1,3,K)+CC(M,IC-1,2,K)))-
     * (TAUI*(CC(M,I,3,K)+CC(M,IC,2,K))))
     2                   -WA1(I-1)*
     3 ((CC(M,I,1,K)+TAUR*(CC(M,I,3,K)-CC(M,IC,2,K)))+
     * (TAUI*(CC(M,I-1,3,K)-CC(M,IC-1,2,K))))
            CH(M,I,K,2) = WA1(I-2)*
     4 ((CC(M,I,1,K)+TAUR*(CC(M,I,3,K)-CC(M,IC,2,K)))+
     8 (TAUI*(CC(M,I-1,3,K)-CC(M,IC-1,2,K))))
     5                  +WA1(I-1)*
     6 ((CC(M,I-1,1,K)+TAUR*(CC(M,I-1,3,K)+CC(M,IC-1,2,K)))-
     8 (TAUI*(CC(M,I,3,K)+CC(M,IC,2,K))))
              CH(M,I-1,K,3) = WA2(I-2)*
     7 ((CC(M,I-1,1,K)+TAUR*(CC(M,I-1,3,K)+CC(M,IC-1,2,K)))+
     8 (TAUI*(CC(M,I,3,K)+CC(M,IC,2,K))))
     8                      -WA2(I-1)*
     9 ((CC(M,I,1,K)+TAUR*(CC(M,I,3,K)-CC(M,IC,2,K)))-
     8 (TAUI*(CC(M,I-1,3,K)-CC(M,IC-1,2,K))))
            CH(M,I,K,3) = WA2(I-2)*
     1 ((CC(M,I,1,K)+TAUR*(CC(M,I,3,K)-CC(M,IC,2,K)))-
     8 (TAUI*(CC(M,I-1,3,K)-CC(M,IC-1,2,K))))
     2                 +WA2(I-1)*
     3 ((CC(M,I-1,1,K)+TAUR*(CC(M,I-1,3,K)+CC(M,IC-1,2,K)))+
     8 (TAUI*(CC(M,I,3,K)+CC(M,IC,2,K))))
 1002          CONTINUE
  102    CONTINUE
  103 CONTINUE
      RETURN
      END
      SUBROUTINE BVRADB4 (MP,IDO,L1,CC,CH,MDIMC,WA1,WA2,WA3)
      DIMENSION  CC(MDIMC,IDO,4,L1)  ,CH(MDIMC,IDO,L1,4)    ,
     1                WA1(IDO)  ,WA2(IDO)  ,WA3(IDO)
      SQRT2=SQRT(2.)
      DO 101 K=1,L1
          DO 1001 M=1,MP
         CH(M,1,K,3) = (CC(M,1,1,K)+CC(M,IDO,4,K))
     1   -(CC(M,IDO,2,K)+CC(M,IDO,2,K))
         CH(M,1,K,1) = (CC(M,1,1,K)+CC(M,IDO,4,K))
     1   +(CC(M,IDO,2,K)+CC(M,IDO,2,K))
         CH(M,1,K,4) = (CC(M,1,1,K)-CC(M,IDO,4,K))
     1   +(CC(M,1,3,K)+CC(M,1,3,K))
         CH(M,1,K,2) = (CC(M,1,1,K)-CC(M,IDO,4,K))
     1   -(CC(M,1,3,K)+CC(M,1,3,K))
 1001     CONTINUE
  101 CONTINUE
      IF (IDO-2) 107,105,102
  102 IDP2 = IDO+2
      DO 104 K=1,L1
         DO 103 I=3,IDO,2
            IC = IDP2-I
               DO 1002 M=1,MP
            CH(M,I-1,K,1) = (CC(M,I-1,1,K)+CC(M,IC-1,4,K))
     1      +(CC(M,I-1,3,K)+CC(M,IC-1,2,K))
            CH(M,I,K,1) = (CC(M,I,1,K)-CC(M,IC,4,K))
     1      +(CC(M,I,3,K)-CC(M,IC,2,K))
            CH(M,I-1,K,2)=WA1(I-2)*((CC(M,I-1,1,K)-CC(M,IC-1,4,K))
     1      -(CC(M,I,3,K)+CC(M,IC,2,K)))-WA1(I-1)
     1      *((CC(M,I,1,K)+CC(M,IC,4,K))+(CC(M,I-1,3,K)-CC(M,IC-1,2,K)))
            CH(M,I,K,2)=WA1(I-2)*((CC(M,I,1,K)+CC(M,IC,4,K))
     1      +(CC(M,I-1,3,K)-CC(M,IC-1,2,K)))+WA1(I-1)
     1      *((CC(M,I-1,1,K)-CC(M,IC-1,4,K))-(CC(M,I,3,K)+CC(M,IC,2,K)))
            CH(M,I-1,K,3)=WA2(I-2)*((CC(M,I-1,1,K)+CC(M,IC-1,4,K))
     1      -(CC(M,I-1,3,K)+CC(M,IC-1,2,K)))-WA2(I-1)
     1      *((CC(M,I,1,K)-CC(M,IC,4,K))-(CC(M,I,3,K)-CC(M,IC,2,K)))
            CH(M,I,K,3)=WA2(I-2)*((CC(M,I,1,K)-CC(M,IC,4,K))
     1      -(CC(M,I,3,K)-CC(M,IC,2,K)))+WA2(I-1)
     1      *((CC(M,I-1,1,K)+CC(M,IC-1,4,K))-(CC(M,I-1,3,K)
     1      +CC(M,IC-1,2,K)))
            CH(M,I-1,K,4)=WA3(I-2)*((CC(M,I-1,1,K)-CC(M,IC-1,4,K))
     1      +(CC(M,I,3,K)+CC(M,IC,2,K)))-WA3(I-1)
     1     *((CC(M,I,1,K)+CC(M,IC,4,K))-(CC(M,I-1,3,K)-CC(M,IC-1,2,K)))
            CH(M,I,K,4)=WA3(I-2)*((CC(M,I,1,K)+CC(M,IC,4,K))
     1      -(CC(M,I-1,3,K)-CC(M,IC-1,2,K)))+WA3(I-1)
     1      *((CC(M,I-1,1,K)-CC(M,IC-1,4,K))+(CC(M,I,3,K)+CC(M,IC,2,K)))
 1002          CONTINUE
  103    CONTINUE
  104 CONTINUE
      IF (MOD(IDO,2) .EQ. 1) RETURN
  105 CONTINUE
      DO 106 K=1,L1
               DO 1003 M=1,MP
         CH(M,IDO,K,1) = (CC(M,IDO,1,K)+CC(M,IDO,3,K))
     1   +(CC(M,IDO,1,K)+CC(M,IDO,3,K))
         CH(M,IDO,K,2) = SQRT2*((CC(M,IDO,1,K)-CC(M,IDO,3,K))
     1   -(CC(M,1,2,K)+CC(M,1,4,K)))
         CH(M,IDO,K,3) = (CC(M,1,4,K)-CC(M,1,2,K))
     1   +(CC(M,1,4,K)-CC(M,1,2,K))
         CH(M,IDO,K,4) = -SQRT2*((CC(M,IDO,1,K)-CC(M,IDO,3,K))
     1   +(CC(M,1,2,K)+CC(M,1,4,K)))
 1003          CONTINUE
  106 CONTINUE
  107 RETURN
      END
      SUBROUTINE BVRADB5 (MP,IDO,L1,CC,CH,MDIMC,WA1,WA2,WA3,WA4)
      DIMENSION  CC(MDIMC,IDO,5,L1)    ,CH(MDIMC,IDO,L1,5),
     1             WA1(IDO)     ,WA2(IDO)     ,WA3(IDO)     ,WA4(IDO)
      ARG=2.*PIMACH(1.0)/5.
      TR11=COS(ARG)
      TI11=SIN(ARG)
      TR12=COS(2.*ARG)
      TI12=SIN(2.*ARG)
      DO 101 K=1,L1
      DO 1001 M=1,MP
         CH(M,1,K,1) = CC(M,1,1,K)+2.*CC(M,IDO,2,K)+2.*CC(M,IDO,4,K)
         CH(M,1,K,2) = (CC(M,1,1,K)+TR11*2.*CC(M,IDO,2,K)
     1   +TR12*2.*CC(M,IDO,4,K))-(TI11*2.*CC(M,1,3,K)
     1   +TI12*2.*CC(M,1,5,K))
         CH(M,1,K,3) = (CC(M,1,1,K)+TR12*2.*CC(M,IDO,2,K)
     1   +TR11*2.*CC(M,IDO,4,K))-(TI12*2.*CC(M,1,3,K)
     1   -TI11*2.*CC(M,1,5,K))
         CH(M,1,K,4) = (CC(M,1,1,K)+TR12*2.*CC(M,IDO,2,K)
     1   +TR11*2.*CC(M,IDO,4,K))+(TI12*2.*CC(M,1,3,K)
     1   -TI11*2.*CC(M,1,5,K))
         CH(M,1,K,5) = (CC(M,1,1,K)+TR11*2.*CC(M,IDO,2,K)
     1   +TR12*2.*CC(M,IDO,4,K))+(TI11*2.*CC(M,1,3,K)
     1   +TI12*2.*CC(M,1,5,K))
 1001          CONTINUE
  101 CONTINUE
      IF (IDO .EQ. 1) RETURN
      IDP2 = IDO+2
      DO 103 K=1,L1
         DO 102 I=3,IDO,2
            IC = IDP2-I
      DO 1002 M=1,MP
            CH(M,I-1,K,1) = CC(M,I-1,1,K)+(CC(M,I-1,3,K)+CC(M,IC-1,2,K))
     1      +(CC(M,I-1,5,K)+CC(M,IC-1,4,K))
            CH(M,I,K,1) = CC(M,I,1,K)+(CC(M,I,3,K)-CC(M,IC,2,K))
     1      +(CC(M,I,5,K)-CC(M,IC,4,K))
            CH(M,I-1,K,2) = WA1(I-2)*((CC(M,I-1,1,K)+TR11*
     1      (CC(M,I-1,3,K)+CC(M,IC-1,2,K))+TR12
     1      *(CC(M,I-1,5,K)+CC(M,IC-1,4,K)))-(TI11*(CC(M,I,3,K)
     1      +CC(M,IC,2,K))+TI12*(CC(M,I,5,K)+CC(M,IC,4,K))))
     1      -WA1(I-1)*((CC(M,I,1,K)+TR11*(CC(M,I,3,K)-CC(M,IC,2,K))
     1      +TR12*(CC(M,I,5,K)-CC(M,IC,4,K)))+(TI11*(CC(M,I-1,3,K)
     1      -CC(M,IC-1,2,K))+TI12*(CC(M,I-1,5,K)-CC(M,IC-1,4,K))))
            CH(M,I,K,2) = WA1(I-2)*((CC(M,I,1,K)+TR11*(CC(M,I,3,K)
     1      -CC(M,IC,2,K))+TR12*(CC(M,I,5,K)-CC(M,IC,4,K)))
     1      +(TI11*(CC(M,I-1,3,K)-CC(M,IC-1,2,K))+TI12
     1      *(CC(M,I-1,5,K)-CC(M,IC-1,4,K))))+WA1(I-1)
     1      *((CC(M,I-1,1,K)+TR11*(CC(M,I-1,3,K)
     1      +CC(M,IC-1,2,K))+TR12*(CC(M,I-1,5,K)+CC(M,IC-1,4,K)))
     1      -(TI11*(CC(M,I,3,K)+CC(M,IC,2,K))+TI12
     1      *(CC(M,I,5,K)+CC(M,IC,4,K))))
            CH(M,I-1,K,3) = WA2(I-2)
     1      *((CC(M,I-1,1,K)+TR12*(CC(M,I-1,3,K)+CC(M,IC-1,2,K))
     1      +TR11*(CC(M,I-1,5,K)+CC(M,IC-1,4,K)))-(TI12*(CC(M,I,3,K)
     1      +CC(M,IC,2,K))-TI11*(CC(M,I,5,K)+CC(M,IC,4,K))))
     1     -WA2(I-1)
     1     *((CC(M,I,1,K)+TR12*(CC(M,I,3,K)-
     1      CC(M,IC,2,K))+TR11*(CC(M,I,5,K)-CC(M,IC,4,K)))
     1      +(TI12*(CC(M,I-1,3,K)-CC(M,IC-1,2,K))-TI11
     1      *(CC(M,I-1,5,K)-CC(M,IC-1,4,K))))
            CH(M,I,K,3) = WA2(I-2)
     1     *((CC(M,I,1,K)+TR12*(CC(M,I,3,K)-
     1      CC(M,IC,2,K))+TR11*(CC(M,I,5,K)-CC(M,IC,4,K)))
     1      +(TI12*(CC(M,I-1,3,K)-CC(M,IC-1,2,K))-TI11
     1      *(CC(M,I-1,5,K)-CC(M,IC-1,4,K))))
     1      +WA2(I-1)
     1      *((CC(M,I-1,1,K)+TR12*(CC(M,I-1,3,K)+CC(M,IC-1,2,K))
     1      +TR11*(CC(M,I-1,5,K)+CC(M,IC-1,4,K)))-(TI12*(CC(M,I,3,K)
     1      +CC(M,IC,2,K))-TI11*(CC(M,I,5,K)+CC(M,IC,4,K))))
            CH(M,I-1,K,4) = WA3(I-2)
     1      *((CC(M,I-1,1,K)+TR12*(CC(M,I-1,3,K)+CC(M,IC-1,2,K))
     1      +TR11*(CC(M,I-1,5,K)+CC(M,IC-1,4,K)))+(TI12*(CC(M,I,3,K)
     1      +CC(M,IC,2,K))-TI11*(CC(M,I,5,K)+CC(M,IC,4,K))))
     1      -WA3(I-1)
     1     *((CC(M,I,1,K)+TR12*(CC(M,I,3,K)-
     1      CC(M,IC,2,K))+TR11*(CC(M,I,5,K)-CC(M,IC,4,K)))
     1      -(TI12*(CC(M,I-1,3,K)-CC(M,IC-1,2,K))-TI11
     1      *(CC(M,I-1,5,K)-CC(M,IC-1,4,K))))
            CH(M,I,K,4) = WA3(I-2)
     1     *((CC(M,I,1,K)+TR12*(CC(M,I,3,K)-
     1      CC(M,IC,2,K))+TR11*(CC(M,I,5,K)-CC(M,IC,4,K)))
     1      -(TI12*(CC(M,I-1,3,K)-CC(M,IC-1,2,K))-TI11
     1      *(CC(M,I-1,5,K)-CC(M,IC-1,4,K))))
     1      +WA3(I-1)
     1      *((CC(M,I-1,1,K)+TR12*(CC(M,I-1,3,K)+CC(M,IC-1,2,K))
     1      +TR11*(CC(M,I-1,5,K)+CC(M,IC-1,4,K)))+(TI12*(CC(M,I,3,K)
     1      +CC(M,IC,2,K))-TI11*(CC(M,I,5,K)+CC(M,IC,4,K))))
            CH(M,I-1,K,5) = WA4(I-2)
     1      *((CC(M,I-1,1,K)+TR11*(CC(M,I-1,3,K)+CC(M,IC-1,2,K))
     1      +TR12*(CC(M,I-1,5,K)+CC(M,IC-1,4,K)))+(TI11*(CC(M,I,3,K)
     1      +CC(M,IC,2,K))+TI12*(CC(M,I,5,K)+CC(M,IC,4,K))))
     1      -WA4(I-1)
     1      *((CC(M,I,1,K)+TR11*(CC(M,I,3,K)-CC(M,IC,2,K))
     1      +TR12*(CC(M,I,5,K)-CC(M,IC,4,K)))-(TI11*(CC(M,I-1,3,K)
     1      -CC(M,IC-1,2,K))+TI12*(CC(M,I-1,5,K)-CC(M,IC-1,4,K))))
            CH(M,I,K,5) = WA4(I-2)
     1      *((CC(M,I,1,K)+TR11*(CC(M,I,3,K)-CC(M,IC,2,K))
     1      +TR12*(CC(M,I,5,K)-CC(M,IC,4,K)))-(TI11*(CC(M,I-1,3,K)
     1      -CC(M,IC-1,2,K))+TI12*(CC(M,I-1,5,K)-CC(M,IC-1,4,K))))
     1      +WA4(I-1)
     1      *((CC(M,I-1,1,K)+TR11*(CC(M,I-1,3,K)+CC(M,IC-1,2,K))
     1      +TR12*(CC(M,I-1,5,K)+CC(M,IC-1,4,K)))+(TI11*(CC(M,I,3,K)
     1      +CC(M,IC,2,K))+TI12*(CC(M,I,5,K)+CC(M,IC,4,K))))
 1002          CONTINUE
  102    CONTINUE
  103 CONTINUE
      RETURN
      END
      SUBROUTINE BVRADBG (MP,IDO,IP,L1,IDL1,CC,C1,C2,CH,CH2,
     *                 MDIMC,WA)
      DIMENSION    CH(MDIMC,IDO,L1,IP)    ,CC(MDIMC,IDO,IP,L1) ,
     1           C1(MDIMC,IDO,L1,IP)     ,C2(MDIMC,IDL1,IP),
     2                CH2(MDIMC,IDL1,IP)       ,WA(IDO)
      TPI=2.*PIMACH(1.0)
      ARG = TPI/FLOAT(IP)
      DCP = COS(ARG)
      DSP = SIN(ARG)
      IDP2 = IDO+2
      NBD = (IDO-1)/2
      IPP2 = IP+2
      IPPH = (IP+1)/2
      IF (IDO .LT. L1) GO TO 103
      DO 102 K=1,L1
         DO 101 I=1,IDO
            DO 1001 M=1,MP
            CH(M,I,K,1) = CC(M,I,1,K)
 1001       CONTINUE
  101    CONTINUE
  102 CONTINUE
      GO TO 106
  103 DO 105 I=1,IDO
         DO 104 K=1,L1
            DO 1004 M=1,MP
            CH(M,I,K,1) = CC(M,I,1,K)
 1004       CONTINUE
  104    CONTINUE
  105 CONTINUE
  106 DO 108 J=2,IPPH
         JC = IPP2-J
         J2 = J+J
         DO 107 K=1,L1
            DO 1007 M=1,MP
            CH(M,1,K,J) = CC(M,IDO,J2-2,K)+CC(M,IDO,J2-2,K)
            CH(M,1,K,JC) = CC(M,1,J2-1,K)+CC(M,1,J2-1,K)
 1007       CONTINUE
  107    CONTINUE
  108 CONTINUE
      IF (IDO .EQ. 1) GO TO 116
      IF (NBD .LT. L1) GO TO 112
      DO 111 J=2,IPPH
         JC = IPP2-J
         DO 110 K=1,L1
            DO 109 I=3,IDO,2
               IC = IDP2-I
               DO 1009 M=1,MP
               CH(M,I-1,K,J) = CC(M,I-1,2*J-1,K)+CC(M,IC-1,2*J-2,K)
               CH(M,I-1,K,JC) = CC(M,I-1,2*J-1,K)-CC(M,IC-1,2*J-2,K)
               CH(M,I,K,J) = CC(M,I,2*J-1,K)-CC(M,IC,2*J-2,K)
               CH(M,I,K,JC) = CC(M,I,2*J-1,K)+CC(M,IC,2*J-2,K)
 1009          CONTINUE
  109       CONTINUE
  110    CONTINUE
  111 CONTINUE
      GO TO 116
  112 DO 115 J=2,IPPH
         JC = IPP2-J
         DO 114 I=3,IDO,2
            IC = IDP2-I
            DO 113 K=1,L1
               DO 1013 M=1,MP
               CH(M,I-1,K,J) = CC(M,I-1,2*J-1,K)+CC(M,IC-1,2*J-2,K)
               CH(M,I-1,K,JC) = CC(M,I-1,2*J-1,K)-CC(M,IC-1,2*J-2,K)
               CH(M,I,K,J) = CC(M,I,2*J-1,K)-CC(M,IC,2*J-2,K)
               CH(M,I,K,JC) = CC(M,I,2*J-1,K)+CC(M,IC,2*J-2,K)
 1013          CONTINUE
  113       CONTINUE
  114    CONTINUE
  115 CONTINUE
  116 AR1 = 1.
      AI1 = 0.
      DO 120 L=2,IPPH
         LC = IPP2-L
         AR1H = DCP*AR1-DSP*AI1
         AI1 = DCP*AI1+DSP*AR1
         AR1 = AR1H
         DO 117 IK=1,IDL1
            DO 1017 M=1,MP
            C2(M,IK,L) = CH2(M,IK,1)+AR1*CH2(M,IK,2)
            C2(M,IK,LC) = AI1*CH2(M,IK,IP)
 1017       CONTINUE
  117    CONTINUE
         DC2 = AR1
         DS2 = AI1
         AR2 = AR1
         AI2 = AI1
         DO 119 J=3,IPPH
            JC = IPP2-J
            AR2H = DC2*AR2-DS2*AI2
            AI2 = DC2*AI2+DS2*AR2
            AR2 = AR2H
            DO 118 IK=1,IDL1
               DO 1018 M=1,MP
               C2(M,IK,L) = C2(M,IK,L)+AR2*CH2(M,IK,J)
               C2(M,IK,LC) = C2(M,IK,LC)+AI2*CH2(M,IK,JC)
 1018          CONTINUE
  118       CONTINUE
  119    CONTINUE
  120 CONTINUE
      DO 122 J=2,IPPH
         DO 121 IK=1,IDL1
            DO 1021 M=1,MP
            CH2(M,IK,1) = CH2(M,IK,1)+CH2(M,IK,J)
 1021       CONTINUE
  121    CONTINUE
  122 CONTINUE
      DO 124 J=2,IPPH
         JC = IPP2-J
         DO 123 K=1,L1
            DO 1023 M=1,MP
            CH(M,1,K,J) = C1(M,1,K,J)-C1(M,1,K,JC)
            CH(M,1,K,JC) = C1(M,1,K,J)+C1(M,1,K,JC)
 1023       CONTINUE
  123    CONTINUE
  124 CONTINUE
      IF (IDO .EQ. 1) GO TO 132
      IF (NBD .LT. L1) GO TO 128
      DO 127 J=2,IPPH
         JC = IPP2-J
         DO 126 K=1,L1
            DO 125 I=3,IDO,2
               DO 1025 M=1,MP
               CH(M,I-1,K,J) = C1(M,I-1,K,J)-C1(M,I,K,JC)
               CH(M,I-1,K,JC) = C1(M,I-1,K,J)+C1(M,I,K,JC)
               CH(M,I,K,J) = C1(M,I,K,J)+C1(M,I-1,K,JC)
               CH(M,I,K,JC) = C1(M,I,K,J)-C1(M,I-1,K,JC)
 1025          CONTINUE
  125       CONTINUE
  126    CONTINUE
  127 CONTINUE
      GO TO 132
  128 DO 131 J=2,IPPH
         JC = IPP2-J
         DO 130 I=3,IDO,2
            DO 129 K=1,L1
               DO 1029 M=1,MP
               CH(M,I-1,K,J) = C1(M,I-1,K,J)-C1(M,I,K,JC)
               CH(M,I-1,K,JC) = C1(M,I-1,K,J)+C1(M,I,K,JC)
               CH(M,I,K,J) = C1(M,I,K,J)+C1(M,I-1,K,JC)
               CH(M,I,K,JC) = C1(M,I,K,J)-C1(M,I-1,K,JC)
 1029          CONTINUE
  129       CONTINUE
  130    CONTINUE
  131 CONTINUE
  132 CONTINUE
      IF (IDO .EQ. 1) RETURN
      DO 133 IK=1,IDL1
         DO 1033 M=1,MP
         C2(M,IK,1) = CH2(M,IK,1)
 1033    CONTINUE
  133 CONTINUE
      DO 135 J=2,IP
         DO 134 K=1,L1
            DO 1034 M=1,MP
            C1(M,1,K,J) = CH(M,1,K,J)
 1034       CONTINUE
  134    CONTINUE
  135 CONTINUE
      IF (NBD .GT. L1) GO TO 139
      IS = -IDO
      DO 138 J=2,IP
         IS = IS+IDO
         IDIJ = IS
         DO 137 I=3,IDO,2
            IDIJ = IDIJ+2
            DO 136 K=1,L1
               DO 1036 M=1,MP
               C1(M,I-1,K,J) = WA(IDIJ-1)*CH(M,I-1,K,J)-WA(IDIJ)*
     1          CH(M,I,K,J)
               C1(M,I,K,J) = WA(IDIJ-1)*CH(M,I,K,J)+WA(IDIJ)*
     1          CH(M,I-1,K,J)
 1036          CONTINUE
  136       CONTINUE
  137    CONTINUE
  138 CONTINUE
      GO TO 143
  139 IS = -IDO
      DO 142 J=2,IP
         IS = IS+IDO
         DO 141 K=1,L1
            IDIJ = IS
            DO 140 I=3,IDO,2
               IDIJ = IDIJ+2
               DO 1040 M=1,MP
               C1(M,I-1,K,J) = WA(IDIJ-1)*CH(M,I-1,K,J)-WA(IDIJ)*
     1          CH(M,I,K,J)
               C1(M,I,K,J) = WA(IDIJ-1)*CH(M,I,K,J)+WA(IDIJ)*
     1          CH(M,I-1,K,J)
 1040          CONTINUE
  140       CONTINUE
  141    CONTINUE
  142 CONTINUE
  143 RETURN
      END
      SUBROUTINE BVRADF2 (MP,IDO,L1,CC,CH,MDIMC,WA1)
      DIMENSION   CH(MDIMC,IDO,2,L1)  ,CC(MDIMC,IDO,L1,2)     ,
     1                WA1(IDO)
      DO 101 K=1,L1
         DO 1001 M=1,MP
         CH(M,1,1,K) = CC(M,1,K,1)+CC(M,1,K,2)
         CH(M,IDO,2,K) = CC(M,1,K,1)-CC(M,1,K,2)
 1001    CONTINUE
  101 CONTINUE
      IF (IDO-2) 107,105,102
  102 IDP2 = IDO+2
      DO 104 K=1,L1
         DO 103 I=3,IDO,2
            IC = IDP2-I
            DO 1003 M=1,MP
            CH(M,I,1,K) = CC(M,I,K,1)+(WA1(I-2)*CC(M,I,K,2)-
     1       WA1(I-1)*CC(M,I-1,K,2))
            CH(M,IC,2,K) = (WA1(I-2)*CC(M,I,K,2)-WA1(I-1)*
     1       CC(M,I-1,K,2))-CC(M,I,K,1)
            CH(M,I-1,1,K) = CC(M,I-1,K,1)+(WA1(I-2)*CC(M,I-1,K,2)+
     1       WA1(I-1)*CC(M,I,K,2))
            CH(M,IC-1,2,K) = CC(M,I-1,K,1)-(WA1(I-2)*CC(M,I-1,K,2)+
     1       WA1(I-1)*CC(M,I,K,2))
 1003       CONTINUE
  103    CONTINUE
  104 CONTINUE
      IF (MOD(IDO,2) .EQ. 1) RETURN
  105 DO 106 K=1,L1
         DO 1006 M=1,MP
         CH(M,1,2,K) = -CC(M,IDO,K,2)
         CH(M,IDO,1,K) = CC(M,IDO,K,1)
 1006    CONTINUE
  106 CONTINUE
  107 RETURN
      END
      SUBROUTINE BVRADF3 (MP,IDO,L1,CC,CH,MDIMC,WA1,WA2)
      DIMENSION   CH(MDIMC,IDO,3,L1)  ,CC(MDIMC,IDO,L1,3)     ,
     1                WA1(IDO)     ,WA2(IDO)
      ARG=2.*PIMACH(1.0)/3.
      TAUR=COS(ARG)
      TAUI=SIN(ARG)
      DO 101 K=1,L1
         DO 1001 M=1,MP
         CH(M,1,1,K) = CC(M,1,K,1)+(CC(M,1,K,2)+CC(M,1,K,3))
         CH(M,1,3,K) = TAUI*(CC(M,1,K,3)-CC(M,1,K,2))
         CH(M,IDO,2,K) = CC(M,1,K,1)+TAUR*
     1      (CC(M,1,K,2)+CC(M,1,K,3))
 1001    CONTINUE
  101 CONTINUE
      IF (IDO .EQ. 1) RETURN
      IDP2 = IDO+2
      DO 103 K=1,L1
         DO 102 I=3,IDO,2
            IC = IDP2-I
            DO 1002 M=1,MP
            CH(M,I-1,1,K) = CC(M,I-1,K,1)+((WA1(I-2)*CC(M,I-1,K,2)+
     1       WA1(I-1)*CC(M,I,K,2))+(WA2(I-2)*CC(M,I-1,K,3)+WA2(I-1)*
     1       CC(M,I,K,3)))
            CH(M,I,1,K) = CC(M,I,K,1)+((WA1(I-2)*CC(M,I,K,2)-WA1(I-1)*
     1       CC(M,I-1,K,2))+(WA2(I-2)*CC(M,I,K,3)-WA2(I-1)*
     1       CC(M,I-1,K,3)))
            CH(M,I-1,3,K) = (CC(M,I-1,K,1)+TAUR*((WA1(I-2)*
     1       CC(M,I-1,K,2)+WA1(I-1)*CC(M,I,K,2))+(WA2(I-2)*
     1       CC(M,I-1,K,3)+WA2(I-1)*CC(M,I,K,3))))+(TAUI*((WA1(I-2)*
     1       CC(M,I,K,2)-WA1(I-1)*CC(M,I-1,K,2))-(WA2(I-2)*
     1       CC(M,I,K,3)-WA2(I-1)*CC(M,I-1,K,3))))
            CH(M,IC-1,2,K) = (CC(M,I-1,K,1)+TAUR*((WA1(I-2)*
     1       CC(M,I-1,K,2)+WA1(I-1)*CC(M,I,K,2))+(WA2(I-2)*
     1       CC(M,I-1,K,3)+WA2(I-1)*CC(M,I,K,3))))-(TAUI*((WA1(I-2)*
     1       CC(M,I,K,2)-WA1(I-1)*CC(M,I-1,K,2))-(WA2(I-2)*
     1       CC(M,I,K,3)-WA2(I-1)*CC(M,I-1,K,3))))
            CH(M,I,3,K) = (CC(M,I,K,1)+TAUR*((WA1(I-2)*CC(M,I,K,2)-
     1       WA1(I-1)*CC(M,I-1,K,2))+(WA2(I-2)*CC(M,I,K,3)-WA2(I-1)*
     1       CC(M,I-1,K,3))))+(TAUI*((WA2(I-2)*CC(M,I-1,K,3)+WA2(I-1)*
     1       CC(M,I,K,3))-(WA1(I-2)*CC(M,I-1,K,2)+WA1(I-1)*
     1       CC(M,I,K,2))))
            CH(M,IC,2,K) = (TAUI*((WA2(I-2)*CC(M,I-1,K,3)+WA2(I-1)*
     1       CC(M,I,K,3))-(WA1(I-2)*CC(M,I-1,K,2)+WA1(I-1)*
     1       CC(M,I,K,2))))-(CC(M,I,K,1)+TAUR*((WA1(I-2)*CC(M,I,K,2)-
     1       WA1(I-1)*CC(M,I-1,K,2))+(WA2(I-2)*CC(M,I,K,3)-WA2(I-1)*
     1       CC(M,I-1,K,3))))
 1002       CONTINUE
  102    CONTINUE
  103 CONTINUE
      RETURN
      END
      SUBROUTINE BVRADF4 (MP,IDO,L1,CC,CH,MDIMC,WA1,WA2,WA3)
      DIMENSION    CC(MDIMC,IDO,L1,4)   ,CH(MDIMC,IDO,4,L1)     ,
     1                WA1(IDO)     ,WA2(IDO)     ,WA3(IDO)
      HSQT2=SQRT(2.)/2.
      DO 101 K=1,L1
         DO 1001 M=1,MP
         CH(M,1,1,K) = (CC(M,1,K,2)+CC(M,1,K,4))
     1      +(CC(M,1,K,1)+CC(M,1,K,3))
         CH(M,IDO,4,K) = (CC(M,1,K,1)+CC(M,1,K,3))
     1      -(CC(M,1,K,2)+CC(M,1,K,4))
         CH(M,IDO,2,K) = CC(M,1,K,1)-CC(M,1,K,3)
         CH(M,1,3,K) = CC(M,1,K,4)-CC(M,1,K,2)
 1001    CONTINUE
  101 CONTINUE
      IF (IDO-2) 107,105,102
  102 IDP2 = IDO+2
      DO 104 K=1,L1
         DO 103 I=3,IDO,2
            IC = IDP2-I
            DO 1003 M=1,MP
            CH(M,I-1,1,K) = ((WA1(I-2)*CC(M,I-1,K,2)+WA1(I-1)*
     1       CC(M,I,K,2))+(WA3(I-2)*CC(M,I-1,K,4)+WA3(I-1)*
     1       CC(M,I,K,4)))+(CC(M,I-1,K,1)+(WA2(I-2)*CC(M,I-1,K,3)+
     1       WA2(I-1)*CC(M,I,K,3)))
            CH(M,IC-1,4,K) = (CC(M,I-1,K,1)+(WA2(I-2)*CC(M,I-1,K,3)+
     1       WA2(I-1)*CC(M,I,K,3)))-((WA1(I-2)*CC(M,I-1,K,2)+
     1       WA1(I-1)*CC(M,I,K,2))+(WA3(I-2)*CC(M,I-1,K,4)+
     1       WA3(I-1)*CC(M,I,K,4)))
            CH(M,I,1,K) = ((WA1(I-2)*CC(M,I,K,2)-WA1(I-1)*
     1       CC(M,I-1,K,2))+(WA3(I-2)*CC(M,I,K,4)-WA3(I-1)*
     1       CC(M,I-1,K,4)))+(CC(M,I,K,1)+(WA2(I-2)*CC(M,I,K,3)-
     1       WA2(I-1)*CC(M,I-1,K,3)))
            CH(M,IC,4,K) = ((WA1(I-2)*CC(M,I,K,2)-WA1(I-1)*
     1       CC(M,I-1,K,2))+(WA3(I-2)*CC(M,I,K,4)-WA3(I-1)*
     1       CC(M,I-1,K,4)))-(CC(M,I,K,1)+(WA2(I-2)*CC(M,I,K,3)-
     1       WA2(I-1)*CC(M,I-1,K,3)))
            CH(M,I-1,3,K) = ((WA1(I-2)*CC(M,I,K,2)-WA1(I-1)*
     1       CC(M,I-1,K,2))-(WA3(I-2)*CC(M,I,K,4)-WA3(I-1)*
     1       CC(M,I-1,K,4)))+(CC(M,I-1,K,1)-(WA2(I-2)*CC(M,I-1,K,3)+
     1       WA2(I-1)*CC(M,I,K,3)))
            CH(M,IC-1,2,K) = (CC(M,I-1,K,1)-(WA2(I-2)*CC(M,I-1,K,3)+
     1       WA2(I-1)*CC(M,I,K,3)))-((WA1(I-2)*CC(M,I,K,2)-WA1(I-1)*
     1       CC(M,I-1,K,2))-(WA3(I-2)*CC(M,I,K,4)-WA3(I-1)*
     1       CC(M,I-1,K,4)))
            CH(M,I,3,K) = ((WA3(I-2)*CC(M,I-1,K,4)+WA3(I-1)*
     1       CC(M,I,K,4))-(WA1(I-2)*CC(M,I-1,K,2)+WA1(I-1)*
     1       CC(M,I,K,2)))+(CC(M,I,K,1)-(WA2(I-2)*CC(M,I,K,3)-
     1       WA2(I-1)*CC(M,I-1,K,3)))
            CH(M,IC,2,K) = ((WA3(I-2)*CC(M,I-1,K,4)+WA3(I-1)*
     1       CC(M,I,K,4))-(WA1(I-2)*CC(M,I-1,K,2)+WA1(I-1)*
     1       CC(M,I,K,2)))-(CC(M,I,K,1)-(WA2(I-2)*CC(M,I,K,3)-WA2(I-1)*
     1       CC(M,I-1,K,3)))
 1003       CONTINUE
  103    CONTINUE
  104 CONTINUE
      IF (MOD(IDO,2) .EQ. 1) RETURN
  105 CONTINUE
      DO 106 K=1,L1
         DO 1006 M=1,MP
            CH(M,IDO,1,K) = (HSQT2*(CC(M,IDO,K,2)-CC(M,IDO,K,4)))+
     1       CC(M,IDO,K,1)
            CH(M,IDO,3,K) = CC(M,IDO,K,1)-(HSQT2*(CC(M,IDO,K,2)-
     1       CC(M,IDO,K,4)))
            CH(M,1,2,K) = (-HSQT2*(CC(M,IDO,K,2)+CC(M,IDO,K,4)))-
     1       CC(M,IDO,K,3)
            CH(M,1,4,K) = (-HSQT2*(CC(M,IDO,K,2)+CC(M,IDO,K,4)))+
     1       CC(M,IDO,K,3)
 1006    CONTINUE
  106 CONTINUE
  107 RETURN
      END
      SUBROUTINE BVRADF5 (MP,IDO,L1,CC,CH,MDIMC,WA1,WA2,WA3,WA4)
      DIMENSION  CC(MDIMC,IDO,L1,5)    ,CH(MDIMC,IDO,5,L1)     ,
     1           WA1(IDO)     ,WA2(IDO)     ,WA3(IDO)     ,WA4(IDO)
      ARG=2.*PIMACH(1.0)/5.
      TR11=COS(ARG)
      TI11=SIN(ARG)
      TR12=COS(2.*ARG)
      TI12=SIN(2.*ARG)
      DO 101 K=1,L1
         DO 1001 M=1,MP
         CH(M,1,1,K) = CC(M,1,K,1)+(CC(M,1,K,5)+CC(M,1,K,2))+
     1    (CC(M,1,K,4)+CC(M,1,K,3))
         CH(M,IDO,2,K) = CC(M,1,K,1)+TR11*(CC(M,1,K,5)+CC(M,1,K,2))+
     1    TR12*(CC(M,1,K,4)+CC(M,1,K,3))
         CH(M,1,3,K) = TI11*(CC(M,1,K,5)-CC(M,1,K,2))+TI12*
     1    (CC(M,1,K,4)-CC(M,1,K,3))
         CH(M,IDO,4,K) = CC(M,1,K,1)+TR12*(CC(M,1,K,5)+CC(M,1,K,2))+
     1    TR11*(CC(M,1,K,4)+CC(M,1,K,3))
         CH(M,1,5,K) = TI12*(CC(M,1,K,5)-CC(M,1,K,2))-TI11*
     1    (CC(M,1,K,4)-CC(M,1,K,3))
 1001    CONTINUE
  101 CONTINUE
      IF (IDO .EQ. 1) RETURN
      IDP2 = IDO+2
      DO 103 K=1,L1
         DO 102 I=3,IDO,2
            IC = IDP2-I
            DO 1002 M=1,MP
            CH(M,I-1,1,K) = CC(M,I-1,K,1)+((WA1(I-2)*CC(M,I-1,K,2)+
     1       WA1(I-1)*CC(M,I,K,2))+(WA4(I-2)*CC(M,I-1,K,5)+WA4(I-1)*
     1       CC(M,I,K,5)))+((WA2(I-2)*CC(M,I-1,K,3)+WA2(I-1)*
     1       CC(M,I,K,3))+(WA3(I-2)*CC(M,I-1,K,4)+WA3(I-1)*CC(M,I,K,4)))
            CH(M,I,1,K) = CC(M,I,K,1)+((WA1(I-2)*CC(M,I,K,2)-WA1(I-1)*
     1       CC(M,I-1,K,2))+(WA4(I-2)*CC(M,I,K,5)-WA4(I-1)*
     1       CC(M,I-1,K,5)))+((WA2(I-2)*CC(M,I,K,3)-WA2(I-1)*
     1       CC(M,I-1,K,3))+(WA3(I-2)*CC(M,I,K,4)-WA3(I-1)*
     1       CC(M,I-1,K,4)))
            CH(M,I-1,3,K) = CC(M,I-1,K,1)+TR11*
     1      ( WA1(I-2)*CC(M,I-1,K,2)+WA1(I-1)*CC(M,I,K,2)
     1       +WA4(I-2)*CC(M,I-1,K,5)+WA4(I-1)*CC(M,I,K,5))+TR12*
     1      ( WA2(I-2)*CC(M,I-1,K,3)+WA2(I-1)*CC(M,I,K,3)
     1       +WA3(I-2)*CC(M,I-1,K,4)+WA3(I-1)*CC(M,I,K,4))+TI11*
     1      ( WA1(I-2)*CC(M,I,K,2)-WA1(I-1)*CC(M,I-1,K,2)
     1       -(WA4(I-2)*CC(M,I,K,5)-WA4(I-1)*CC(M,I-1,K,5)))+TI12*
     1      ( WA2(I-2)*CC(M,I,K,3)-WA2(I-1)*CC(M,I-1,K,3)
     1       -(WA3(I-2)*CC(M,I,K,4)-WA3(I-1)*CC(M,I-1,K,4)))
            CH(M,IC-1,2,K) = CC(M,I-1,K,1)+TR11*
     1      ( WA1(I-2)*CC(M,I-1,K,2)+WA1(I-1)*CC(M,I,K,2)
     1       +WA4(I-2)*CC(M,I-1,K,5)+WA4(I-1)*CC(M,I,K,5))+TR12*
     1     ( WA2(I-2)*CC(M,I-1,K,3)+WA2(I-1)*CC(M,I,K,3)
     1      +WA3(I-2)*CC(M,I-1,K,4)+WA3(I-1)*CC(M,I,K,4))-(TI11*
     1      ( WA1(I-2)*CC(M,I,K,2)-WA1(I-1)*CC(M,I-1,K,2)
     1       -(WA4(I-2)*CC(M,I,K,5)-WA4(I-1)*CC(M,I-1,K,5)))+TI12*
     1      ( WA2(I-2)*CC(M,I,K,3)-WA2(I-1)*CC(M,I-1,K,3)
     1       -(WA3(I-2)*CC(M,I,K,4)-WA3(I-1)*CC(M,I-1,K,4))))
            CH(M,I,3,K) = (CC(M,I,K,1)+TR11*((WA1(I-2)*CC(M,I,K,2)-
     1       WA1(I-1)*CC(M,I-1,K,2))+(WA4(I-2)*CC(M,I,K,5)-WA4(I-1)*
     1       CC(M,I-1,K,5)))+TR12*((WA2(I-2)*CC(M,I,K,3)-WA2(I-1)*
     1       CC(M,I-1,K,3))+(WA3(I-2)*CC(M,I,K,4)-WA3(I-1)*
     1       CC(M,I-1,K,4))))+(TI11*((WA4(I-2)*CC(M,I-1,K,5)+
     1       WA4(I-1)*CC(M,I,K,5))-(WA1(I-2)*CC(M,I-1,K,2)+WA1(I-1)*
     1       CC(M,I,K,2)))+TI12*((WA3(I-2)*CC(M,I-1,K,4)+WA3(I-1)*
     1       CC(M,I,K,4))-(WA2(I-2)*CC(M,I-1,K,3)+WA2(I-1)*
     1       CC(M,I,K,3))))
            CH(M,IC,2,K) = (TI11*((WA4(I-2)*CC(M,I-1,K,5)+WA4(I-1)*
     1       CC(M,I,K,5))-(WA1(I-2)*CC(M,I-1,K,2)+WA1(I-1)*
     1       CC(M,I,K,2)))+TI12*((WA3(I-2)*CC(M,I-1,K,4)+WA3(I-1)*
     1       CC(M,I,K,4))-(WA2(I-2)*CC(M,I-1,K,3)+WA2(I-1)*
     1       CC(M,I,K,3))))-(CC(M,I,K,1)+TR11*((WA1(I-2)*CC(M,I,K,2)-
     1       WA1(I-1)*CC(M,I-1,K,2))+(WA4(I-2)*CC(M,I,K,5)-WA4(I-1)*
     1       CC(M,I-1,K,5)))+TR12*((WA2(I-2)*CC(M,I,K,3)-WA2(I-1)*
     1       CC(M,I-1,K,3))+(WA3(I-2)*CC(M,I,K,4)-WA3(I-1)*
     1       CC(M,I-1,K,4))))
            CH(M,I-1,5,K) = (CC(M,I-1,K,1)+TR12*((WA1(I-2)*
     1       CC(M,I-1,K,2)+WA1(I-1)*CC(M,I,K,2))+(WA4(I-2)*
     1       CC(M,I-1,K,5)+WA4(I-1)*CC(M,I,K,5)))+TR11*((WA2(I-2)*
     1       CC(M,I-1,K,3)+WA2(I-1)*CC(M,I,K,3))+(WA3(I-2)*
     1       CC(M,I-1,K,4)+WA3(I-1)*CC(M,I,K,4))))+(TI12*((WA1(I-2)*
     1       CC(M,I,K,2)-WA1(I-1)*CC(M,I-1,K,2))-(WA4(I-2)*CC(M,I,K,5)-
     1       WA4(I-1)*CC(M,I-1,K,5)))-TI11*((WA2(I-2)*CC(M,I,K,3)-
     1       WA2(I-1)*CC(M,I-1,K,3))-(WA3(I-2)*CC(M,I,K,4)-WA3(I-1)*
     1       CC(M,I-1,K,4))))
            CH(M,IC-1,4,K) = (CC(M,I-1,K,1)+TR12*((WA1(I-2)*
     1       CC(M,I-1,K,2)+WA1(I-1)*CC(M,I,K,2))+(WA4(I-2)*
     1       CC(M,I-1,K,5)+WA4(I-1)*CC(M,I,K,5)))+TR11*((WA2(I-2)*
     1       CC(M,I-1,K,3)+WA2(I-1)*CC(M,I,K,3))+(WA3(I-2)*
     1       CC(M,I-1,K,4)+WA3(I-1)*CC(M,I,K,4))))-(TI12*((WA1(I-2)*
     1       CC(M,I,K,2)-WA1(I-1)*CC(M,I-1,K,2))-(WA4(I-2)*CC(M,I,K,5)-
     1       WA4(I-1)*CC(M,I-1,K,5)))-TI11*((WA2(I-2)*CC(M,I,K,3)-
     1       WA2(I-1)*CC(M,I-1,K,3))-(WA3(I-2)*CC(M,I,K,4)-WA3(I-1)*
     1       CC(M,I-1,K,4))))
            CH(M,I,5,K) = (CC(M,I,K,1)+TR12*((WA1(I-2)*CC(M,I,K,2)-
     1       WA1(I-1)*CC(M,I-1,K,2))+(WA4(I-2)*CC(M,I,K,5)-WA4(I-1)*
     1       CC(M,I-1,K,5)))+TR11*((WA2(I-2)*CC(M,I,K,3)-WA2(I-1)*
     1       CC(M,I-1,K,3))+(WA3(I-2)*CC(M,I,K,4)-WA3(I-1)*
     1       CC(M,I-1,K,4))))+(TI12*((WA4(I-2)*CC(M,I-1,K,5)+
     1       WA4(I-1)*CC(M,I,K,5))-(WA1(I-2)*CC(M,I-1,K,2)+WA1(I-1)*
     1       CC(M,I,K,2)))-TI11*((WA3(I-2)*CC(M,I-1,K,4)+WA3(I-1)*
     1       CC(M,I,K,4))-(WA2(I-2)*CC(M,I-1,K,3)+WA2(I-1)*
     1       CC(M,I,K,3))))
            CH(M,IC,4,K) = (TI12*((WA4(I-2)*CC(M,I-1,K,5)+WA4(I-1)*
     1       CC(M,I,K,5))-(WA1(I-2)*CC(M,I-1,K,2)+WA1(I-1)*
     1       CC(M,I,K,2)))-TI11*((WA3(I-2)*CC(M,I-1,K,4)+WA3(I-1)*
     1       CC(M,I,K,4))-(WA2(I-2)*CC(M,I-1,K,3)+WA2(I-1)*
     1       CC(M,I,K,3))))-(CC(M,I,K,1)+TR12*((WA1(I-2)*CC(M,I,K,2)-
     1       WA1(I-1)*CC(M,I-1,K,2))+(WA4(I-2)*CC(M,I,K,5)-WA4(I-1)*
     1       CC(M,I-1,K,5)))+TR11*((WA2(I-2)*CC(M,I,K,3)-WA2(I-1)*
     1       CC(M,I-1,K,3))+(WA3(I-2)*CC(M,I,K,4)-WA3(I-1)*
     1       CC(M,I-1,K,4))))
 1002       CONTINUE
  102    CONTINUE
  103 CONTINUE
      RETURN
      END
      SUBROUTINE BVRADFG (MP,IDO,IP,L1,IDL1,CC,C1,C2,CH,CH2,MDIMC,WA)
      DIMENSION     CH(MDIMC,IDO,L1,IP)   ,CC(MDIMC,IDO,IP,L1)  ,
     1            C1(MDIMC,IDO,L1,IP)    ,C2(MDIMC,IDL1,IP),
     2                CH2(MDIMC,IDL1,IP)           ,WA(IDO)
      TPI=2.*PIMACH(1.0)
      ARG = TPI/FLOAT(IP)
      DCP = COS(ARG)
      DSP = SIN(ARG)
      IPPH = (IP+1)/2
      IPP2 = IP+2
      IDP2 = IDO+2
      NBD = (IDO-1)/2
      IF (IDO .EQ. 1) GO TO 119
      DO 101 IK=1,IDL1
         DO 1001 M=1,MP
         CH2(M,IK,1) = C2(M,IK,1)
 1001    CONTINUE
  101 CONTINUE
      DO 103 J=2,IP
         DO 102 K=1,L1
            DO 1002 M=1,MP
            CH(M,1,K,J) = C1(M,1,K,J)
 1002       CONTINUE
  102    CONTINUE
  103 CONTINUE
      IF (NBD .GT. L1) GO TO 107
      IS = -IDO
      DO 106 J=2,IP
         IS = IS+IDO
         IDIJ = IS
         DO 105 I=3,IDO,2
            IDIJ = IDIJ+2
            DO 104 K=1,L1
               DO 1004 M=1,MP
               CH(M,I-1,K,J) = WA(IDIJ-1)*C1(M,I-1,K,J)+WA(IDIJ)
     1           *C1(M,I,K,J)
               CH(M,I,K,J) = WA(IDIJ-1)*C1(M,I,K,J)-WA(IDIJ)
     1           *C1(M,I-1,K,J)
 1004          CONTINUE
  104       CONTINUE
  105    CONTINUE
  106 CONTINUE
      GO TO 111
  107 IS = -IDO
      DO 110 J=2,IP
         IS = IS+IDO
         DO 109 K=1,L1
            IDIJ = IS
            DO 108 I=3,IDO,2
               IDIJ = IDIJ+2
               DO 1008 M=1,MP
               CH(M,I-1,K,J) = WA(IDIJ-1)*C1(M,I-1,K,J)+WA(IDIJ)
     1           *C1(M,I,K,J)
               CH(M,I,K,J) = WA(IDIJ-1)*C1(M,I,K,J)-WA(IDIJ)
     1           *C1(M,I-1,K,J)
 1008          CONTINUE
  108       CONTINUE
  109    CONTINUE
  110 CONTINUE
  111 IF (NBD .LT. L1) GO TO 115
      DO 114 J=2,IPPH
         JC = IPP2-J
         DO 113 K=1,L1
            DO 112 I=3,IDO,2
               DO 1012 M=1,MP
               C1(M,I-1,K,J) = CH(M,I-1,K,J)+CH(M,I-1,K,JC)
               C1(M,I-1,K,JC) = CH(M,I,K,J)-CH(M,I,K,JC)
               C1(M,I,K,J) = CH(M,I,K,J)+CH(M,I,K,JC)
               C1(M,I,K,JC) = CH(M,I-1,K,JC)-CH(M,I-1,K,J)
 1012          CONTINUE
  112       CONTINUE
  113    CONTINUE
  114 CONTINUE
      GO TO 121
  115 DO 118 J=2,IPPH
         JC = IPP2-J
         DO 117 I=3,IDO,2
            DO 116 K=1,L1
               DO 1016 M=1,MP
               C1(M,I-1,K,J) = CH(M,I-1,K,J)+CH(M,I-1,K,JC)
               C1(M,I-1,K,JC) = CH(M,I,K,J)-CH(M,I,K,JC)
               C1(M,I,K,J) = CH(M,I,K,J)+CH(M,I,K,JC)
               C1(M,I,K,JC) = CH(M,I-1,K,JC)-CH(M,I-1,K,J)
 1016          CONTINUE
  116       CONTINUE
  117    CONTINUE
  118 CONTINUE
      GO TO 121
  119 DO 120 IK=1,IDL1
         DO 1020 M=1,MP
         C2(M,IK,1) = CH2(M,IK,1)
 1020    CONTINUE
  120 CONTINUE
  121 DO 123 J=2,IPPH
         JC = IPP2-J
         DO 122 K=1,L1
            DO 1022 M=1,MP
            C1(M,1,K,J) = CH(M,1,K,J)+CH(M,1,K,JC)
            C1(M,1,K,JC) = CH(M,1,K,JC)-CH(M,1,K,J)
 1022       CONTINUE
  122    CONTINUE
  123 CONTINUE
      AR1 = 1.
      AI1 = 0.
      DO 127 L=2,IPPH
         LC = IPP2-L
         AR1H = DCP*AR1-DSP*AI1
         AI1 = DCP*AI1+DSP*AR1
         AR1 = AR1H
         DO 124 IK=1,IDL1
            DO 1024 M=1,MP
            CH2(M,IK,L) = C2(M,IK,1)+AR1*C2(M,IK,2)
            CH2(M,IK,LC) = AI1*C2(M,IK,IP)
 1024       CONTINUE
  124    CONTINUE
         DC2 = AR1
         DS2 = AI1
         AR2 = AR1
         AI2 = AI1
         DO 126 J=3,IPPH
            JC = IPP2-J
            AR2H = DC2*AR2-DS2*AI2
            AI2 = DC2*AI2+DS2*AR2
            AR2 = AR2H
            DO 125 IK=1,IDL1
               DO 1025 M=1,MP
               CH2(M,IK,L) = CH2(M,IK,L)+AR2*C2(M,IK,J)
               CH2(M,IK,LC) = CH2(M,IK,LC)+AI2*C2(M,IK,JC)
 1025          CONTINUE
  125       CONTINUE
  126    CONTINUE
  127 CONTINUE
      DO 129 J=2,IPPH
         DO 128 IK=1,IDL1
            DO 1028 M=1,MP
            CH2(M,IK,1) = CH2(M,IK,1)+C2(M,IK,J)
 1028       CONTINUE
  128    CONTINUE
  129 CONTINUE
      IF (IDO .LT. L1) GO TO 132
      DO 131 K=1,L1
         DO 130 I=1,IDO
            DO 1030 M=1,MP
            CC(M,I,1,K) = CH(M,I,K,1)
 1030       CONTINUE
  130    CONTINUE
  131 CONTINUE
      GO TO 135
  132 DO 134 I=1,IDO
         DO 133 K=1,L1
            DO 1033 M=1,MP
            CC(M,I,1,K) = CH(M,I,K,1)
 1033       CONTINUE
  133    CONTINUE
  134 CONTINUE
  135 DO 137 J=2,IPPH
         JC = IPP2-J
         J2 = J+J
         DO 136 K=1,L1
            DO 1036 M=1,MP
            CC(M,IDO,J2-2,K) = CH(M,1,K,J)
            CC(M,1,J2-1,K) = CH(M,1,K,JC)
 1036       CONTINUE
  136    CONTINUE
  137 CONTINUE
      IF (IDO .EQ. 1) RETURN
      IF (NBD .LT. L1) GO TO 141
      DO 140 J=2,IPPH
         JC = IPP2-J
         J2 = J+J
         DO 139 K=1,L1
            DO 138 I=3,IDO,2
               IC = IDP2-I
               DO 1038 M=1,MP
               CC(M,I-1,J2-1,K) = CH(M,I-1,K,J)+CH(M,I-1,K,JC)
               CC(M,IC-1,J2-2,K) = CH(M,I-1,K,J)-CH(M,I-1,K,JC)
               CC(M,I,J2-1,K) = CH(M,I,K,J)+CH(M,I,K,JC)
               CC(M,IC,J2-2,K) = CH(M,I,K,JC)-CH(M,I,K,J)
 1038          CONTINUE
  138       CONTINUE
  139    CONTINUE
  140 CONTINUE
      RETURN
  141 DO 144 J=2,IPPH
         JC = IPP2-J
         J2 = J+J
         DO 143 I=3,IDO,2
            IC = IDP2-I
            DO 142 K=1,L1
               DO 1042 M=1,MP
               CC(M,I-1,J2-1,K) = CH(M,I-1,K,J)+CH(M,I-1,K,JC)
               CC(M,IC-1,J2-2,K) = CH(M,I-1,K,J)-CH(M,I-1,K,JC)
               CC(M,I,J2-1,K) = CH(M,I,K,J)+CH(M,I,K,JC)
               CC(M,IC,J2-2,K) = CH(M,I,K,JC)-CH(M,I,K,J)
 1042          CONTINUE
  142       CONTINUE
  143    CONTINUE
  144 CONTINUE
      RETURN
      END
      SUBROUTINE BVRFFTB(M,N,R,RT,MDIMR,WSAVE)
      DIMENSION     R(MDIMR,N),RT(MDIMR,N),WSAVE(N+15)
      IF (N .EQ. 1) RETURN
      CALL BVRFTB1 (M,N,R,RT,MDIMR,WSAVE(1),WSAVE(N+1))
      RETURN
      END
      SUBROUTINE BVRFFTF (M,N,R,RT,MDIMR,WSAVE)
      DIMENSION       R(MDIMR,N)  ,RT(MDIMR,N)    ,WSAVE(N+15)
      IF (N .EQ. 1) RETURN
      CALL BVRFTF1 (M,N,R,RT,MDIMR,WSAVE(1),WSAVE(N+1))
      RETURN
      END
      SUBROUTINE BVRFFTI (N,WSAVE)
      DIMENSION       WSAVE(N+15)
      IF (N .EQ. 1) RETURN
      CALL BVRFTI1 (N,WSAVE(1),WSAVE(N+1))
      RETURN
      END
      SUBROUTINE BVRFTB1 (M,N,C,CH,MDIMC,WA,FAC)
      DIMENSION       CH(MDIMC,N), C(MDIMC,N), WA(N) ,FAC(15)
      NF = FAC(2)
      NA = 0
      L1 = 1
      IW = 1
      DO 116 K1=1,NF
         IP = FAC(K1+2)
         L2 = IP*L1
         IDO = N/L2
         IDL1 = IDO*L1
         IF (IP .NE. 4) GO TO 103
         IX2 = IW+IDO
         IX3 = IX2+IDO
         IF (NA .NE. 0) GO TO 101
         CALL BVRADB4 (M,IDO,L1,C,CH,MDIMC,WA(IW),WA(IX2),WA(IX3))
         GO TO 102
  101    CALL BVRADB4 (M,IDO,L1,CH,C,MDIMC,WA(IW),WA(IX2),WA(IX3))
  102    NA = 1-NA
         GO TO 115
  103    IF (IP .NE. 2) GO TO 106
         IF (NA .NE. 0) GO TO 104
         CALL BVRADB2 (M,IDO,L1,C,CH,MDIMC,WA(IW))
         GO TO 105
  104    CALL BVRADB2 (M,IDO,L1,CH,C,MDIMC,WA(IW))
  105    NA = 1-NA
         GO TO 115
  106    IF (IP .NE. 3) GO TO 109
         IX2 = IW+IDO
         IF (NA .NE. 0) GO TO 107
         CALL BVRADB3 (M,IDO,L1,C,CH,MDIMC,WA(IW),WA(IX2))
         GO TO 108
  107    CALL BVRADB3 (M,IDO,L1,CH,C,MDIMC,WA(IW),WA(IX2))
  108    NA = 1-NA
         GO TO 115
  109    IF (IP .NE. 5) GO TO 112
         IX2 = IW+IDO
         IX3 = IX2+IDO
         IX4 = IX3+IDO
         IF (NA .NE. 0) GO TO 110
      CALL BVRADB5 (M,IDO,L1,C,CH,MDIMC,WA(IW),WA(IX2),WA(IX3),WA(IX4))
         GO TO 111
  110 CALL BVRADB5 (M,IDO,L1,CH,C,MDIMC,WA(IW),WA(IX2),WA(IX3),WA(IX4))
  111    NA = 1-NA
         GO TO 115
  112    IF (NA .NE. 0) GO TO 113
         CALL BVRADBG (M,IDO,IP,L1,IDL1,C,C,C,CH,CH,MDIMC,WA(IW))
         GO TO 114
  113    CALL BVRADBG (M,IDO,IP,L1,IDL1,CH,CH,CH,C,C,MDIMC,WA(IW))
  114    IF (IDO .EQ. 1) NA = 1-NA
  115    L1 = L2
         IW = IW+(IP-1)*IDO
  116 CONTINUE
      SCALE=SQRT(1./N)
      IF (NA .EQ. 0) GO TO 118
      DO 117 J=1,N
      DO 117 I=1,M
         C(I,J) = SCALE*CH(I,J)
  117 CONTINUE
      RETURN
  118 DO 119 J=1,N
      DO 119 I=1,M
         C(I,J)=SCALE*C(I,J)
  119 CONTINUE
      RETURN
      END
      SUBROUTINE BVRFTF1 (M,N,C,CH,MDIMC,WA,FAC)
      DIMENSION       CH(MDIMC,N) ,C(MDIMC,N)  ,WA(N)   ,FAC(15)
      NF = FAC(2)
      NA = 1
      L2 = N
      IW = N
      DO 111 K1=1,NF
         KH = NF-K1
         IP = FAC(KH+3)
         L1 = L2/IP
         IDO = N/L2
         IDL1 = IDO*L1
         IW = IW-(IP-1)*IDO
         NA = 1-NA
         IF (IP .NE. 4) GO TO 102
         IX2 = IW+IDO
         IX3 = IX2+IDO
         IF (NA .NE. 0) GO TO 101
         CALL BVRADF4 (M,IDO,L1,C,CH,MDIMC,WA(IW),WA(IX2),WA(IX3))
         GO TO 110
  101    CALL BVRADF4 (M,IDO,L1,CH,C,MDIMC,WA(IW),WA(IX2),WA(IX3))
         GO TO 110
  102    IF (IP .NE. 2) GO TO 104
         IF (NA .NE. 0) GO TO 103
         CALL BVRADF2 (M,IDO,L1,C,CH,MDIMC,WA(IW))
         GO TO 110
  103    CALL BVRADF2 (M,IDO,L1,CH,C,MDIMC,WA(IW))
         GO TO 110
  104    IF (IP .NE. 3) GO TO 106
         IX2 = IW+IDO
         IF (NA .NE. 0) GO TO 105
         CALL BVRADF3 (M,IDO,L1,C,CH,MDIMC,WA(IW),WA(IX2))
         GO TO 110
  105    CALL BVRADF3 (M,IDO,L1,CH,C,MDIMC,WA(IW),WA(IX2))
         GO TO 110
  106    IF (IP .NE. 5) GO TO 108
         IX2 = IW+IDO
         IX3 = IX2+IDO
         IX4 = IX3+IDO
         IF (NA .NE. 0) GO TO 107
      CALL BVRADF5(M,IDO,L1,C,CH,MDIMC,WA(IW),WA(IX2),WA(IX3),WA(IX4))
         GO TO 110
  107 CALL BVRADF5 (M,IDO,L1,CH,C,MDIMC,WA(IW),WA(IX2),WA(IX3),WA(IX4))
         GO TO 110
  108    IF (IDO .EQ. 1) NA = 1-NA
         IF (NA .NE. 0) GO TO 109
         CALL BVRADFG (M,IDO,IP,L1,IDL1,C,C,C,CH,CH,MDIMC,WA(IW))
         NA = 1
         GO TO 110
  109    CALL BVRADFG (M,IDO,IP,L1,IDL1,CH,CH,CH,C,C,MDIMC,WA(IW))
         NA = 0
  110    L2 = L1
  111 CONTINUE
      SCALE=SQRT(1./N)
      IF (NA .EQ. 1) GO TO 113
      DO 112 J=1,N
      DO 112 I=1,M
         C(I,J) = SCALE*CH(I,J)
  112 CONTINUE
      RETURN
  113 DO 114 J=1,N
      DO 114 I=1,M
         C(I,J)=SCALE*C(I,J)
  114 CONTINUE
      RETURN
      END
      SUBROUTINE BVRFTI1 (N,WA,FAC)
      DIMENSION       WA(N)      ,FAC(15)    ,NTRYH(4)
      DATA NTRYH(1),NTRYH(2),NTRYH(3),NTRYH(4)/4,2,3,5/
      NL = N
      NF = 0
      J = 0
  101 J = J+1
      IF (J-4) 102,102,103
  102 NTRY = NTRYH(J)
      GO TO 104
  103 NTRY = NTRY+2
  104 NQ = NL/NTRY
      NR = NL-NTRY*NQ
      IF (NR) 101,105,101
  105 NF = NF+1
      FAC(NF+2) = NTRY
      NL = NQ
      IF (NTRY .NE. 2) GO TO 107
      IF (NF .EQ. 1) GO TO 107
      DO 106 I=2,NF
         IB = NF-I+2
         FAC(IB+2) = FAC(IB+1)
  106 CONTINUE
      FAC(3) = 2
  107 IF (NL .NE. 1) GO TO 104
      FAC(1) = N
      FAC(2) = NF
      TPI = 2.*PIMACH(1.0)
      ARGH = TPI/FLOAT(N)
      IS = 0
      NFM1 = NF-1
      L1 = 1
      IF (NFM1 .EQ. 0) RETURN
      DO 110 K1=1,NFM1
         IP = FAC(K1+2)
         LD = 0
         L2 = L1*IP
         IDO = N/L2
         IPM = IP-1
         DO 109 J=1,IPM
            LD = LD+L1
            I = IS
            ARGLD = FLOAT(LD)*ARGH
            FI = 0.
            DO 108 II=3,IDO,2
               I = I+2
               FI = FI+1.
               ARG = FI*ARGLD
               WA(I-1) = COS(ARG)
               WA(I) = SIN(ARG)
  108       CONTINUE
            IS = IS+IDO
  109    CONTINUE
         L1 = L2
  110 CONTINUE
      RETURN
      END


      SUBROUTINE BLKTRI (IFLG,NP,N,AN,BN,CN,MP,M,AM,BM,CM,IDIMY,Y,
     1                   IERROR,W)
C
C     * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
C     *                                                               *
C     *                        F I S H P A K                          *
C     *                                                               *
C     *                                                               *
C     *     A PACKAGE OF FORTRAN SUBPROGRAMS FOR THE SOLUTION OF      *
C     *                                                               *
C     *      SEPARABLE ELLIPTIC PARTIAL DIFFERENTIAL EQUATIONS        *
C     *                                                               *
C     *                  (VERSION 3.1 , OCTOBER 1980)                 *
C     *                                                               *
C     *                             BY                                *
C     *                                                               *
C     *        JOHN ADAMS, PAUL SWARZTRAUBER AND ROLAND SWEET         *
C     *                                                               *
C     *                             OF                                *
C     *                                                               *
C     *         THE NATIONAL CENTER FOR ATMOSPHERIC RESEARCH          *
C     *                                                               *
C     *                BOULDER, COLORADO  (80307)  U.S.A.             *
C     *                                                               *
C     *                   WHICH IS SPONSORED BY                       *
C     *                                                               *
C     *              THE NATIONAL SCIENCE FOUNDATION                  *
C     *                                                               *
C     * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
C
C     SUBROUTINE BLKTRI SOLVES A SYSTEM OF LINEAR EQUATIONS OF THE FORM
C
C          AN(J)*X(I,J-1) + AM(I)*X(I-1,J) + (BN(J)+BM(I))*X(I,J)
C
C          + CN(J)*X(I,J+1) + CM(I)*X(I+1,J) = Y(I,J)
C
C               FOR I = 1,2,...,M  AND  J = 1,2,...,N.
C
C     I+1 AND I-1 ARE EVALUATED MODULO M AND J+1 AND J-1 MODULO N, I.E.,
C
C          X(I,0) = X(I,N),  X(I,N+1) = X(I,1),
C          X(0,J) = X(M,J),  X(M+1,J) = X(1,J).
C
C     THESE EQUATIONS USUALLY RESULT FROM THE DISCRETIZATION OF
C     SEPARABLE ELLIPTIC EQUATIONS.  BOUNDARY CONDITIONS MAY BE
C     DIRICHLET, NEUMANN, OR PERIODIC.
C
C
C     * * * * * * * * * *     ON INPUT     * * * * * * * * * *
C
C     IFLG
C       = 0  INITIALIZATION ONLY.  CERTAIN QUANTITIES THAT DEPEND ON NP,
C            N, AN, BN, AND CN ARE COMPUTED AND STORED IN THE WORK
C            ARRAY  W.
C       = 1  THE QUANTITIES THAT WERE COMPUTED IN THE INITIALIZATION ARE
C            USED TO OBTAIN THE SOLUTION X(I,J).
C
C       NOTE   A CALL WITH IFLG=0 TAKES APPROXIMATELY ONE HALF THE TIME
C              TIME AS A CALL WITH IFLG = 1  .  HOWEVER, THE
C              INITIALIZATION DOES NOT HAVE TO BE REPEATED UNLESS NP, N,
C              AN, BN, OR CN CHANGE.
C
C     NP
C       = 0  IF AN(1) AND CN(N) ARE NOT ZERO, WHICH CORRESPONDS TO
C            PERIODIC BOUNARY CONDITIONS.
C       = 1  IF AN(1) AND CN(N) ARE ZERO.
C
C     N
C       THE NUMBER OF UNKNOWNS IN THE J-DIRECTION. N MUST BE GREATER
C       THAN 4. THE OPERATION COUNT IS PROPORTIONAL TO MNLOG2(N), HENCE
C       N SHOULD BE SELECTED LESS THAN OR EQUAL TO M.
C
C     AN,BN,CN
C       ONE-DIMENSIONAL ARRAYS OF LENGTH N THAT SPECIFY THE COEFFICIENTS
C       IN THE LINEAR EQUATIONS GIVEN ABOVE.
C
C     MP
C       = 0  IF AM(1) AND CM(M) ARE NOT ZERO, WHICH CORRESPONDS TO
C            PERIODIC BOUNDARY CONDITIONS.
C       = 1  IF AM(1) = CM(M) = 0  .
C
C     M
C       THE NUMBER OF UNKNOWNS IN THE I-DIRECTION. M MUST BE GREATER
C       THAN 4.
C
C     AM,BM,CM
C       ONE-DIMENSIONAL ARRAYS OF LENGTH M THAT SPECIFY THE COEFFICIENTS
C       IN THE LINEAR EQUATIONS GIVEN ABOVE.
C
C     IDIMY
C       THE ROW (OR FIRST) DIMENSION OF THE TWO-DIMENSIONAL ARRAY Y AS
C       IT APPEARS IN THE PROGRAM CALLING BLKTRI.  THIS PARAMETER IS
C       USED TO SPECIFY THE VARIABLE DIMENSION OF Y.  IDIMY MUST BE AT
C       LEAST M.
C
C     Y
C       A TWO-DIMENSIONAL ARRAY THAT SPECIFIES THE VALUES OF THE RIGHT
C       SIDE OF THE LINEAR SYSTEM OF EQUATIONS GIVEN ABOVE.  Y MUST BE
C       DIMENSIONED AT LEAST M*N.
C
C     W
C       A ONE-DIMENSIONAL ARRAY THAT MUST BE PROVIDED BY THE USER FOR
C       WORK SPACE.
C             IF NP=1 DEFINE K=INT(LOG2(N))+1 AND SET L=2**(K+1) THEN
C                     W MUST HAVE DIMENSION (K-2)*L+K+5+MAX(2N,6M)
C
C             IF NP=0 DEFINE K=INT(LOG2(N-1))+1 AND SET L=2**(K+1) THEN
C                     W MUST HAVE DIMENSION (K-2)*L+K+5+2N+MAX(2N,6M)
C
C       **IMPORTANT** FOR PURPOSES OF CHECKING, THE REQUIRED DIMENSION
C                     OF W IS COMPUTED BY BLKTRI AND STORED IN W(1)
C                     IN FLOATING POINT FORMAT.
C
C     * * * * * * * * * *     ON OUTPUT     * * * * * * * * * *
C
C     Y
C       CONTAINS THE SOLUTION X.
C
C     IERROR
C       AN ERROR FLAG THAT INDICATES INVALID INPUT PARAMETERS.  EXCEPT
C       FOR NUMBER ZERO, A SOLUTION IS NOT ATTEMPTED.
C
C       = 0  NO ERROR.
C       = 1  M IS LESS THAN 5
C       = 2  N IS LESS THAN 5
C       = 3  IDIMY IS LESS THAN M.
C       = 4  BLKTRI FAILED WHILE COMPUTING RESULTS THAT DEPEND ON THE
C            COEFFICIENT ARRAYS AN, BN, CN.  CHECK THESE ARRAYS.
C       = 5  AN(J)*CN(J-1) IS LESS THAN 0 FOR SOME J. POSSIBLE REASONS
C            FOR THIS CONDITION ARE
C            1. THE ARRAYS AN AND CN ARE NOT CORRECT
C            2. TOO LARGE A GRID SPACING WAS USED IN THE DISCRETIZATION
C               OF THE ELLIPTIC EQUATION
C            3. THE LINEAR EQUATIONS RESULTED FROM A PARTIAL
C               DIFFERENTIAL EQUATION WHICH WAS NOT ELLIPTIC
C
C     W
C       CONTAINS INTERMEDIATE VALUES THAT MUST NOT BE DESTROYED IF
C       BLKTRI WILL BE CALLED AGAIN WITH IFLG=1. W(1) CONTAINS THE
C       NUMBER OF LOCATIONS REQUIRED BY W IN FLOATING POINT FORMAT.
C
C     * * * * * * *   PROGRAM SPECIFICATIONS    * * * * * * * * * * * *
C
C     DIMENSION OF   AN(N),BN(N),CN(N),AM(M),BM(M),CM(M),Y(IDIMY,N)
C     ARGUMENTS      W(SEE ARGUMENT LIST)
C
C     LATEST         JUNE 1979
C     REVISION
C
C     REQUIRED       BLKTRI,BLKTRI,PROD,PRODP,CPROD,CPRODP,COMPB,INDXA,
C     SUBPROGRAMS    INDXB,INDXC,PPADD,PSGF,PPSGF,PPSPF,BSRH,TEVLS,
C                    EPMACH,STORE
C
C     SPECIAL        THE ALGORITHM MAY FAIL IF ABS(BM(I)+BN(J)) IS LESS
C     CONDITIONS     THAN ABS(AM(I))+ABS(AN(J))+ABS(CM(I))+ABS(CN(J))
C                    FOR SOME I AND J. THE ALGORITHM WILL ALSO FAIL IF
C                    AN(J)*CN(J-1) IS LESS THAN ZERO FOR SOME J
C                    SEE THE DISCRIPTION OF THE OUTPUT PARAMETER IERROR.
C
C     COMMON         CBLKT,VALUE
C     BLOCKS
C
C     I/O            NONE
C
C     PRECISION      SINGLE
C
C     SPECIALIST     PAUL SWARZTRAUBER
C
C     LANGUAGE       FORTRAN
C
C     HISTORY        VERSION 1 SEPTEMBER 1973
C                    VERSION 2 APRIL     1976
C                    VERSION 3 JUNE      1979
C
C     ALGORITHM      GENERALIZED CYCLIC REDUCTION (SEE REFERENCE BELOW)
C
C     SPACE
C     REQUIRED       CONTROL DATA 7600
C
C     PORTABILITY    AMERICAN NATIONAL STANDARDS INSTITUTE FORTRAN.
C                    THE APPROXIMATE MACHINE ACCURACY IS COMPUTED IN
C                    FUNCTION EPMACH
C
C     REQUIRED       NONE
C     RESIDENT
C     ROUTINES
C
C     REFERENCES     SWARZTRAUBER,P. AND R. SWEET, 'EFFICIENT FORTRAN
C                    SUBPROGRAMS FOR THE SOLUTION OF ELLIPTIC EQUATIONS'
C                    NCAR TN/IA-109, JULY, 1975, 138 PP.
C
C                    SWARZTRAUBER P. N.,A DIRECT METHOD FOR THE DISCRETE
C                    SOLUTION OF SEPARABLE ELLIPTIC EQUATIONS, S.I.A.M.
C                    J. NUMER. ANAL.,11(1974) PP. 1136-1150.
C
C     * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
C
C
C
      DIMENSION       AN(1)      ,BN(1)      ,CN(1)      ,AM(1)      ,
     1                BM(1)      ,CM(1)      ,Y(IDIMY,1) ,W(1)
      EXTERNAL        PROD       ,PRODP      ,CPROD      ,CPRODP
      COMMON /CBLKT/  NPP        ,K          ,EPS        ,CNV        ,
     1                NM         ,NCMPLX     ,IK
C
C TEST M AND N FOR THE PROPER FORM
C
      NM = N
      IERROR = 0
      IF (M-5) 101,102,102
  101 IERROR = 1
      GO TO 119
  102 IF (NM-3) 103,104,104
  103 IERROR = 2
      GO TO 119
  104 IF (IDIMY-M) 105,106,106
  105 IERROR = 3
      GO TO 119
  106 NH = N
      NPP = NP
      IF (NPP) 107,108,107
  107 NH = NH+1
  108 IK = 2
      K = 1
  109 IK = IK+IK
      K = K+1
      IF (NH-IK) 110,110,109
  110 NL = IK
      IK = IK+IK
      NL = NL-1
      IWAH = (K-2)*IK+K+6
      IF (NPP) 111,112,111
C
C     DIVIDE W INTO WORKING SUB ARRAYS
C
  111 IW1 = IWAH
      IWBH = IW1+NM
      W(1) = FLOAT(IW1-1+MAX0(2*NM,6*M))
      GO TO 113
  112 IWBH = IWAH+NM+NM
      IW1 = IWBH
      W(1) = FLOAT(IW1-1+MAX0(2*NM,6*M))
      NM = NM-1
C
C SUBROUTINE COMP B COMPUTES THE ROOTS OF THE B POLYNOMIALS
C
  113 IF (IERROR) 119,114,119
  114 IW2 = IW1+M
      IW3 = IW2+M
      IWD = IW3+M
      IWW = IWD+M
      IWU = IWW+M
      IF (IFLG) 116,115,116
  115 CALL COMPB (NL,IERROR,AN,BN,CN,W(2),W(IWAH),W(IWBH))
      GO TO 119
  116 IF (MP) 117,118,117
C
C SUBROUTINE BLKTR1 SOLVES THE LINEAR SYSTEM
C
  117 CALL BLKTR1 (NL,AN,BN,CN,M,AM,BM,CM,IDIMY,Y,W(2),W(IW1),W(IW2),
     1             W(IW3),W(IWD),W(IWW),W(IWU),PROD,CPROD)
      GO TO 119
  118 CALL BLKTR1 (NL,AN,BN,CN,M,AM,BM,CM,IDIMY,Y,W(2),W(IW1),W(IW2),
     1             W(IW3),W(IWD),W(IWW),W(IWU),PRODP,CPRODP)
  119 CONTINUE
      RETURN
      END
      SUBROUTINE BLKTR1 (N,AN,BN,CN,M,AM,BM,CM,IDIMY,Y,B,W1,W2,W3,WD,
     1                   WW,WU,PRDCT,CPRDCT)
C
C BLKTR1 SOLVES THE LINEAR SYSTEM
C
C B  CONTAINS THE ROOTS OF ALL THE B POLYNOMIALS
C W1,W2,W3,WD,WW,WU  ARE ALL WORKING ARRAYS
C PRDCT  IS EITHER PRODP OR PROD DEPENDING ON WHETHER THE BOUNDARY
C CONDITIONS IN THE M DIRECTION ARE PERIODIC OR NOT
C CPRDCT IS EITHER CPRODP OR CPROD WHICH ARE THE COMPLEX VERSIONS
C OF PRODP AND PROD. THESE ARE CALLED IN THE EVENT THAT SOME
C OF THE ROOTS OF THE B SUB P POLYNOMIAL ARE COMPLEX
C
C
      DIMENSION       AN(1)      ,BN(1)      ,CN(1)      ,AM(1)      ,
     1                BM(1)      ,CM(1)      ,B(1)       ,W1(1)      ,
     2                W2(1)      ,W3(1)      ,WD(1)      ,WW(1)      ,
     3                WU(1)      ,Y(IDIMY,1)
      COMMON /CBLKT/  NPP        ,K          ,EPS        ,CNV        ,
     1                NM         ,NCMPLX     ,IK
C
C BEGIN REDUCTION PHASE
C
      KDO = K-1
      DO 109 L=1,KDO
         IR = L-1
         I2 = 2**IR
         I1 = I2/2
         I3 = I2+I1
         I4 = I2+I2
         IRM1 = IR-1
         CALL INDXB (I2,IR,IM2,NM2)
         CALL INDXB (I1,IRM1,IM3,NM3)
         CALL INDXB (I3,IRM1,IM1,NM1)
         CALL PRDCT (NM2,B(IM2),NM3,B(IM3),NM1,B(IM1),0,DUM,Y(1,I2),W3,
     1               M,AM,BM,CM,WD,WW,WU)
         IF = 2**K
         DO 108 I=I4,IF,I4
            IF (I-NM) 101,101,108
  101       IPI1 = I+I1
            IPI2 = I+I2
            IPI3 = I+I3
            CALL INDXC (I,IR,IDXC,NC)
            IF (I-IF) 102,108,108
  102       CALL INDXA (I,IR,IDXA,NA)
            CALL INDXB (I-I1,IRM1,IM1,NM1)
            CALL INDXB (IPI2,IR,IP2,NP2)
            CALL INDXB (IPI1,IRM1,IP1,NP1)
            CALL INDXB (IPI3,IRM1,IP3,NP3)
            CALL PRDCT (NM1,B(IM1),0,DUM,0,DUM,NA,AN(IDXA),W3,W1,M,AM,
     1                  BM,CM,WD,WW,WU)
            IF (IPI2-NM) 105,105,103
  103       DO 104 J=1,M
               W3(J) = 0.
               W2(J) = 0.
  104       CONTINUE
            GO TO 106
  105       CALL PRDCT (NP2,B(IP2),NP1,B(IP1),NP3,B(IP3),0,DUM,
     1                  Y(1,IPI2),W3,M,AM,BM,CM,WD,WW,WU)
            CALL PRDCT (NP1,B(IP1),0,DUM,0,DUM,NC,CN(IDXC),W3,W2,M,AM,
     1                  BM,CM,WD,WW,WU)
  106       DO 107 J=1,M
               Y(J,I) = W1(J)+W2(J)+Y(J,I)
  107       CONTINUE
  108    CONTINUE
  109 CONTINUE
      IF (NPP) 132,110,132
C
C     THE PERIODIC CASE IS TREATED USING THE CAPACITANCE MATRIX METHOD
C
  110 IF = 2**K
      I = IF/2
      I1 = I/2
      CALL INDXB (I-I1,K-2,IM1,NM1)
      CALL INDXB (I+I1,K-2,IP1,NP1)
      CALL INDXB (I,K-1,IZ,NZ)
      CALL PRDCT (NZ,B(IZ),NM1,B(IM1),NP1,B(IP1),0,DUM,Y(1,I),W1,M,AM,
     1            BM,CM,WD,WW,WU)
      IZR = I
      DO 111 J=1,M
         W2(J) = W1(J)
  111 CONTINUE
      DO 113 LL=2,K
         L = K-LL+1
         IR = L-1
         I2 = 2**IR
         I1 = I2/2
         I = I2
         CALL INDXC (I,IR,IDXC,NC)
         CALL INDXB (I,IR,IZ,NZ)
         CALL INDXB (I-I1,IR-1,IM1,NM1)
         CALL INDXB (I+I1,IR-1,IP1,NP1)
         CALL PRDCT (NP1,B(IP1),0,DUM,0,DUM,NC,CN(IDXC),W1,W1,M,AM,BM,
     1               CM,WD,WW,WU)
         DO 112 J=1,M
            W1(J) = Y(J,I)+W1(J)
  112    CONTINUE
         CALL PRDCT (NZ,B(IZ),NM1,B(IM1),NP1,B(IP1),0,DUM,W1,W1,M,AM,
     1               BM,CM,WD,WW,WU)
  113 CONTINUE
      DO 118 LL=2,K
         L = K-LL+1
         IR = L-1
         I2 = 2**IR
         I1 = I2/2
         I4 = I2+I2
         IFD = IF-I2
         DO 117 I=I2,IFD,I4
            IF (I-I2-IZR) 117,114,117
  114       IF (I-NM) 115,115,118
  115       CALL INDXA (I,IR,IDXA,NA)
            CALL INDXB (I,IR,IZ,NZ)
            CALL INDXB (I-I1,IR-1,IM1,NM1)
            CALL INDXB (I+I1,IR-1,IP1,NP1)
            CALL PRDCT (NM1,B(IM1),0,DUM,0,DUM,NA,AN(IDXA),W2,W2,M,AM,
     1                  BM,CM,WD,WW,WU)
            DO 116 J=1,M
               W2(J) = Y(J,I)+W2(J)
  116       CONTINUE
            CALL PRDCT (NZ,B(IZ),NM1,B(IM1),NP1,B(IP1),0,DUM,W2,W2,M,
     1                  AM,BM,CM,WD,WW,WU)
            IZR = I
            IF (I-NM) 117,119,117
  117    CONTINUE
  118 CONTINUE
  119 DO 120 J=1,M
         Y(J,NM+1) = Y(J,NM+1)-CN(NM+1)*W1(J)-AN(NM+1)*W2(J)
  120 CONTINUE
      CALL INDXB (IF/2,K-1,IM1,NM1)
      CALL INDXB (IF,K-1,IP,NP)
      IF (NCMPLX) 121,122,121
  121 CALL CPRDCT (NM+1,B(IP),NM1,B(IM1),0,DUM,0,DUM,Y(1,NM+1),
     1             Y(1,NM+1),M,AM,BM,CM,W1,W3,WW)
      GO TO 123
  122 CALL PRDCT (NM+1,B(IP),NM1,B(IM1),0,DUM,0,DUM,Y(1,NM+1),
     1            Y(1,NM+1),M,AM,BM,CM,WD,WW,WU)
  123 DO 124 J=1,M
         W1(J) = AN(1)*Y(J,NM+1)
         W2(J) = CN(NM)*Y(J,NM+1)
         Y(J,1) = Y(J,1)-W1(J)
         Y(J,NM) = Y(J,NM)-W2(J)
  124 CONTINUE
      DO 126 L=1,KDO
         IR = L-1
         I2 = 2**IR
         I4 = I2+I2
         I1 = I2/2
         I = I4
         CALL INDXA (I,IR,IDXA,NA)
         CALL INDXB (I-I2,IR,IM2,NM2)
         CALL INDXB (I-I2-I1,IR-1,IM3,NM3)
         CALL INDXB (I-I1,IR-1,IM1,NM1)
         CALL PRDCT (NM2,B(IM2),NM3,B(IM3),NM1,B(IM1),0,DUM,W1,W1,M,AM,
     1               BM,CM,WD,WW,WU)
         CALL PRDCT (NM1,B(IM1),0,DUM,0,DUM,NA,AN(IDXA),W1,W1,M,AM,BM,
     1               CM,WD,WW,WU)
         DO 125 J=1,M
            Y(J,I) = Y(J,I)-W1(J)
  125    CONTINUE
  126 CONTINUE
C
      IZR = NM
      DO 131 L=1,KDO
         IR = L-1
         I2 = 2**IR
         I1 = I2/2
         I3 = I2+I1
         I4 = I2+I2
         IRM1 = IR-1
         DO 130 I=I4,IF,I4
            IPI1 = I+I1
            IPI2 = I+I2
            IPI3 = I+I3
            IF (IPI2-IZR) 127,128,127
  127       IF (I-IZR) 130,131,130
  128       CALL INDXC (I,IR,IDXC,NC)
            CALL INDXB (IPI2,IR,IP2,NP2)
            CALL INDXB (IPI1,IRM1,IP1,NP1)
            CALL INDXB (IPI3,IRM1,IP3,NP3)
            CALL PRDCT (NP2,B(IP2),NP1,B(IP1),NP3,B(IP3),0,DUM,W2,W2,M,
     1                  AM,BM,CM,WD,WW,WU)
            CALL PRDCT (NP1,B(IP1),0,DUM,0,DUM,NC,CN(IDXC),W2,W2,M,AM,
     1                  BM,CM,WD,WW,WU)
            DO 129 J=1,M
               Y(J,I) = Y(J,I)-W2(J)
  129       CONTINUE
            IZR = I
            GO TO 131
  130    CONTINUE
  131 CONTINUE
C
C BEGIN BACK SUBSTITUTION PHASE
C
  132 DO 144 LL=1,K
         L = K-LL+1
         IR = L-1
         IRM1 = IR-1
         I2 = 2**IR
         I1 = I2/2
         I4 = I2+I2
         IFD = IF-I2
         DO 143 I=I2,IFD,I4
            IF (I-NM) 133,133,143
  133       IMI1 = I-I1
            IMI2 = I-I2
            IPI1 = I+I1
            IPI2 = I+I2
            CALL INDXA (I,IR,IDXA,NA)
            CALL INDXC (I,IR,IDXC,NC)
            CALL INDXB (I,IR,IZ,NZ)
            CALL INDXB (IMI1,IRM1,IM1,NM1)
            CALL INDXB (IPI1,IRM1,IP1,NP1)
            IF (I-I2) 134,134,136
  134       DO 135 J=1,M
               W1(J) = 0.
  135       CONTINUE
            GO TO 137
  136       CALL PRDCT (NM1,B(IM1),0,DUM,0,DUM,NA,AN(IDXA),Y(1,IMI2),
     1                  W1,M,AM,BM,CM,WD,WW,WU)
  137       IF (IPI2-NM) 140,140,138
  138       DO 139 J=1,M
               W2(J) = 0.
  139       CONTINUE
            GO TO 141
  140       CALL PRDCT (NP1,B(IP1),0,DUM,0,DUM,NC,CN(IDXC),Y(1,IPI2),
     1                  W2,M,AM,BM,CM,WD,WW,WU)
  141       DO 142 J=1,M
               W1(J) = Y(J,I)+W1(J)+W2(J)
  142       CONTINUE
            CALL PRDCT (NZ,B(IZ),NM1,B(IM1),NP1,B(IP1),0,DUM,W1,Y(1,I),
     1                  M,AM,BM,CM,WD,WW,WU)
  143    CONTINUE
  144 CONTINUE
      RETURN
      END
      FUNCTION BSRH (XLL,XRR,IZ,C,A,BH,F,SGN)
      DIMENSION       A(1)       ,C(1)       ,BH(1)
      COMMON /CBLKT/  NPP        ,K          ,EPS        ,CNV        ,
     1                NM         ,NCMPLX     ,IK
      XL = XLL
      XR = XRR
      DX = .5*ABS(XR-XL)
  101 X = .5*(XL+XR)
      IF (SGN*F(X,IZ,C,A,BH)) 103,105,102
  102 XR = X
      GO TO 104
  103 XL = X
  104 DX = .5*DX
      IF (DX-CNV) 105,105,101
  105 BSRH = .5*(XL+XR)
      RETURN
      END
      SUBROUTINE COMPB (N,IERROR,AN,BN,CN,B,AH,BH)
C
C     COMPB COMPUTES THE ROOTS OF THE B POLYNOMIALS USING SUBROUTINE
C     TEVLS WHICH IS A MODIFICATION THE EISPACK PROGRAM TQLRAT.
C     IERROR IS SET TO 4 IF EITHER TEVLS FAILS OR IF A(J+1)*C(J) IS
C     LESS THAN ZERO FOR SOME J.  AH,BH ARE TEMPORARY WORK ARRAYS.
C
      DIMENSION       AN(1)      ,BN(1)      ,CN(1)      ,B(1)       ,
     1                AH(1)      ,BH(1)
      COMMON /CBLKT/  NPP        ,K          ,EPS        ,CNV        ,
     1                NM         ,NCMPLX     ,IK
      EPS = EPMACH(DUM)
      BNORM = ABS(BN(1))
      DO 102 J=2,NM
         BNORM = AMAX1(BNORM,ABS(BN(J)))
         ARG = AN(J)*CN(J-1)
         IF (ARG) 119,101,101
  101    B(J) = SIGN(SQRT(ARG),AN(J))
  102 CONTINUE
      CNV = EPS*BNORM
      IF = 2**K
      KDO = K-1
      DO 108 L=1,KDO
         IR = L-1
         I2 = 2**IR
         I4 = I2+I2
         IPL = I4-1
         IFD = IF-I4
         DO 107 I=I4,IFD,I4
            CALL INDXB (I,L,IB,NB)
            IF (NB) 108,108,103
  103       JS = I-IPL
            JF = JS+NB-1
            LS = 0
            DO 104 J=JS,JF
               LS = LS+1
               BH(LS) = BN(J)
               AH(LS) = B(J)
  104       CONTINUE
            CALL TEVLS (NB,BH,AH,IERROR)
            IF (IERROR) 118,105,118
  105       LH = IB-1
            DO 106 J=1,NB
               LH = LH+1
               B(LH) = -BH(J)
  106       CONTINUE
  107    CONTINUE
  108 CONTINUE
      DO 109 J=1,NM
         B(J) = -BN(J)
  109 CONTINUE
      IF (NPP) 117,110,117
  110 NMP = NM+1
      NB = NM+NMP
      DO 112 J=1,NB
         L1 = MOD(J-1,NMP)+1
         L2 = MOD(J+NM-1,NMP)+1
         ARG = AN(L1)*CN(L2)
         IF (ARG) 119,111,111
  111    BH(J) = SIGN(SQRT(ARG),-AN(L1))
         AH(J) = -BN(L1)
  112 CONTINUE
      CALL TEVLS (NB,AH,BH,IERROR)
      IF (IERROR) 118,113,118
  113 CALL INDXB (IF,K-1,J2,LH)
      CALL INDXB (IF/2,K-1,J1,LH)
      J2 = J2+1
      LH = J2
      N2M2 = J2+NM+NM-2
  114 D1 = ABS(B(J1)-B(J2-1))
      D2 = ABS(B(J1)-B(J2))
      D3 = ABS(B(J1)-B(J2+1))
      IF ((D2 .LT. D1) .AND. (D2 .LT. D3)) GO TO 115
      B(LH) = B(J2)
      J2 = J2+1
      LH = LH+1
      IF (J2-N2M2) 114,114,116
  115 J2 = J2+1
      J1 = J1+1
      IF (J2-N2M2) 114,114,116
  116 B(LH) = B(N2M2+1)
      CALL INDXB (IF,K-1,J1,J2)
      J2 = J1+NMP+NMP
      CALL PPADD (NM+1,IERROR,AN,CN,B(J1),B(J1),B(J2))
  117 RETURN
  118 IERROR = 4
      RETURN
  119 IERROR = 5
      RETURN
      END
      SUBROUTINE CPROD (ND,BD,NM1,BM1,NM2,BM2,NA,AA,X,YY,M,A,B,C,D,W,Y)
C
C PROD APPLIES A SEQUENCE OF MATRIX OPERATIONS TO THE VECTOR X AND
C STORES THE RESULT IN YY           (COMPLEX CASE)
C AA   ARRAY CONTAINING SCALAR MULTIPLIERS OF THE VECTOR X
C ND,NM1,NM2 ARE THE LENGTHS OF THE ARRAYS BD,BM1,BM2 RESPECTIVELY
C BD,BM1,BM2 ARE ARRAYS CONTAINING ROOTS OF CERTIAN B POLYNOMIALS
C NA IS THE LENGTH OF THE ARRAY AA
C X,YY THE MATRIX OPERATIONS ARE APPLIED TO X AND THE RESULT IS YY
C A,B,C  ARE ARRAYS WHICH CONTAIN THE TRIDIAGONAL MATRIX
C M  IS THE ORDER OF THE MATRIX
C D,W,Y ARE WORKING ARRAYS
C ISGN  DETERMINES WHETHER OR NOT A CHANGE IN SIGN IS MADE
C
      COMPLEX         Y          ,D          ,W          ,BD         ,
     1                CRT        ,DEN        ,Y1         ,Y2
      DIMENSION       A(1)       ,B(1)       ,C(1)       ,X(1)       ,
     1                Y(1)       ,D(1)       ,W(1)       ,BD(1)      ,
     2                BM1(1)     ,BM2(1)     ,AA(1)      ,YY(1)
      DO 101 J=1,M
         Y(J) = CMPLX(X(J),0.)
  101 CONTINUE
      MM = M-1
      ID = ND
      M1 = NM1
      M2 = NM2
      IA = NA
  102 IFLG = 0
      IF (ID) 109,109,103
  103 CRT = BD(ID)
      ID = ID-1
C
C BEGIN SOLUTION TO SYSTEM
C
      D(M) = A(M)/(B(M)-CRT)
      W(M) = Y(M)/(B(M)-CRT)
      DO 104 J=2,MM
         K = M-J
         DEN = B(K+1)-CRT-C(K+1)*D(K+2)
         D(K+1) = A(K+1)/DEN
         W(K+1) = (Y(K+1)-C(K+1)*W(K+2))/DEN
  104 CONTINUE
      DEN = B(1)-CRT-C(1)*D(2)
      IF (CABS(DEN)) 105,106,105
  105 Y(1) = (Y(1)-C(1)*W(2))/DEN
      GO TO 107
  106 Y(1) = (1.,0.)
  107 DO 108 J=2,M
         Y(J) = W(J)-D(J)*Y(J-1)
  108 CONTINUE
  109 IF (M1) 110,110,112
  110 IF (M2) 121,121,111
  111 RT = BM2(M2)
      M2 = M2-1
      GO TO 117
  112 IF (M2) 113,113,114
  113 RT = BM1(M1)
      M1 = M1-1
      GO TO 117
  114 IF (ABS(BM1(M1))-ABS(BM2(M2))) 116,116,115
  115 RT = BM1(M1)
      M1 = M1-1
      GO TO 117
  116 RT = BM2(M2)
      M2 = M2-1
  117 Y1 = (B(1)-RT)*Y(1)+C(1)*Y(2)
      IF (MM-2) 120,118,118
C
C MATRIX MULTIPLICATION
C
  118 DO 119 J=2,MM
         Y2 = A(J)*Y(J-1)+(B(J)-RT)*Y(J)+C(J)*Y(J+1)
         Y(J-1) = Y1
         Y1 = Y2
  119 CONTINUE
  120 Y(M) = A(M)*Y(M-1)+(B(M)-RT)*Y(M)
      Y(M-1) = Y1
      IFLG = 1
      GO TO 102
  121 IF (IA) 124,124,122
  122 RT = AA(IA)
      IA = IA-1
      IFLG = 1
C
C SCALAR MULTIPLICATION
C
      DO 123 J=1,M
         Y(J) = RT*Y(J)
  123 CONTINUE
  124 IF (IFLG) 125,125,102
  125 DO 126 J=1,M
         YY(J) = REAL(Y(J))
  126 CONTINUE
      RETURN
      END
      SUBROUTINE CPRODP (ND,BD,NM1,BM1,NM2,BM2,NA,AA,X,YY,M,A,B,C,D,U,Y)
C
C PRODP APPLIES A SEQUENCE OF MATRIX OPERATIONS TO THE VECTOR X AND
C STORES THE RESULT IN YY       PERIODIC BOUNDARY CONDITIONS
C AND  COMPLEX  CASE
C
C BD,BM1,BM2 ARE ARRAYS CONTAINING ROOTS OF CERTIAN B POLYNOMIALS
C ND,NM1,NM2 ARE THE LENGTHS OF THE ARRAYS BD,BM1,BM2 RESPECTIVELY
C AA   ARRAY CONTAINING SCALAR MULTIPLIERS OF THE VECTOR X
C NA IS THE LENGTH OF THE ARRAY AA
C X,YY THE MATRIX OPERATIONS ARE APPLIED TO X AND THE RESULT IS YY
C A,B,C  ARE ARRAYS WHICH CONTAIN THE TRIDIAGONAL MATRIX
C M  IS THE ORDER OF THE MATRIX
C D,U,Y ARE WORKING ARRAYS
C ISGN  DETERMINES WHETHER OR NOT A CHANGE IN SIGN IS MADE
C
      COMPLEX         Y          ,D          ,U          ,V          ,
     1                DEN        ,BH         ,YM         ,AM         ,
     2                Y1         ,Y2         ,YH         ,BD         ,
     3                CRT
      DIMENSION       A(1)       ,B(1)       ,C(1)       ,X(1)       ,
     1                Y(1)       ,D(1)       ,U(1)       ,BD(1)      ,
     2                BM1(1)     ,BM2(1)     ,AA(1)      ,YY(1)
      DO 101 J=1,M
         Y(J) = CMPLX(X(J),0.)
  101 CONTINUE
      MM = M-1
      MM2 = M-2
      ID = ND
      M1 = NM1
      M2 = NM2
      IA = NA
  102 IFLG = 0
      IF (ID) 111,111,103
  103 CRT = BD(ID)
      ID = ID-1
      IFLG = 1
C
C BEGIN SOLUTION TO SYSTEM
C
      BH = B(M)-CRT
      YM = Y(M)
      DEN = B(1)-CRT
      D(1) = C(1)/DEN
      U(1) = A(1)/DEN
      Y(1) = Y(1)/DEN
      V = CMPLX(C(M),0.)
      IF (MM2-2) 106,104,104
  104 DO 105 J=2,MM2
         DEN = B(J)-CRT-A(J)*D(J-1)
         D(J) = C(J)/DEN
         U(J) = -A(J)*U(J-1)/DEN
         Y(J) = (Y(J)-A(J)*Y(J-1))/DEN
         BH = BH-V*U(J-1)
         YM = YM-V*Y(J-1)
         V = -V*D(J-1)
  105 CONTINUE
  106 DEN = B(M-1)-CRT-A(M-1)*D(M-2)
      D(M-1) = (C(M-1)-A(M-1)*U(M-2))/DEN
      Y(M-1) = (Y(M-1)-A(M-1)*Y(M-2))/DEN
      AM = A(M)-V*D(M-2)
      BH = BH-V*U(M-2)
      YM = YM-V*Y(M-2)
      DEN = BH-AM*D(M-1)
      IF (CABS(DEN)) 107,108,107
  107 Y(M) = (YM-AM*Y(M-1))/DEN
      GO TO 109
  108 Y(M) = (1.,0.)
  109 Y(M-1) = Y(M-1)-D(M-1)*Y(M)
      DO 110 J=2,MM
         K = M-J
         Y(K) = Y(K)-D(K)*Y(K+1)-U(K)*Y(M)
  110 CONTINUE
  111 IF (M1) 112,112,114
  112 IF (M2) 123,123,113
  113 RT = BM2(M2)
      M2 = M2-1
      GO TO 119
  114 IF (M2) 115,115,116
  115 RT = BM1(M1)
      M1 = M1-1
      GO TO 119
  116 IF (ABS(BM1(M1))-ABS(BM2(M2))) 118,118,117
  117 RT = BM1(M1)
      M1 = M1-1
      GO TO 119
  118 RT = BM2(M2)
      M2 = M2-1
C
C MATRIX MULTIPLICATION
C
  119 YH = Y(1)
      Y1 = (B(1)-RT)*Y(1)+C(1)*Y(2)+A(1)*Y(M)
      IF (MM-2) 122,120,120
  120 DO 121 J=2,MM
         Y2 = A(J)*Y(J-1)+(B(J)-RT)*Y(J)+C(J)*Y(J+1)
         Y(J-1) = Y1
         Y1 = Y2
  121 CONTINUE
  122 Y(M) = A(M)*Y(M-1)+(B(M)-RT)*Y(M)+C(M)*YH
      Y(M-1) = Y1
      IFLG = 1
      GO TO 102
  123 IF (IA) 126,126,124
  124 RT = AA(IA)
      IA = IA-1
      IFLG = 1
C
C SCALAR MULTIPLICATION
C
      DO 125 J=1,M
         Y(J) = RT*Y(J)
  125 CONTINUE
  126 IF (IFLG) 127,127,102
  127 DO 128 J=1,M
         YY(J) = REAL(Y(J))
  128 CONTINUE
      RETURN
      END
      FUNCTION EPMACH (DUM)
C
C     THIS PROGRAM COMPUTES AN APPROXIMATE MACHIINE EPSILON (ACCURACY)
C
      COMMON /VALUE/  V
      EPS = 1.
  101 EPS = EPS/10.
      CALL STORE (EPS+1.)
      IF (V-1.) 102,102,101
  102 EPMACH = 100.*EPS
      RETURN
      END
      SUBROUTINE INDXA (I,IR,IDXA,NA)
      COMMON /CBLKT/  NPP        ,K          ,EPS        ,CNV        ,
     1                NM         ,NCMPLX     ,IK
      NA = 2**IR
      IDXA = I-NA+1
      IF (I-NM) 102,102,101
  101 NA = 0
  102 RETURN
      END
      SUBROUTINE INDXB (I,IR,IDX,IDP)
C
C B(IDX) IS THE LOCATION OF THE FIRST ROOT OF THE B(I,IR) POLYNOMIAL
C
      COMMON /CBLKT/  NPP        ,K          ,EPS        ,CNV        ,
     1                NM         ,NCMPLX     ,IK
      IDP = 0
      IF (IR) 107,101,103
  101 IF (I-NM) 102,102,107
  102 IDX = I
      IDP = 1
      RETURN
  103 IZH = 2**IR
      ID = I-IZH-IZH
      IDX = ID+ID+(IR-1)*IK+IR+(IK-I)/IZH+4
      IPL = IZH-1
      IDP = IZH+IZH-1
      IF (I-IPL-NM) 105,105,104
  104 IDP = 0
      RETURN
  105 IF (I+IPL-NM) 107,107,106
  106 IDP = NM+IPL-I+1
  107 RETURN
      END
      SUBROUTINE INDXC (I,IR,IDXC,NC)
      COMMON /CBLKT/  NPP        ,K          ,EPS        ,CNV        ,
     1                NM         ,NCMPLX     ,IK
      NC = 2**IR
      IDXC = I
      IF (IDXC+NC-1-NM) 102,102,101
  101 NC = 0
  102 RETURN
      END
      SUBROUTINE PPADD (N,IERROR,A,C,CBP,BP,BH)
C
C     PPADD COMPUTES THE EIGENVALUES OF THE PERIODIC TRIDIAGONAL MATRIX
C     WITH COEFFICIENTS AN,BN,CN
C
C N IS THE ORDER OF THE BH AND BP POLYNOMIALS
C     ON OUTPUT BP CONTIANS THE EIGENVALUES
C CBP IS THE SAME AS BP EXCEPT TYPE COMPLEX
C BH IS USED TO TEMPORARILY STORE THE ROOTS OF THE B HAT POLYNOMIAL
C WHICH ENTERS THROUGH BP
C
      COMPLEX         CF         ,CX         ,FSG        ,HSG        ,
     1                DD         ,F          ,FP         ,FPP        ,
     2                CDIS       ,R1         ,R2         ,R3         ,
     3                CBP
      DIMENSION       A(1)       ,C(1)       ,BP(1)      ,BH(1)      ,
     1                CBP(1)
      COMMON /CBLKT/  NPP        ,K          ,EPS        ,CNV        ,
     1                NM         ,NCMPLX     ,IK
      EXTERNAL        PSGF       ,PPSPF      ,PPSGF
      SCNV = SQRT(CNV)
      IZ = N
      IZM = IZ-1
      IZM2 = IZ-2
      IF (BP(N)-BP(1)) 101,142,103
  101 DO 102 J=1,N
         NT = N-J
         BH(J) = BP(NT+1)
  102 CONTINUE
      GO TO 105
  103 DO 104 J=1,N
         BH(J) = BP(J)
  104 CONTINUE
  105 NCMPLX = 0
      MODIZ = MOD(IZ,2)
      IS = 1
      IF (MODIZ) 106,107,106
  106 IF (A(1)) 110,142,107
  107 XL = BH(1)
      DB = BH(3)-BH(1)
  108 XL = XL-DB
      IF (PSGF(XL,IZ,C,A,BH)) 108,108,109
  109 SGN = -1.
      CBP(1) = CMPLX(BSRH(XL,BH(1),IZ,C,A,BH,PSGF,SGN),0.)
      IS = 2
  110 IF = IZ-1
      IF (MODIZ) 111,112,111
  111 IF (A(1)) 112,142,115
  112 XR = BH(IZ)
      DB = BH(IZ)-BH(IZ-2)
  113 XR = XR+DB
      IF (PSGF(XR,IZ,C,A,BH)) 113,114,114
  114 SGN = 1.
      CBP(IZ) = CMPLX(BSRH(BH(IZ),XR,IZ,C,A,BH,PSGF,SGN),0.)
      IF = IZ-2
  115 DO 136 IG=IS,IF,2
         XL = BH(IG)
         XR = BH(IG+1)
         SGN = -1.
         XM = BSRH(XL,XR,IZ,C,A,BH,PPSPF,SGN)
         PSG = PSGF(XM,IZ,C,A,BH)
         IF (ABS(PSG)-EPS) 118,118,116
  116    IF (PSG*PPSGF(XM,IZ,C,A,BH)) 117,118,119
C
C     CASE OF A REAL ZERO
C
  117    SGN = 1.
         CBP(IG) = CMPLX(BSRH(BH(IG),XM,IZ,C,A,BH,PSGF,SGN),0.)
         SGN = -1.
         CBP(IG+1) = CMPLX(BSRH(XM,BH(IG+1),IZ,C,A,BH,PSGF,SGN),0.)
         GO TO 136
C
C     CASE OF A MULTIPLE ZERO
C
  118    CBP(IG) = CMPLX(XM,0.)
         CBP(IG+1) = CMPLX(XM,0.)
         GO TO 136
C
C     CASE OF A COMPLEX ZERO
C
  119    IT = 0
         ICV = 0
         CX = CMPLX(XM,0.)
  120    FSG = (1.,0.)
         HSG = (1.,0.)
         FP = (0.,0.)
         FPP = (0.,0.)
         DO 121 J=1,IZ
            DD = 1./(CX-BH(J))
            FSG = FSG*A(J)*DD
            HSG = HSG*C(J)*DD
            FP = FP+DD
            FPP = FPP-DD*DD
  121    CONTINUE
         IF (MODIZ) 123,122,123
  122    F = (1.,0.)-FSG-HSG
         GO TO 124
  123    F = (1.,0.)+FSG+HSG
  124    I3 = 0
         IF (CABS(FP)) 126,126,125
  125    I3 = 1
         R3 = -F/FP
  126    I2 = 0
         IF (CABS(FPP)) 132,132,127
  127    I2 = 1
         CDIS = CSQRT(FP**2-2.*F*FPP)
         R1 = CDIS-FP
         R2 = -FP-CDIS
         IF (CABS(R1)-CABS(R2)) 129,129,128
  128    R1 = R1/FPP
         GO TO 130
  129    R1 = R2/FPP
  130    R2 = 2.*F/FPP/R1
         IF (CABS(R2) .LT. CABS(R1)) R1 = R2
         IF (I3) 133,133,131
  131    IF (CABS(R3) .LT. CABS(R1)) R1 = R3
         GO TO 133
  132    R1 = R3
  133    CX = CX+R1
         IT = IT+1
         IF (IT .GT. 50) GO TO 142
         IF (CABS(R1) .GT. SCNV) GO TO 120
         IF (ICV) 134,134,135
  134    ICV = 1
         GO TO 120
  135    CBP(IG) = CX
         CBP(IG+1) = CONJG(CX)
  136 CONTINUE
      IF (CABS(CBP(N))-CABS(CBP(1))) 137,142,139
  137 NHALF = N/2
      DO 138 J=1,NHALF
         NT = N-J
         CX = CBP(J)
         CBP(J) = CBP(NT+1)
         CBP(NT+1) = CX
  138 CONTINUE
  139 NCMPLX = 1
      DO 140 J=2,IZ
         IF (AIMAG(CBP(J))) 143,140,143
  140 CONTINUE
      NCMPLX = 0
      DO 141 J=2,IZ
         BP(J) = REAL(CBP(J))
  141 CONTINUE
      GO TO 143
  142 IERROR = 4
  143 CONTINUE
      RETURN
      END
      FUNCTION PPSGF (X,IZ,C,A,BH)
      DIMENSION       A(1)       ,C(1)       ,BH(1)
      SUM = 0.
      DO 101 J=1,IZ
         SUM = SUM-1./(X-BH(J))**2
  101 CONTINUE
      PPSGF = SUM
      RETURN
      END
      FUNCTION PPSPF (X,IZ,C,A,BH)
      DIMENSION       A(1)       ,C(1)       ,BH(1)
      SUM = 0.
      DO 101 J=1,IZ
         SUM = SUM+1./(X-BH(J))
  101 CONTINUE
      PPSPF = SUM
      RETURN
      END
      SUBROUTINE PROD (ND,BD,NM1,BM1,NM2,BM2,NA,AA,X,Y,M,A,B,C,D,W,U)
C
C PROD APPLIES A SEQUENCE OF MATRIX OPERATIONS TO THE VECTOR X AND
C STORES THE RESULT IN Y
C BD,BM1,BM2 ARE ARRAYS CONTAINING ROOTS OF CERTIAN B POLYNOMIALS
C ND,NM1,NM2 ARE THE LENGTHS OF THE ARRAYS BD,BM1,BM2 RESPECTIVELY
C AA   ARRAY CONTAINING SCALAR MULTIPLIERS OF THE VECTOR X
C NA IS THE LENGTH OF THE ARRAY AA
C X,Y  THE MATRIX OPERATIONS ARE APPLIED TO X AND THE RESULT IS Y
C A,B,C  ARE ARRAYS WHICH CONTAIN THE TRIDIAGONAL MATRIX
C M  IS THE ORDER OF THE MATRIX
C D,W,U ARE WORKING ARRAYS
C IS  DETERMINES WHETHER OR NOT A CHANGE IN SIGN IS MADE
C
      DIMENSION       A(1)       ,B(1)       ,C(1)       ,X(1)       ,
     1                Y(1)       ,D(1)       ,W(1)       ,BD(1)      ,
     2                BM1(1)     ,BM2(1)     ,AA(1)      ,U(1)
      DO 101 J=1,M
         W(J) = X(J)
         Y(J) = W(J)
  101 CONTINUE
      MM = M-1
      ID = ND
      IBR = 0
      M1 = NM1
      M2 = NM2
      IA = NA
  102 IF (IA) 105,105,103
  103 RT = AA(IA)
      IF (ND .EQ. 0) RT = -RT
      IA = IA-1
C
C SCALAR MULTIPLICATION
C
      DO 104 J=1,M
         Y(J) = RT*W(J)
  104 CONTINUE
  105 IF (ID) 125,125,106
  106 RT = BD(ID)
      ID = ID-1
      IF (ID .EQ. 0) IBR = 1
C
C BEGIN SOLUTION TO SYSTEM
C
      D(M) = A(M)/(B(M)-RT)
      W(M) = Y(M)/(B(M)-RT)
      DO 107 J=2,MM
         K = M-J
         DEN = B(K+1)-RT-C(K+1)*D(K+2)
         D(K+1) = A(K+1)/DEN
         W(K+1) = (Y(K+1)-C(K+1)*W(K+2))/DEN
  107 CONTINUE
      DEN = B(1)-RT-C(1)*D(2)
      W(1) = 1.
      IF (DEN) 108,109,108
  108 W(1) = (Y(1)-C(1)*W(2))/DEN
  109 DO 110 J=2,M
         W(J) = W(J)-D(J)*W(J-1)
  110 CONTINUE
      IF (NA) 113,113,102
  111 DO 112 J=1,M
         Y(J) = W(J)
  112 CONTINUE
      IBR = 1
      GO TO 102
  113 IF (M1) 114,114,115
  114 IF (M2) 111,111,120
  115 IF (M2) 117,117,116
  116 IF (ABS(BM1(M1))-ABS(BM2(M2))) 120,120,117
  117 IF (IBR) 118,118,119
  118 IF (ABS(BM1(M1)-BD(ID))-ABS(BM1(M1)-RT)) 111,119,119
  119 RT = RT-BM1(M1)
      M1 = M1-1
      GO TO 123
  120 IF (IBR) 121,121,122
  121 IF (ABS(BM2(M2)-BD(ID))-ABS(BM2(M2)-RT)) 111,122,122
  122 RT = RT-BM2(M2)
      M2 = M2-1
  123 DO 124 J=1,M
         Y(J) = Y(J)+RT*W(J)
  124 CONTINUE
      GO TO 102
  125 RETURN
      END
      SUBROUTINE PRODP (ND,BD,NM1,BM1,NM2,BM2,NA,AA,X,Y,M,A,B,C,D,U,W)
C
C PRODP APPLIES A SEQUENCE OF MATRIX OPERATIONS TO THE VECTOR X AND
C STORES THE RESULT IN Y        PERIODIC BOUNDARY CONDITIONS
C
C BD,BM1,BM2 ARE ARRAYS CONTAINING ROOTS OF CERTIAN B POLYNOMIALS
C ND,NM1,NM2 ARE THE LENGTHS OF THE ARRAYS BD,BM1,BM2 RESPECTIVELY
C AA   ARRAY CONTAINING SCALAR MULTIPLIERS OF THE VECTOR X
C NA IS THE LENGTH OF THE ARRAY AA
C X,Y  THE MATRIX OPERATIONS ARE APPLIED TO X AND THE RESULT IS Y
C A,B,C  ARE ARRAYS WHICH CONTAIN THE TRIDIAGONAL MATRIX
C M  IS THE ORDER OF THE MATRIX
C D,U,W ARE WORKING ARRAYS
C IS  DETERMINES WHETHER OR NOT A CHANGE IN SIGN IS MADE
C
      DIMENSION       A(1)       ,B(1)       ,C(1)       ,X(1)       ,
     1                Y(1)       ,D(1)       ,U(1)       ,BD(1)      ,
     2                BM1(1)     ,BM2(1)     ,AA(1)      ,W(1)
      DO 101 J=1,M
         Y(J) = X(J)
         W(J) = Y(J)
  101 CONTINUE
      MM = M-1
      MM2 = M-2
      ID = ND
      IBR = 0
      M1 = NM1
      M2 = NM2
      IA = NA
  102 IF (IA) 105,105,103
  103 RT = AA(IA)
      IF (ND .EQ. 0) RT = -RT
      IA = IA-1
      DO 104 J=1,M
         Y(J) = RT*W(J)
  104 CONTINUE
  105 IF (ID) 128,128,106
  106 RT = BD(ID)
      ID = ID-1
      IF (ID .EQ. 0) IBR = 1
C
C BEGIN SOLUTION TO SYSTEM
C
      BH = B(M)-RT
      YM = Y(M)
      DEN = B(1)-RT
      D(1) = C(1)/DEN
      U(1) = A(1)/DEN
      W(1) = Y(1)/DEN
      V = C(M)
      IF (MM2-2) 109,107,107
  107 DO 108 J=2,MM2
         DEN = B(J)-RT-A(J)*D(J-1)
         D(J) = C(J)/DEN
         U(J) = -A(J)*U(J-1)/DEN
         W(J) = (Y(J)-A(J)*W(J-1))/DEN
         BH = BH-V*U(J-1)
         YM = YM-V*W(J-1)
         V = -V*D(J-1)
  108 CONTINUE
  109 DEN = B(M-1)-RT-A(M-1)*D(M-2)
      D(M-1) = (C(M-1)-A(M-1)*U(M-2))/DEN
      W(M-1) = (Y(M-1)-A(M-1)*W(M-2))/DEN
      AM = A(M)-V*D(M-2)
      BH = BH-V*U(M-2)
      YM = YM-V*W(M-2)
      DEN = BH-AM*D(M-1)
      IF (DEN) 110,111,110
  110 W(M) = (YM-AM*W(M-1))/DEN
      GO TO 112
  111 W(M) = 1.
  112 W(M-1) = W(M-1)-D(M-1)*W(M)
      DO 113 J=2,MM
         K = M-J
         W(K) = W(K)-D(K)*W(K+1)-U(K)*W(M)
  113 CONTINUE
      IF (NA) 116,116,102
  114 DO 115 J=1,M
         Y(J) = W(J)
  115 CONTINUE
      IBR = 1
      GO TO 102
  116 IF (M1) 117,117,118
  117 IF (M2) 114,114,123
  118 IF (M2) 120,120,119
  119 IF (ABS(BM1(M1))-ABS(BM2(M2))) 123,123,120
  120 IF (IBR) 121,121,122
  121 IF (ABS(BM1(M1)-BD(ID))-ABS(BM1(M1)-RT)) 114,122,122
  122 RT = RT-BM1(M1)
      M1 = M1-1
      GO TO 126
  123 IF (IBR) 124,124,125
  124 IF (ABS(BM2(M2)-BD(ID))-ABS(BM2(M2)-RT)) 114,125,125
  125 RT = RT-BM2(M2)
      M2 = M2-1
  126 DO 127 J=1,M
         Y(J) = Y(J)+RT*W(J)
  127 CONTINUE
      GO TO 102
  128 RETURN
      END
      FUNCTION PSGF (X,IZ,C,A,BH)
      DIMENSION       A(1)       ,C(1)       ,BH(1)
      FSG = 1.
      HSG = 1.
      DO 101 J=1,IZ
         DD = 1./(X-BH(J))
         FSG = FSG*A(J)*DD
         HSG = HSG*C(J)*DD
  101 CONTINUE
      IF (MOD(IZ,2)) 103,102,103
  102 PSGF = 1.-FSG-HSG
      RETURN
  103 PSGF = 1.+FSG+HSG
      RETURN
      END
      SUBROUTINE STORE (X)
      COMMON /VALUE/  V
      V = X
      RETURN
      END
      SUBROUTINE TEVLS (N,D,E2,IERR)
C
      INTEGER         I          ,J          ,L          ,M          ,
     1                N          ,II         ,L1         ,MML        ,
     2                IERR
      REAL            D(N)       ,E2(N)
      REAL            B          ,C          ,F          ,G          ,
     1                H          ,P          ,R          ,S          ,
     2                MACHEP
C
C     REAL SQRT,ABS,SIGN
C
      COMMON /CBLKT/  NPP        ,K          ,MACHEP     ,CNV        ,
     1                NM         ,NCMPLX     ,IK
C
C     THIS SUBROUTINE IS A MODIFICATION OF THE EISPACK SUBROUTINE TQLRAT
C     ALGORITHM 464, COMM. ACM 16, 689(1973) BY REINSCH.
C
C     THIS SUBROUTINE FINDS THE EIGENVALUES OF A SYMMETRIC
C     TRIDIAGONAL MATRIX BY THE RATIONAL QL METHOD.
C
C     ON INPUT-
C
C        N IS THE ORDER OF THE MATRIX,
C
C        D CONTAINS THE DIAGONAL ELEMENTS OF THE INPUT MATRIX,
C
C        E2 CONTAINS THE                SUBDIAGONAL ELEMENTS OF THE
C          INPUT MATRIX IN ITS LAST N-1 POSITIONS.  E2(1) IS ARBITRARY.
C
C      ON OUTPUT-
C
C        D CONTAINS THE EIGENVALUES IN ASCENDING ORDER.  IF AN
C          ERROR EXIT IS MADE, THE EIGENVALUES ARE CORRECT AND
C          ORDERED FOR INDICES 1,2,...IERR-1, BUT MAY NOT BE
C          THE SMALLEST EIGENVALUES,
C
C        E2 HAS BEEN DESTROYED,
C
C        IERR IS SET TO
C          ZERO       FOR NORMAL RETURN,
C          J          IF THE J-TH EIGENVALUE HAS NOT BEEN
C                     DETERMINED AFTER 30 ITERATIONS.
C
C     QUESTIONS AND COMMENTS SHOULD BE DIRECTED TO B. S. GARBOW,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C
C
C     ********** MACHEP IS A MACHINE DEPENDENT PARAMETER SPECIFYING
C                THE RELATIVE PRECISION OF FLOATING POINT ARITHMETIC.
C
C                **********
C
      IERR = 0
      IF (N .EQ. 1) GO TO 115
C
      DO 101 I=2,N
         E2(I-1) = E2(I)*E2(I)
  101 CONTINUE
C
      F = 0.0
      B = 0.0
      E2(N) = 0.0
C
      DO 112 L=1,N
         J = 0
         H = MACHEP*(ABS(D(L))+SQRT(E2(L)))
         IF (B .GT. H) GO TO 102
         B = H
         C = B*B
C
C     ********** LOOK FOR SMALL SQUARED SUB-DIAGONAL ELEMENT **********
C
  102    DO 103 M=L,N
            IF (E2(M) .LE. C) GO TO 104
C
C     ********** E2(N) IS ALWAYS ZERO, SO THERE IS NO EXIT
C                THROUGH THE BOTTOM OF THE LOOP **********
C
  103    CONTINUE
C
  104    IF (M .EQ. L) GO TO 108
  105    IF (J .EQ. 30) GO TO 114
         J = J+1
C
C     ********** FORM SHIFT **********
C
         L1 = L+1
         S = SQRT(E2(L))
         G = D(L)
         P = (D(L1)-G)/(2.0*S)
         R = SQRT(P*P+1.0)
         D(L) = S/(P+SIGN(R,P))
         H = G-D(L)
C
         DO 106 I=L1,N
            D(I) = D(I)-H
  106    CONTINUE
C
         F = F+H
C
C     ********** RATIONAL QL TRANSFORMATION **********
C
         G = D(M)
         IF (G .EQ. 0.0) G = B
         H = G
         S = 0.0
         MML = M-L
C
C     ********** FOR I=M-1 STEP -1 UNTIL L DO -- **********
C
         DO 107 II=1,MML
            I = M-II
            P = G*H
            R = P+E2(I)
            E2(I+1) = S*R
            S = E2(I)/R
            D(I+1) = H+S*(H+D(I))
            G = D(I)-E2(I)/G
            IF (G .EQ. 0.0) G = B
            H = G*P/R
  107    CONTINUE
C
         E2(L) = S*G
         D(L) = H
C
C     ********** GUARD AGAINST UNDERFLOWED H **********
C
         IF (H .EQ. 0.0) GO TO 108
         IF (ABS(E2(L)) .LE. ABS(C/H)) GO TO 108
         E2(L) = H*E2(L)
         IF (E2(L) .NE. 0.0) GO TO 105
  108    P = D(L)+F
C
C     ********** ORDER EIGENVALUES **********
C
         IF (L .EQ. 1) GO TO 110
C
C     ********** FOR I=L STEP -1 UNTIL 2 DO -- **********
C
         DO 109 II=2,L
            I = L+2-II
            IF (P .GE. D(I-1)) GO TO 111
            D(I) = D(I-1)
  109    CONTINUE
C
  110    I = 1
  111    D(I) = P
  112 CONTINUE
C
      IF (ABS(D(N)) .GE. ABS(D(1))) GO TO 115
      NHALF = N/2
      DO 113 I=1,NHALF
         NTOP = N-I
         DHOLD = D(I)
         D(I) = D(NTOP+1)
         D(NTOP+1) = DHOLD
  113 CONTINUE
      GO TO 115
C
C     ********** SET ERROR -- NO CONVERGENCE TO AN
C                EIGENVALUE AFTER 30 ITERATIONS **********
C
  114 IERR = L
  115 RETURN
C
C     ********** LAST CARD OF TQLRAT **********
C
      END

      SUBROUTINE matrix(A,B,C,RHS)

      IMPLICIT NONE

      INCLUDE 'param.txt'
      INTEGER jmaxm1,jmaxm2

      REAL    A(imax,jmax),B(imax,jmax),C(imax,jmax),RHS(imax,jmax),
     +        D(imax,jmax),tmpvar(imax)

c-----------------------------------------------------------------------

c *** Define two work variables for array indices:

      jmaxm1 = jmax - 1
      jmaxm2 = jmax - 2

c*********************************************************************
c
c     Subroutine matrix solves the set of linear equations:
c
c       Matrix (X) = (Right-hand side vektor)
c
c     on input:
c
c         A : matrix elements of the first diagonal of the matrix
c         B : matrix elements of the second diagonal of the matrix
c         C : matrix elements of the third diagonal of the matrix
c       RHS : right-hand side vektor
c
c     on output:
c
c       RHS : solution vektor (X)
c
c     Note: using the i-index as an inner-loop makes vectorization
c           possible without problems.
c
c*********************************************************************

c *** Fill the 2 work array's tmpvar and D:

c     -------------------------------------------start i-loop
      do 100 i=1,imax

c *** In the lower-left corner:

        tmpvar(i) = C(i,jmax)

c *** In the upper right corner:

        D(i,1)    = A(i,1)

100   continue
c     -------------------------------------------start i-loop

c *** Now reduce the matrix to an upper triangular matrix.
c *** Exceptions are made for the indices j=jmax-1 and j=jmax.
c *** They are treated within another loop.

c     -------------------------------------------start j-loop
      do 350 j=1,jmax-3
c     -------------------------------------------start i-loop
         do 450 i=1,imax

c ***    Elimination of element A(i,j+1) ----> A(i,j+1) = 0.0

         B(i,j+1)   =  B(i,j+1)   - (A(i,j+1)/B(i,j))  * C(i,j)

         RHS(i,j+1) =  RHS(i,j+1) - (A(i,j+1)/B(i,j))  * RHS(i,j)

         D(i,j+1)   =             - (A(i,j+1)/B(i,j))  * D(i,j)

c ***    Elimination of element tmpvar(i) ----> tmpvar(i) = 0.0
c ***    (This action moves tmpvar(i) from position j=j to j=j+1)

         RHS(i,jmax) =  RHS(i,jmax)  - (tmpvar(i)/B(i,j)) * RHS(i,j)

         B(i,jmax)   =  B(i,jmax)    - (tmpvar(i)/B(i,j)) * D(i,j)

         tmpvar(i)   =               - (tmpvar(i)/B(i,j)) * C(i,j)

450      continue
c     -------------------------------------------end i-loop
350   continue
c     -------------------------------------------end j-loop

c *** Now we arrive at the lower-right corner of the matrix which
c *** gets a special treatment.

c     -------------------------------------------start i-loop
      do 550 i=1,imax

c *** Elimination of element A(i,jmaxm1) ----> A(i,jmaxm1) = 0.0

      B(i,jmaxm1)   = B(i,jmaxm1)   - ( A(i,jmaxm1)/B(i,jmaxm2) ) *
     +                                  C(i,jmaxm2)

      C(i,jmaxm1)   = C(i,jmaxm1)   - ( A(i,jmaxm1)/B(i,jmaxm2) ) *
     +                                  D(i,jmaxm2)

      RHS(i,jmaxm1) = RHS(i,jmaxm1) - ( A(i,jmaxm1)/B(i,jmaxm2) ) *
     +                                  RHS(i,jmaxm2)

c *** Now the last row of the matrix is updated because of the
c *** periodicity of the problem.

c *** Elimination of element tmpvar(i) ----> tmpvar(i) = 0.0
c *** (This action removes tmpvar(i) from position j=jmaxm2)

      A(i,jmax)   = A(i,jmax)   - (tmpvar(i)/B(i,jmaxm2))*C(i,jmaxm2)

      B(i,jmax)   = B(i,jmax)   - (tmpvar(i)/B(i,jmaxm2))*D(i,jmaxm2)

      RHS(i,jmax) = RHS(i,jmax) - (tmpvar(i)/B(i,jmaxm2))*RHS(i,jmaxm2)

c *** As a last step in the procedure of reducing the matrix to an
c *** upper triangular matrix, the last row is now treated in the
c *** "standard" way.

c *** Final elimination of element A(i,jmax) ----> A(i,jmax) = 0.0

      B(i,jmax)   = B(i,jmax)   - (A(i,jmax)/B(i,jmaxm1))*C(i,jmaxm1)

      RHS(i,jmax) = RHS(i,jmax) - (A(i,jmax)/B(i,jmaxm1))*RHS(i,jmaxm1)

c *** The matrix is now completely reduced to an upper matrix and the
c *** solution can be obtained by backward substitution starting with
c *** the element with the highest index (j=jmax):

      RHS(i,jmax) = RHS(i,jmax) / B(i,jmax)

c *** Calculate the solution member with the one-but-highest index:

      RHS(i,jmaxm1) = ( RHS(i,jmaxm1) - C(i,jmaxm1) * RHS(i,jmax) ) /
     +                  B(i,jmaxm1)

550   continue
c     -------------------------------------------end i-loop

c *** All other solution members (j=jmax-2 until j=1) can be obtained
c *** within one loop:

      DO j=jmax-2,1,-1
         DO i=1,imax

            RHS(i,j) = ( RHS(i,j) - C(i,j)*RHS(i,j+1) - D(i,j)*RHS(i
     $           ,jmax) )/ B(i,j)

         END DO
      END DO

c *** Now, the array RHS(i,j) contains the solution.

      RETURN
      END

      SUBROUTINE smagor(ib,ie,jb,je,kb,ke)

      IMPLICIT NONE

      INCLUDE 'param.txt'
      INCLUDE 'common.txt'

      INTEGER ib,ie,jb,je,kb,ke,ip,im,jp,jm,kp,km

      REAL athird
c-----------------------------------------------------------------------

c *** divergence of velocity ***

      DO k=kb,ke
         
         kp=k+1
         km=k-1

         DO j=jb,je

            jp=j+1
            jm=j-1

            DO i=ib,ie

               ip=i+1
               im=i-1

               div(i,j,k) = 
     1    ( ru(i)*unew(i,j,k) - ru(im)*unew(im,j,k) ) / 
     1              (rp(i)*(ru(i)-ru(im)))
     2 +  ( vnew(i,j,k) - vnew(i,jm,k) )              / 
     2              (rp(i)*dphi)        
     3 +  ( wnew(i,j,k) - wnew(i,j,km) )              /
     3              (zw(k) - zw(km))


               div(i,j,k) = 0.0


            END DO
         END DO
      END DO

c *** deviatoric strain rate tensor ***

      athird = 1.0/3.0

      DO k=kb,ke

         kp=k+1
         km=k-1

         DO j=jb,je

            jp=j+1
            jm=j-1

c *** Exclude i=1: considered i=1 apart at the end of the 300 loop

            DO i= 2,ie

               ip=i+1
               im=i-1

               drr(i,j,k) = ( unew(i,j,k)-unew(im,j,k) ) / (ru(i)-ru(im
     $              )) - athird*div(i,j,k)             

               doo(i,j,k) = ( (vnew(i,j,k)-vnew(i,jm,k)) / dphi +(unew(i
     $              ,j,k)+unew(im,j,k)) / 2.0 ) / rp(i) - athird*div(i,j
     $              ,k)

               dzz(i,j,k) = ( wnew(i,j,k) - wnew(i,j,km) ) / (zw(k)
     $              -zw(km)) - athird*div(i,j,k)


c *** r-theta (theta-r) strain ***


               dro(i,j,k) = 0.5 * 0.25 * (
     & ( ru(i) * ( vnew(ip,j,k)/rp(ip)  - vnew(i,j,k)/rp(i)   ) /
     &           ( Rp(ip) - Rp(i) )                             +
     &           ( unew(i,jp,k)         - unew(i,j,k)         ) /
     &           ( ru(i) * dphi )                               )
     &      +
     & ( ru(i) * ( vnew(ip,jm,k)/rp(ip) - vnew(i,jm,k)/rp(i)  ) /
     &           ( rp(ip) - rp(i) )                             +
     &           ( unew(i,j,k)          - unew(i,jm,k)        ) /
     &           ( ru(i) * dphi )                               )
     &      +
     & ( ru(im)* ( vnew(i,j,k)/rp(i)    - vnew(im,j,k)/rp(im) ) /
     &           ( rp(i) - rp(im) )                             +
     &           ( unew(im,jp,k)        - unew(im,j,k)        ) /
     &           ( ru(im) * dphi )                              )
     &      +
     & ( ru(im)* ( vnew(i,jm,k)/rp(i)   - vnew(im,jm,k)/rp(im)) /
     &           ( rp(i) - rp(im) )                             +
     &           ( unew(im,j,k)         - unew(im,jm,k)       ) /
     &           ( ru(im) * dphi )                              )
     &                       )

c *** theta-z (z-theta) strain ***


               doz(i,j,k) = 0.5 * 0.25 * (
     & (  ( wnew(i,jp,k)  - wnew(i,j,k)   ) / ( rp(i) * dphi )  +
     &    ( vnew(i,j,kp)  - vnew(i,j,k)   ) / ( zp(kp)-zp(k) )  )
     &      +
     & (  ( wnew(i,j,k)   - wnew(i,jm,k)  ) / ( rp(i) * dphi )  +
     &    ( vnew(i,jm,kp) - vnew(i,jm,k)  ) / ( zp(kp)-zp(k) )  )
     &      +
     & (  ( wnew(i,jp,km) - wnew(i,j,km)  ) / ( rp(i) * dphi )  +
     &    ( vnew(i,j,k)   - vnew(i,j,km)  ) / ( zp(k)-zp(km) )  )
     &      +
     & (  ( wnew(i,j,km)  - wnew(i,jm,km) ) / ( rp(i) * dphi )  +
     &    ( vnew(i,jm,k)  - vnew(i,jm,km) ) / ( zp(k)-zp(km) )  )
     &                       )


c *** r-z (z-r) strain ***


               drz(i,j,k) = 0.5 * 0.25 * (
     & (  ( wnew(ip,j,k)  - wnew(i,j,k)   ) / ( rp(ip)-rp(i) )  +
     &    ( unew(i,j,kp)  - unew(i,j,k)   ) / ( zp(kp)-zp(k) )  )
     &      +
     & (  ( wnew(ip,j,km) - wnew(i,j,km)  ) / ( rp(ip)-rp(i) )  +
     &    ( unew(i,j,k)   - unew(i,j,km)  ) / ( zp(k)-zp(km) )  )
     &      +
     & (  ( wnew(i,j,k)   - wnew(im,j,k)  ) / ( rp(i)-rp(im) )  +
     &    ( unew(im,j,kp) - unew(im,j,k)  ) / ( zp(kp)-zp(k) )  )
     &      +
     & (  ( wnew(i,j,km)  - wnew(im,j,km) ) / ( rp(i)-rp(im) )  +
     &    ( unew(im,j,k)  - unew(im,j,km) ) / ( zp(k)-zp(km) )  )
     &                       )

            END DO

c *** Consider i=1 as a special case because some stresses become zero
c *** at the centerline:

      im = 0
      i  = 1
      ip = 2

            drr(i,j,k) = ( unew(i,j,k)-unew(im,j,k) ) / (ru(i)-ru(im
     $         )) - athird*div(i,j,k)             

            doo(i,j,k) = ( (vnew(i,j,k)-vnew(i,jm,k)) / dphi +(unew(i
     $           ,j,k)+unew(im,j,k)) / 2.0 ) / rp(i) - athird*div(i,j
     $           ,k)

            dzz(i,j,k) = ( wnew(i,j,k) - wnew(i,j,km) ) / (zw(k)
     $           -zw(km)) - athird*div(i,j,k)


c *** r-theta (theta-r) strain ***


            dro(i,j,k) = 0.5 * 0.25 * (
     & ( ru(i) * ( vnew(ip,j,k)/rp(ip)  - vnew(i,j,k)/rp(i)   ) /
     &           ( rp(ip) - rp(i) )                             +
     &           ( unew(i,jp,k)         - unew(i,j,k)         ) /
     &           ( ru(i) * dphi )                               )
     &      +
     & ( ru(i) * ( vnew(ip,jm,k)/rp(ip) - vnew(i,jm,k)/rp(i)  ) /
     &           ( rp(ip) - rp(i) )                             +
     &           ( unew(i,j,k)          - unew(i,jm,k)        ) /
     &           ( ru(i) * dphi )                               )
cR=0 &      +
cR=0 & ( ru(im)* ( vnew(i,j,k)/rp(i)    - vnew(im,j,k)/rp(im) ) /
cR=0 &           ( rp(i) - rp(im) )                             +
cR=0 &           ( unew(im,jp,k)        - unew(im,j,k)        ) /
cR=0 &           ( ru(im) * dphi )                              )
cR=0 &      +
cR=0 & ( ru(im)* ( vnew(i,jm,k)/rp(i)   - vnew(im,jm,k)/rp(im)) /
cR=0 &           ( rp(i) - rp(im) )                             +
cR=0 &           ( unew(im,j,k)         - unew(im,jm,k)       ) /
cR=0 &           ( ru(im) * dphi )                              )
     &                       )


c *** theta-z (z-theta) strain ***


            doz(i,j,k) = 0.5 * 0.25 * (
     & (  ( wnew(i,jp,k)  - wnew(i,j,k)   ) / ( rp(i) * dphi )  +
     &    ( vnew(i,j,kp)  - vnew(i,j,k)   ) / ( zp(kp)-zp(k) )  )
     &      +
     & (  ( wnew(i,j,k)   - wnew(i,jm,k)  ) / ( rp(i) * dphi )  +
     &    ( vnew(i,jm,kp) - vnew(i,jm,k)  ) / ( zp(kp)-zp(k) )  )
     &      +
     & (  ( wnew(i,jp,km) - wnew(i,j,km)  ) / ( rp(i) * dphi )  +
     &    ( vnew(i,j,k)   - vnew(i,j,km)  ) / ( zp(k)-zp(km) )  )
     &      +
     & (  ( wnew(i,j,km)  - wnew(i,jm,km) ) / ( rp(i) * dphi )  +
     &    ( vnew(i,jm,k)  - vnew(i,jm,km) ) / ( zp(k)-zp(km) )  )
     &                       )

c *** r-z (z-r) strain ***


            drz(i,j,k) = 0.5 * 0.25 * (
     & (  ( wnew(ip,j,k)  - wnew(i,j,k)   ) / ( rp(ip)-rp(i) )  +
     &    ( unew(i,j,kp)  - unew(i,j,k)   ) / ( zp(kp)-zp(k) )  )
     &      +
     & (  ( wnew(ip,j,km) - wnew(i,j,km)  ) / ( rp(ip)-rp(i) )  +
     &    ( unew(i,j,k)   - unew(i,j,km)  ) / ( zp(k)-zp(km) )  )
cR=0 &      +
cR=0 & (  ( wnew(i,j,k)   - wnew(im,j,k)  ) / ( rp(i)-rp(im) )  +
cR=0 &    ( unew(im,j,kp) - unew(im,j,k)  ) / ( dz )            )
cR=0 &      +
cR=0 & (  ( wnew(i,j,km)  - wnew(im,j,km) ) / ( rp(i)-rp(im) )  +
cR=0 &    ( unew(im,j,k)  - unew(im,j,km) ) / ( dz )            )
     &                       )

         END DO

      END DO


c... compute |d_i,j| = sqrt(2*d_(i,j)*d_(i,j)) ... 
c... and mu_t = C_s * delta^2 * |d_i,j| = lmix(i,k)*magdij(i,j,k) 

      DO k=kb,ke
         DO j=jb,je
            DO i=ib,ie

               magdij(i,j,k) = SQRT( 2*drr(i,j,k)**2 + 2*doo(i,j,k)**2 +
     $              2*dzz(i,j,k)**2 + 4*dro(i,j,k)**2 + 4*doz(i,j,k)**2
     $              + 4*drz(i,j,k)**2 )
               
               mut(i,j,k) = lmix(i,k) * magdij(i,j,k)

            END DO
         END DO
      END DO

c*************************************************************
c
c     Set boundary boundary condition for K-closure factors.
c  
c     probably don't need to do this there because it's done
c     in the routine viscous, but what the hell.
c
c*************************************************************

      DO k=1,kmax

c *** Theta-direction ***

         DO i=1,imax

            mut(i,0,k)  = mut(i,jmax,k)
            mut(i,j1,k) = mut(i,1,k)

         END DO

c *** R-direction ***

         DO j=0,j1

            mut(0,j,k)  =   mut(1,j,k)
            mut(i1,j,k) = - mut(imax,j,k)

         END DO

      END DO

c *** Z-direction ***

      DO j=0,j1
         DO i=0,i1

            mut(i,j,0)  = mut(i,j,kmax)
            mut(i,j,k1) = mut(i,j,1)

         END DO
      END DO
      
      RETURN
      END

      SUBROUTINE advec2(ib,ie,jb,je,kb,ke)

      IMPLICIT NONE

      INCLUDE 'param.txt'
      INCLUDE 'common.txt'

      INTEGER  ib,ie,jb,je,kb,ke

c********************************************************************
c
c     Advec calculates the advection for all variables over the
c     indicated domain. The indices ib,ie,jb,je,kb and ke ("i,j,k" for
c     the direction and "b" and "e" for begin and end) determine the
c     points for which the advection is calculated.
c
c*********************************************************************


      CALL advu(dudtnm,unew,vnew,wnew,rhonew,ru,rp,dr,dphi,zw,zp,i1
     $     ,j1,k1,ib,ie,jb,je,kb,ke)

      CALL advv(dvdtnm,unew,vnew,wnew,rhonew,ru,rp,dr,dphi,zw,zp,i1
     $     ,j1,k1,ib,ie,jb,je,kb,ke)

      CALL advw(dwdtnm,unew,vnew,wnew,rhonew,ru,rp,dr,dphi,zw,zp
     $     ,i1,j1,k1,ib,ie,jb,je,kb,ke)

      CALL advt(dtdtnm,unew,vnew,wnew,rhonew,tnew,ru,rp,dr,dphi,zw,zp,i1
     $     ,j1,k1,ib,ie,jb,je,kb,ke)

      CALL advy(dydtnm,unew,vnew,wnew,rhonew,ynew,ru,rp,dr,dphi,zw,zp,i1
     $     ,j1,k1,ib,ie,jb,je,kb,ke)

      RETURN
      END

      SUBROUTINE update

      IMPLICIT NONE

      INCLUDE 'param.txt'
      INCLUDE 'common.txt'

c--------------------------------------------------------------------

      DO k=0,k1
         DO j=0,j1
            DO i=0,i1

               dudtnm(i,j,k) = dudtn(i,j,k)
               dvdtnm(i,j,k) = dvdtn(i,j,k)
               dwdtnm(i,j,k) = dwdtn(i,j,k)
               dtdtnm(i,j,k) = dtdtn(i,j,k)
               dydtnm(i,j,k) = dydtn(i,j,k)

               umold(i,j,k)  = umnew(i,j,k)
               vmold(i,j,k)  = vmnew(i,j,k)
               wmold(i,j,k)  = wmnew(i,j,k)
               ymold(i,j,k)  = ymnew(i,j,k)

               told(i,j,k)   = tnew(i,j,k)

            END DO
         END DO
      END DO


      DO k=0,k1
         DO j=0,j1
            DO i=0,i1

               rhold2(i,j,k) = rhold1(i,j,k)
               rhold1(i,j,k) = rhonew(i,j,k)

            END DO
         END DO
      END DO

      RETURN
      END

      SUBROUTINE dynamic(ib,ie,jb,je,kb,ke)

      IMPLICIT NONE

      INCLUDE 'param.txt'
      INCLUDE 'common.txt'

      INTEGER ib,ie,jb,je,kb,ke

      INTEGER l

      REAL uht(0:i1,0:j1,0:k1)
      REAL vht(0:i1,0:j1,0:k1)
      REAL wht(0:i1,0:j1,0:k1)

      REAL up(0:i1,0:j1,0:k1)
      REAL vp(0:i1,0:j1,0:k1)
      REAL wp(0:i1,0:j1,0:k1)

      REAL abr(6,0:i1,0:j1,0:k1)
      REAL magabr(0:i1,0:j1,0:k1)
      REAL aht(6,0:i1,0:j1,0:k1)
      REAL magaht(0:i1,0:j1,0:k1)
      REAL bbr(0:i1,0:j1,0:k1)
      REAL bht(0:i1,0:j1,0:k1)
      REAL mkldkl(0:i1,0:j1,0:k1)
      REAL lijdij(0:i1,0:j1,0:k1)

      REAL im,jm,km
      REAL tmp,sum1,sum2
c--------------------------------------------------------------------

c... first test-filter velocity field ...

      CALL filter(2,unew,uht,ru,i1,j1,k1,ib,ie,jb,je,kb,ke)
      CALL filter(2,vnew,vht,rp,i1,j1,k1,ib,ie,jb,je,kb,ke)
      CALL filter(2,wnew,wht,rp,i1,j1,k1,ib,ie,jb,je,kb,ke)





c      do i=1,imax,4
c         do j=1,jmax,4
c            do k=1,2

c               print*,1,i,j,k,unew(i,j,k),uht(i,j,k)
c               print*,2,i,j,k,vnew(i,j,k),vht(i,j,k)
c               print*,3,i,j,k,wnew(i,j,k),wht(i,j,k)

c            end do
c         end do
c      end do
c      stop
               




c... now set the boundary values for the test-filtered velocity field ...

      CALL bound(uht,vht,wht,tnew,ynew,rhonew,time,ijet,dt,zp,zw,0
     $     ,ru,rp)

c... compute d^bar_ij and |d^bar_ij| ...

      CALL deviatoric(abr,magabr,unew,vnew,wnew,ru,rp,dphi,zw,zp,i1,j1
     $     ,k1,ib,ie,jb,je,kb,ke)





c      print*,ijet
c      do i=1,imax
c         do j=1,jmax,4
c            write(*,20) i,j,abr(1,i,j,1),abr(2,i,j,1),abr(3,i,j,1)
c            write(*,20) i,j,abr(4,i,j,1),abr(5,i,j,1),abr(6,i,j,1)
c            write(*,21) i,j,magabr(i,j,1)
c 20         format(2(i4),3(f12.5))
c 21         format(2(i4),f12.5)
c         end do
c      end do
c      stop










c... compute d^bar^hat_ij and |d^bar^hat_ij| ...

      CALL deviatoric(aht,magaht,uht,vht,wht,ru,rp,dphi,zw,zp,i1,j1,k1
     $     ,ib,ie,jb,je,kb,ke)



c      do i=1,imax
c         do j=1,jmax,4
c            print*,i,j,aht(1,i,j,2),aht(2,i,j,2),aht(3,i,j,2)
c            print*,i,j,aht(4,i,j,2),aht(5,i,j,2),aht(6,i,j,2)
c            write(*,10) i,j,aht(2,i,j,1),abr(2,i,j,1),aht(3,i,j,1),abr(3
c     $           ,i,j,1)
c            write(*,10) i,j,aht(5,i,j,1),abr(5,i,j,1),aht(6,i,j,1),abr(5
c     $           ,i,j,1)
c 10         format(2(i4),4(f12.5))
c         end do
c      end do
c      stop





c... initialize M_kl * d^bar_kl and L_ij * d^bar_ij to zero ...

      DO i=0,i1
         DO j=0,j1
            DO k=0,k1

               mkldkl(i,j,k) = 0.0
               lijdij(i,j,k) = 0.0

            END DO
         END DO
      END DO

c... compute M_kl * d^bar_kl ...

      DO l=1,6

         DO i=1,imax
            DO j=0,j1
               DO k=1,kmax
                  bbr(i,j,k) = magabr(i,j,k)*abr(l,i,j,k)
               END DO
            END DO
         END DO

         CALL filter(2,bbr,bht,rp,i1,j1,k1,ib+1,ie-1,jb,je,kb+1,ke-1)





c      if(l .eq. 3)then
c      do i=1,imax
c         do j=1,jmax,4
c            write(*,30) i,j,bbr(i,j,2),bht(i,j,2)
c 30         format(2(i4),2(f12.5))
c         end do
c      end do
c      stop
c      end if







         tmp = 1.0
         IF(l .GT. 3) tmp = 2.0
         DO i=2,imax-1
            DO j=1,jmax
               DO k=2,kmax-1
               
                  mkldkl(i,j,k) = mkldkl(i,j,k) + tmp*((delht(i,k)
     $                 /delbr(i,k))*magaht(i,j,k)*aht(l,i,j,k)*abr(l,i,j
     $                 ,k) - bht(i,j,k)*aht(l,i,j,k))

               END DO
            END DO
         END DO






c      if(l .eq. 3)then
c      do i=2,imax-1,4
c         do j=1,jmax,4
c            do k=2,10
c               write(*,30) i,j,k,mkldkl(i,j,k)
c 30            format(3(i4),1(f12.5))
c            end do
c         end do
c      end do
c      stop
c      end if






         
      END DO

c... compute L_ij * d^bar_ij ...

c... interpolate velocities onto pressure nodes ...

      DO i=1,imax
         DO j=1,jmax
            DO k=1,kmax

               up(i,j,k) = 0.5*(unew(i,j,k) + unew(i-1,j,k))

               vp(i,j,k) = 0.5*(vnew(i,j,k) + vnew(i,j-1,k))

               wp(i,j,k) = 0.5*(wnew(i,j,k) + wnew(i,j,k-1))

            END DO
         END DO
      END DO

c... apply boundary conditions in theta direction ...

      DO i=1,imax
         DO k=1,kmax

            up(i,0,k)  = up(i,jmax,k)
            up(i,j1,k) = up(i,1,k)

            vp(i,0,k)  = vp(i,jmax,k)
            vp(i,j1,k) = vp(i,1,k)

            wp(i,0,k)  = wp(i,jmax,k)
            wp(i,j1,k) = wp(i,1,k)

         END DO
      END DO

c... test filter velocity fields ...

      CALL filter(2,up,uht,rp,i1,j1,k1,ib+1,ie-1,jb,je,kb+1,ke-1)
      CALL filter(2,vp,vht,rp,i1,j1,k1,ib+1,ie-1,jb,je,kb+1,ke-1)
      CALL filter(2,wp,wht,rp,i1,j1,k1,ib+1,ie-1,jb,je,kb+1,ke-1)





c      do i=2,imax-1,6
c         do j=1,jmax,6
c            do k=1,kmax-1
c               
c               write(*,50) i,j,k,up(i,j,k),uht(i,j,k),vp(i,j,k),vht(i,j
c     $              ,k),wp(i,j,k),wht(i,j,k)
c 50            format(3(i4),6(f12.5))
c
c            end do
c         end do
c      end do
c      stop















c... compute u^bar^hat_i * u^bar^hat_j ...

      DO i=1,imax
         DO j=0,j1
            DO k=1,kmax

               aht(1,i,j,k) = uht(i,j,k)*uht(i,j,k)
               aht(2,i,j,k) = vht(i,j,k)*vht(i,j,k)
               aht(3,i,j,k) = wht(i,j,k)*wht(i,j,k)
               aht(4,i,j,k) = uht(i,j,k)*vht(i,j,k)
               aht(5,i,j,k) = wht(i,j,k)*vht(i,j,k)
               aht(6,i,j,k) = uht(i,j,k)*wht(i,j,k)

            END DO
         END DO
      END DO

c... compute u^bar_ij * u^bar_ij ...                

c... r-r component ...

      DO i=1,imax
         DO j=0,j1
            DO k=1,kmax

               bbr(i,j,k) = up(i,j,k)*up(i,j,k)

            END DO
         END DO
      END DO
      CALL filter(2,bbr,bht,rp,i1,j1,k1,ib+1,ie-1,jb,je,kb+1,ke-1)
      DO i=2,imax-1
         DO j=1,jmax
            DO k=2,kmax-1
               
               lijdij(i,j,k) = lijdij(i,j,k) + (bht(i,j,k) - aht(1,i,j,k
     $              ))*abr(1,i,j,k)

            END DO
         END DO
      END DO

c... theta-theta component ...

      DO i=1,imax
         DO j=0,j1
            DO k=1,kmax

               bbr(i,j,k) = vp(i,j,k)*vp(i,j,k)

            END DO
         END DO
      END DO
      CALL filter(2,bbr,bht,rp,i1,j1,k1,ib+1,ie-1,jb,je,kb+1,ke-1)
      DO i=2,imax-1
         DO j=1,jmax
            DO k=2,kmax-1
               
               lijdij(i,j,k) = lijdij(i,j,k) + (bht(i,j,k) - aht(2,i,j,k
     $              ))*abr(2,i,j,k)

            END DO
         END DO
      END DO

c... z-z component ...

      DO i=1,imax
         DO j=0,j1
            DO k=1,kmax

               bbr(i,j,k) = wp(i,j,k)*wp(i,j,k)

            END DO
         END DO
      END DO
      CALL filter(2,bbr,bht,rp,i1,j1,k1,ib+1,ie-1,jb,je,kb+1,ke-1)
      DO i=2,imax-1
         DO j=1,jmax
            DO k=2,kmax-1
               
               lijdij(i,j,k) = lijdij(i,j,k) + (bht(i,j,k) - aht(3,i,j,k
     $              ))*abr(3,i,j,k)

            END DO
         END DO
      END DO

c... r-theta component ...

      DO i=1,imax
         DO j=0,j1
            DO k=1,kmax

               bbr(i,j,k) = up(i,j,k)*vp(i,j,k)

            END DO
         END DO
      END DO
      CALL filter(2,bbr,bht,rp,i1,j1,k1,ib+1,ie-1,jb,je,kb+1,ke-1)
      DO i=2,imax-1
         DO j=1,jmax
            DO k=2,kmax-1
               
               lijdij(i,j,k) = lijdij(i,j,k) + 2.0*(bht(i,j,k) - aht(4,i
     $              ,j,k))*abr(4,i,j,k)

            END DO
         END DO
      END DO
               
c... z-theta component ...

      DO i=1,imax
         DO j=0,j1
            DO k=1,kmax

               bbr(i,j,k) = wp(i,j,k)*vp(i,j,k)

            END DO
         END DO
      END DO
      CALL filter(2,bbr,bht,rp,i1,j1,k1,ib+1,ie-1,jb,je,kb+1,ke-1)
      DO i=2,imax-1
         DO j=1,jmax
            DO k=2,kmax-1
               
               lijdij(i,j,k) = lijdij(i,j,k) + 2.0*(bht(i,j,k) - aht(5,i
     $              ,j,k))*abr(5,i,j,k)

            END DO
         END DO
      END DO
               
c... r-z component ...

      DO i=1,imax
         DO j=0,j1
            DO k=1,kmax

               bbr(i,j,k) = up(i,j,k)*wp(i,j,k)

            END DO
         END DO
      END DO
      CALL filter(2,bbr,bht,rp,i1,j1,k1,ib+1,ie-1,jb,je,kb+1,ke-1)
      DO i=2,imax-1
         DO j=1,jmax
            DO k=2,kmax-1
               
               lijdij(i,j,k) = lijdij(i,j,k) + 2.0*(bht(i,j,k) - aht(6,i
     $              ,j,k))*abr(6,i,j,k)

            END DO
         END DO
      END DO
               
c... average in theta direction ...

      DO i=2,imax-1
         DO k=2,kmax-1
            
            sum1 = 0.0
            sum2 = 0.0
            DO j=1,jmax

               sum1 = sum1 + lijdij(i,j,k)
               sum2 = sum2 + mkldkl(i,j,k)

            END DO
            lijdij(i,0,k) = sum1/jmax
            mkldkl(i,0,k) = sum2/jmax

         END DO
      END DO

      DO i=2,imax-1
         DO k=2,kmax-1



c            write(*,100) i,k,lijdij(i,0,k),mkldkl(i,0,k)
c 100        format(2(i4),2(f12.5))


            
            lmix(i,k) = -0.5*lijdij(i,0,k)/mkldkl(i,0,k)
            
         END DO
      END DO


c      stop





      DO k=2,kmax-1

         lmix(1,k) = lmix(2,k)
         lmix(imax,k) = lmix(imax-1,k)

      END DO
      lmix(1,1) = lmix(1,2)
      lmix(imax,kmax) = lmix(imax,kmax-1)

      DO i=2,imax-1

         lmix(i,1) = lmix(i,2)
         lmix(i,kmax) = lmix(i,kmax-1)

      END DO
      lmix(1,kmax) = lmix(1,kmax-1)
      lmix(imax,1) = lmix(imax-1,1)


      DO k=kb,ke
         DO j=jb,je
            DO i=ib,ie

               mut(i,j,k) = lmix(i,k) * magabr(i,j,k)

            END DO
         END DO
      END DO

c... set boundary values for mut ...


      DO k=1,kmax

c *** Theta-direction ***

         DO i=1,imax

            mut(i,0,k)  = mut(i,jmax,k)
            mut(i,j1,k) = mut(i,1,k)

         END DO

c *** R-direction ***

         DO j=0,j1

            mut(0,j,k)  =   mut(1,j,k)
c            mut(i1,j,k) = - mut(imax,j,k)
            mut(i1,j,k) = mut(imax,j,k)

         END DO

      END DO

c *** Z-direction ***

      DO j=0,j1
         DO i=0,i1

            mut(i,j,0)  = mut(i,j,kmax)
            mut(i,j,k1) = mut(i,j,1)

         END DO
      END DO
      
      RETURN
      END


c--------------------------------------------------------------------
c--------------------------------------------------------------------
      SUBROUTINE filter(dim,fbr,fht,rf,i1,j1,k1,ib,ie,jb,je,kb,ke)

      IMPLICIT NONE

      INTEGER dim,i1,j1,k1,ib,ie,jb,je,kb,ke
      INTEGER i,j,k,im,ip,jm,jp,km,kp

      REAL fbr(0:i1,0:j1,0:k1)
      REAL fht(0:i1,0:j1,0:k1)
      REAL rf(0:i1)

      REAL a1,a2,a3,a4
c--------------------------------------------------------------------

c... filter in theta-z plane ...

      IF(dim .EQ. 2)THEN

         a1 = 1.0  / 9.0
         a2 = 4.0  / 9.0
         a3 = 16.0 / 9.0

         DO i=ib,ie
            DO j=jb,je
               
               jm = j-1
               jp = j+1

               DO k=kb,ke
                  
                  km = k-1
                  kp = k+1

                  fht(i,j,k) = 0.25*(
     $        a1*fbr(i,jm,km) + a2*fbr(i,jm,k) + a1*fbr(i,jm,kp) 
     $      + a2*fbr(i,j,km)  + a3*fbr(i,j,k)  + a2*fbr(i,j,kp)
     $      + a1*fbr(i,jp,km) + a2*fbr(i,jp,k) + a1*fbr(i,jp,kp)
     $                               )

               END DO
            END DO
         END DO

      END IF

c... filter in all three directions ...

      IF(dim .EQ. 3)THEN 

         a1 = 1.0  / 27.0
         a2 = 4.0  / 27.0
         a3 = 16.0 / 27.0
         a4 = 64.0 / 27.0

         DO i=ib,ie

            im = i-1
            ip = i+1

            DO j=jb,je

               jm = j-1
               jp = j+1

               DO k=kb,ke

                  km = k-1
                  kp = k+1

                  fht(i,j,k) = 1.0/(8.0*rf(i))*(
     1      a1*rf(im)*fbr(im,jm,km) + a2*rf(i)*fbr(i,jm,km)
     1    + a1*rf(ip)*fbr(ip,jm,km)
     2    + a2*rf(im)*fbr(im,jm,k)  + a3*rf(i)*fbr(i,jm,k)
     2    + a2*rf(ip)*fbr(ip,jm,k)
     3    + a1*rf(im)*fbr(im,jm,kp) + a2*rf(i)*fbr(i,jm,kp)
     3    + a1*rf(ip)*fbr(ip,jm,kp)
     4    + a2*rf(im)*fbr(im,j,km)  + a3*rf(i)*fbr(i,j,km)
     4    + a2*rf(ip)*fbr(ip,j,km)
     5    + a3*rf(im)*fbr(im,j,k)   + a4*rf(i)*fbr(i,j,k)
     5    + a3*rf(ip)*fbr(ip,j,k)
     6    + a2*rf(im)*fbr(im,j,kp)  + a3*rf(i)*fbr(i,j,kp)
     6    + a2*rf(ip)*fbr(ip,j,kp)
     7    + a1*rf(im)*fbr(im,jp,km) + a2*rf(i)*fbr(i,jp,km)
     7    + a1*rf(ip)*fbr(ip,jp,km)
     8    + a2*rf(im)*fbr(im,jp,k)  + a3*rf(i)*fbr(i,jp,k)
     8    + a2*rf(ip)*fbr(ip,jp,k)
     9    + a1*rf(im)*fbr(im,jp,kp) + a2*rf(i)*fbr(i,jp,kp)
     9    + a1*rf(ip)*fbr(ip,jp,kp)
     $                                          )

               END DO
            END DO
         END DO

      END IF

      RETURN
      END

c---------------------------------------------------------------------
c---------------------------------------------------------------------
      SUBROUTINE deviatoric(dij,magdij,u,v,w,ru,rp,dphi,zw,zp,i1,j1,k1
     $     ,ib,ie,jb,je,kb,ke)

      IMPLICIT NONE

      INTEGER i1,j1,k1,ib,ie,jb,je,kb,ke
      INTEGER i,j,k,im,ip,jm,jp,km,kp

      INTEGER l

      REAL dij(6,0:i1,0:j1,0:k1)
      REAL magdij(0:i1,0:j1,0:k1)
      REAL u(0:i1,0:j1,0:k1)
      REAL v(0:i1,0:j1,0:k1)
      REAL w(0:i1,0:j1,0:k1)
      REAL ru(0:i1),rp(0:i1),dphi,zw(0:k1),zp(0:k1)

      REAL div(0:i1,0:j1,0:k1)
      
      REAL athird
c-----------------------------------------------------------------------

c *** divergence of velocity ***

      DO k=kb,ke
         
         kp=k+1
         km=k-1

         DO j=jb,je

            jp=j+1
            jm=j-1

            DO i=ib,ie

               ip=i+1
               im=i-1

               div(i,j,k) = 
     1    ( ru(i)*u(i,j,k) - ru(im)*u(im,j,k) ) / 
     1              (rp(i)*(ru(i)-ru(im)))
     2 +  ( v(i,j,k) - v(i,jm,k) )              / 
     2              (rp(i)*dphi)        
     3 +  ( w(i,j,k) - w(i,j,km) )              /
     3              (zw(k) - zw(km))


               div(i,j,k) = 0.0


            END DO
         END DO
      END DO

c *** deviatoric strain rate tensor ***

c... d(1...)=drr, d(2,...)=doo, d(3,...)=dzz, 
c... d(4,..)=dro, d(5,...)=dzo, d(6,...)=drz


      athird = 1.0/3.0

      DO k=kb,ke

         kp=k+1
         km=k-1

         DO j=jb,je

            jp=j+1
            jm=j-1

c *** Exclude i=1: considered i=1 apart at the end of the 300 loop

            DO i= 2,ie

               ip=i+1
               im=i-1

               dij(1,i,j,k) = ( u(i,j,k)-u(im,j,k) ) / (ru(i)-ru(im
     $              )) - athird*div(i,j,k)             

               dij(2,i,j,k) = ( (v(i,j,k)-v(i,jm,k)) / dphi +(u(i
     $              ,j,k)+u(im,j,k)) / 2.0 ) / rp(i) - athird*div(i,j
     $              ,k)

               dij(3,i,j,k) = ( w(i,j,k) - w(i,j,km) ) / (zw(k)
     $              -zw(km)) - athird*div(i,j,k)


c *** r-theta (theta-r) strain ***


               dij(4,i,j,k) = 0.5 * 0.25 * (
     & ( ru(i) * ( v(ip,j,k)/rp(ip)  - v(i,j,k)/rp(i)   ) /
     &           ( Rp(ip) - Rp(i) )                             +
     &           ( u(i,jp,k)         - u(i,j,k)         ) /
     &           ( ru(i) * dphi )                               )
     &      +
     & ( ru(i) * ( v(ip,jm,k)/rp(ip) - v(i,jm,k)/rp(i)  ) /
     &           ( rp(ip) - rp(i) )                             +
     &           ( u(i,j,k)          - u(i,jm,k)        ) /
     &           ( ru(i) * dphi )                               )
     &      +
     & ( ru(im)* ( v(i,j,k)/rp(i)    - v(im,j,k)/rp(im) ) /
     &           ( rp(i) - rp(im) )                             +
     &           ( u(im,jp,k)        - u(im,j,k)        ) /
     &           ( ru(im) * dphi )                              )
     &      +
     & ( ru(im)* ( v(i,jm,k)/rp(i)   - v(im,jm,k)/rp(im)) /
     &           ( rp(i) - rp(im) )                             +
     &           ( u(im,j,k)         - u(im,jm,k)       ) /
     &           ( ru(im) * dphi )                              )
     &                       )


c *** theta-z (z-theta) strain ***


               dij(5,i,j,k) = 0.5 * 0.25 * (
     & (  ( w(i,jp,k)  - w(i,j,k)   ) / ( rp(i) * dphi )  +
     &    ( v(i,j,kp)  - v(i,j,k)   ) / ( zp(kp)-zp(k) )  )
     &      +
     & (  ( w(i,j,k)   - w(i,jm,k)  ) / ( rp(i) * dphi )  +
     &    ( v(i,jm,kp) - v(i,jm,k)  ) / ( zp(kp)-zp(k) )  )
     &      +
     & (  ( w(i,jp,km) - w(i,j,km)  ) / ( rp(i) * dphi )  +
     &    ( v(i,j,k)   - v(i,j,km)  ) / ( zp(k)-zp(km) )  )
     &      +
     & (  ( w(i,j,km)  - w(i,jm,km) ) / ( rp(i) * dphi )  +
     &    ( v(i,jm,k)  - v(i,jm,km) ) / ( zp(k)-zp(km) )  )
     &                       )


c *** r-z (z-r) strain ***


               dij(6,i,j,k) = 0.5 * 0.25 * (
     & (  ( w(ip,j,k)  - w(i,j,k)   ) / ( rp(ip)-rp(i) )  +
     &    ( u(i,j,kp)  - u(i,j,k)   ) / ( zp(kp)-zp(k) )  )
     &      +
     & (  ( w(ip,j,km) - w(i,j,km)  ) / ( rp(ip)-rp(i) )  +
     &    ( u(i,j,k)   - u(i,j,km)  ) / ( zp(k)-zp(km) )  )
     &      +
     & (  ( w(i,j,k)   - w(im,j,k)  ) / ( rp(i)-rp(im) )  +
     &    ( u(im,j,kp) - u(im,j,k)  ) / ( zp(kp)-zp(k) )  )
     &      +
     & (  ( w(i,j,km)  - w(im,j,km) ) / ( rp(i)-rp(im) )  +
     &    ( u(im,j,k)  - u(im,j,km) ) / ( zp(k)-zp(km) )  )
     &                       )

            END DO

c *** Consider i=1 as a special case because some stresses become zero
c *** at the centerline:

      im = 0
      i  = 1
      ip = 2

            dij(1,i,j,k) = ( u(i,j,k)-u(im,j,k) ) / (ru(i)-ru(im
     $         )) - athird*div(i,j,k)             

            dij(2,i,j,k) = ( (v(i,j,k)-v(i,jm,k)) / dphi +(u(i
     $           ,j,k)+u(im,j,k)) / 2.0 ) / rp(i) - athird*div(i,j
     $           ,k)

            dij(3,i,j,k) = ( w(i,j,k) - w(i,j,km) ) / (zw(k)
     $           -zw(km)) - athird*div(i,j,k)


c *** r-theta (theta-r) strain ***


            dij(4,i,j,k) = 0.5 * 0.25 * (
     & ( ru(i) * ( v(ip,j,k)/rp(ip)  - v(i,j,k)/rp(i)   ) /
     &           ( rp(ip) - rp(i) )                             +
     &           ( u(i,jp,k)         - u(i,j,k)         ) /
     &           ( ru(i) * dphi )                               )
     &      +
     & ( ru(i) * ( v(ip,jm,k)/rp(ip) - v(i,jm,k)/rp(i)  ) /
     &           ( rp(ip) - rp(i) )                             +
     &           ( u(i,j,k)          - u(i,jm,k)        ) /
     &           ( ru(i) * dphi )                               )
cR=0 &      +
cR=0 & ( ru(im)* ( v(i,j,k)/rp(i)    - v(im,j,k)/rp(im) ) /
cR=0 &           ( rp(i) - rp(im) )                             +
cR=0 &           ( u(im,jp,k)        - u(im,j,k)        ) /
cR=0 &           ( ru(im) * dphi )                              )
cR=0 &      +
cR=0 & ( ru(im)* ( v(i,jm,k)/rp(i)   - v(im,jm,k)/rp(im)) /
cR=0 &           ( rp(i) - rp(im) )                             +
cR=0 &           ( u(im,j,k)         - u(im,jm,k)       ) /
cR=0 &           ( ru(im) * dphi )                              )
     &                       )


c *** theta-z (z-theta) strain ***


            dij(5,i,j,k) = 0.5 * 0.25 * (
     & (  ( w(i,jp,k)  - w(i,j,k)   ) / ( rp(i) * dphi )  +
     &    ( v(i,j,kp)  - v(i,j,k)   ) / ( zp(kp)-zp(k) )  )
     &      +
     & (  ( w(i,j,k)   - w(i,jm,k)  ) / ( rp(i) * dphi )  +
     &    ( v(i,jm,kp) - v(i,jm,k)  ) / ( zp(kp)-zp(k) )  )
     &      +
     & (  ( w(i,jp,km) - w(i,j,km)  ) / ( rp(i) * dphi )  +
     &    ( v(i,j,k)   - v(i,j,km)  ) / ( zp(k)-zp(km) )  )
     &      +
     & (  ( w(i,j,km)  - w(i,jm,km) ) / ( rp(i) * dphi )  +
     &    ( v(i,jm,k)  - v(i,jm,km) ) / ( zp(k)-zp(km) )  )
     &                       )

c *** r-z (z-r) strain ***


            dij(6,i,j,k) = 0.5 * 0.25 * (
     & (  ( w(ip,j,k)  - w(i,j,k)   ) / ( rp(ip)-rp(i) )  +
     &    ( u(i,j,kp)  - u(i,j,k)   ) / ( zp(kp)-zp(k) )  )
     &      +
     & (  ( w(ip,j,km) - w(i,j,km)  ) / ( rp(ip)-rp(i) )  +
     &    ( u(i,j,k)   - u(i,j,km)  ) / ( zp(k)-zp(km) )  )
cR=0 &      +
cR=0 & (  ( w(i,j,k)   - w(im,j,k)  ) / ( rp(i)-rp(im) )  +
cR=0 &    ( u(im,j,kp) - u(im,j,k)  ) / ( dz )            )
cR=0 &      +
cR=0 & (  ( w(i,j,km)  - w(im,j,km) ) / ( rp(i)-rp(im) )  +
cR=0 &    ( u(im,j,k)  - u(im,j,km) ) / ( dz )            )
     &                       )

         END DO

      END DO

c... compute |d_i,j| = sqrt(2*d_(i,j)*d_(i,j)) ... 

      DO k=kb,ke
         DO j=jb,je
            DO i=ib,ie

               magdij(i,j,k) = SQRT( 2*dij(1,i,j,k)**2 + 2*dij(2,i,j,k)
     $              **2 +2*dij(3,i,j,k)**2 + 4*dij(4,i,j,k)**2 + 4*dij(5
     $              ,i,j,k)**2+ 4*dij(6,i,j,k)**2 )

            END DO
         END DO
      END DO

c... in the theta direction things are periodic so we can supply
c... the following boundary values for j=0 and j=j1 -- these 
c... values are used when we test filter |d^bar_ij| * d^bar_ij

      DO l=1,6
         DO i=ib,ie
            DO k=kb,ke
            
               dij(l,i,0,k)  = dij(l,i,je,k)
               dij(l,i,j1,k) = dij(l,i,1,k)

               magdij(i,0,k)  = magdij(i,je,k)
               magdij(i,j1,k) = magdij(i,1,k)

            END DO
         END DO
      END DO
      

      RETURN 
      END 
c-----------------------------------------------------------------------
c-----------------------------------------------------------------------

      

      SUBROUTINE inlet(ub,vb,wb,yb,tb,rho,time,ru,rp,ijet)

      IMPLICIT NONE

      INCLUDE 'param2.txt'
      INCLUDE 'param.txt'

      REAL ub(0:i1,0:j1,0:k1)
      REAL vb(0:i1,0:j1,0:k1)
      REAL wb(0:i1,0:j1,0:k1)
      REAL yb(0:i1,0:j1,0:k1)
      REAL tb(0:i1,0:j1,0:k1)
      REAL rho(0:i1,0:j1,0:k1)
      REAL ru(0:i1),rp(0:i1)

      REAL time
      INTEGER ijet

      REAL win,u1,u2,v1,v2,w1,w2
      
      PARAMETER (win=2.0)

      REAL kpl
      INTEGER kpln

      REAL upipe(0:pi1,0:pj1,0:pk1)
      REAL vpipe(0:pi1,0:pj1,0:pk1)
      REAL wpipe(0:pi1,0:pj1,0:pk1)
      REAL drpipe
      INTEGER aup(0:i1)

      REAL alpha,beta,preexp,incrho,rhoi

      COMMON /indata/ upipe,vpipe,wpipe,drpipe,aup

      COMMON /heatrl/ alpha,beta,preexp,incrho,rhoi
c----------------------------------------------------------------------

c...inject turbulence at lower jet exit...

      IF(1.EQ.1)THEN

         DO i=0,ijet
            DO j=0,j1

               kpln=pkmax*win*time/plz
               kpln=mod(kpln,pkmax)

               kpl=pkmax*win*time/plz
               kpl=mod(kpl,real(pkmax))

               wb(i,j,0)=(kpl-kpln)*(wpipe(i,j,kpln+1) -
     $              wpipe(i,j,kpln))+wpipe(i,j,kpln) + win

               vb(i,j,0)=(kpl-kpln)*(vpipe(i,j,kpln+1) -
     $              vpipe(i,j,kpln))+vpipe(i,j,kpln)

               ub(i,j,0)=(kpl-kpln)*(upipe(i,j,kpln+1) -
     $              upipe(i,j,kpln))+upipe(i,j,kpln)
               
            END DO
         END DO

      END IF

c...inject turbulence at upper jet exit...

      IF(1.EQ.0)THEN

         DO i=0,ijet
            DO j=0,j1

               kpln=pkmax*win*(time+.1)/plz
               kpln=mod(kpln,pkmax)

               kpl=pkmax*win*(time+.1)/plz
               kpl=mod(kpl,real(pkmax))

               wb(i,j,kmax)=-((kpl-kpln)*(wpipe(i,j,kpln+1) -
     $              wpipe(i,j,kpln))+wpipe(i,j,kpln) + win)

               vb(i,j,k1)=(kpl-kpln)*(vpipe(i,j,kpln+1) -
     $              vpipe(i,j,kpln))+vpipe(i,j,kpln)

               ub(i,j,k1)=(kpl-kpln)*(upipe(i,j,kpln+1) -
     $              upipe(i,j,kpln))+upipe(i,j,kpln)
               
            END DO
         END DO
         
      END IF


c...inject turbulence from pipe DNS...

      IF(1.EQ.0)THEN

         kpln=pkmax*win*time/plz
         kpln=mod(kpln,pkmax)

         kpl=pkmax*win*time/plz
         kpl=mod(kpl,real(pkmax))


         DO i=0,ijet
            DO j=0,j1

               w1=(kpl-kpln)*(wpipe(aup(i),j,kpln+1) - wpipe(aup(i),j
     $              ,kpln))+wpipe(aup(i),j,kpln)

               w2=(kpl-kpln)*(wpipe(aup(i)+1,j,kpln+1) - wpipe(aup(i)+1
     $              ,j,kpln))+wpipe(aup(i)+1,j,kpln)

               wb(i,j,0)=w1+(ru(i)-drpipe*aup(i))*(w2-w1)/drpipe



               v1=(kpl-kpln)*(vpipe(aup(i),j,kpln+1) - vpipe(aup(i),j
     $              ,kpln))+vpipe(aup(i),j,kpln)

               v2=(kpl-kpln)*(vpipe(aup(i)+1,j,kpln+1) - vpipe(aup(i)+1
     $              ,j,kpln))+vpipe(aup(i)+1,j,kpln)

               vb(i,j,0)=v1+(ru(i)-drpipe*aup(i))*(v2-v1)/drpipe



               u1=(kpl-kpln)*(upipe(aup(i),j,kpln+1) - upipe(aup(i),j
     $              ,kpln))+upipe(aup(i),j,kpln)

               u2=(kpl-kpln)*(upipe(aup(i)+1,j,kpln+1) - upipe(aup(i)+1
     $              ,j,kpln))+upipe(aup(i)+1,j,kpln)

               ub(i,j,0)=u1+(ru(i)-drpipe*aup(i))*(u2-u1)/drpipe

               
            END DO
         END DO

      END IF

      RETURN
      END

      SUBROUTINE fkdat

      IMPLICIT NONE

      INCLUDE 'param.txt'
      INCLUDE 'common.txt'

      INTEGER iseed
      REAL*4 ran
      REAL ranf

      REAL alpha,beta,preexp,incrho,rhoi

      COMMON /heatrl/ alpha,beta,preexp,incrho,rhoi
c--------------------------------------------------------------------

      iseed=1.0

      DO i=1,imax
         DO j=1,jmax
            DO k=1,kmax

               unew(i,j,k) = 0.0
               vnew(i,j,k) = 0.0
               wnew(i,j,k) = 0.1

c..............SGI machine.........

c               vnew(i,j,k) = -0.05 + .1*ran(iseed)
c               unew(i,j,k) = -0.05 + .1*ran(iseed)

c..............Cray...............

c               vnew(i,j,k) = -0.05 + .1*ranf()
c               unew(i,j,k) = -0.05 + .1*ranf()
c               wnew(i,j,k) = -0.05 + .1*ranf()

               tnew(i,j,k) = 0.0
               told(i,j,k) = 0.0
               ynew(i,j,k) = 0.0

               munew(i,j,k)  = 1.0
               lmbnew(i,j,k) = 1.0
               difnew(i,j,k) = 1.0

               mut(i,j,k)    = 0.0

               dudtn(i,j,k)  = 0.0
               dudtnm(i,j,k) = 0.0
               dvdtn(i,j,k)  = 0.0
               dvdtnm(i,j,k) = 0.0
               dwdtn(i,j,k)  = 0.0
               dwdtnm(i,j,k) = 0.0
               dtdtn(i,j,k)  = 0.0
               dtdtnm(i,j,k) = 0.0
               dydtn(i,j,k)  = 0.0
               dydtnm(i,j,k) = 0.0

            END DO
         END DO
      END DO

      DO k=0,k1
         DO j=0,j1
            DO i=0,i1
               rhonew(i,j,k) = 1.0/((incrho*alpha/(1.0-incrho*alpha))
     $              *tnew(i,j,k)+rhoi)
               rhold1(i,j,k) = rhonew(i,j,k)
               rhold2(i,j,k) = rhonew(i,j,k)
            END DO
         END DO
      END DO

      DO k=1,kmax
         DO j=1,jmax
            DO i=1,imax

               umnew(i,j,k) = rhonew(i,j,k)*unew(i,j,k)
               vmnew(i,j,k) = rhonew(i,j,k)*vnew(i,j,k)
               wmnew(i,j,k) = rhonew(i,j,k)*wnew(i,j,k)
               ymnew(i,j,k) = rhonew(i,j,k)*ynew(i,j,k)

               umold(i,j,k) = rhonew(i,j,k)*unew(i,j,k)
               vmold(i,j,k) = rhonew(i,j,k)*vnew(i,j,k)
               wmold(i,j,k) = rhonew(i,j,k)*wnew(i,j,k)
               ymold(i,j,k) = rhonew(i,j,k)*ynew(i,j,k)
               
            END DO
         END DO
      END DO

      RETURN
      END

      SUBROUTINE viscos(ib,ie,jb,je,kb,ke)

      IMPLICIT NONE

      INCLUDE 'param.txt'
      INCLUDE 'common.txt'

      INTEGER ib,ie,jb,je,kb,ke

      REAL tmp
c--------------------------------------------------------------------

      DO k=kb,ke
         DO j=jb,je
            DO i=ib,ie

               tmp=((tnew(i,j,k)-tnew(i,j,k-1))/(zp(k)-zp(k-1)))**2
     $              +((tnew(i,j,k)-tnew(i-1,j,k))/(rp(i)-rp(i-1)))**2
     $              +((tnew(i,j,k)-tnew(i,j-1,k))/(rp(i)*dphi))**2

               tmp=SQRT(tmp)

               munew(i,j,k)  = 1.0/(Re) + rhonew(i,j,k)*mut(i,j,k)
               lmbnew(i,j,k) = 1.0/(Re*Pr) + rhonew(i,j,k)*mut(i,j,k)
     $              *Cl*tmp
               difnew(i,j,k) = 1.0/(Re*Pr*Le) + rhonew(i,j,k)*mut(i,j,k)
     $              *Cl*tmp


               if(munew(i,j,k) .lt. 0.0)then
                  munew(i,j,k) = 1.0/Re
               end if


            END DO
         END DO
      END DO

c*************************************************************
c
c     Set boundary boundary condition for K-closure factors.
c
c*************************************************************

      DO k=1,kmax

c *** Theta-direction *** Periodic direction ***

         DO i=1,imax

            munew(i,0,k)  = munew(i,jmax,k)
            munew(i,j1,k) = munew(i,1,k)

            lmbnew(i,0,k)  = lmbnew(i,jmax,k)
            lmbnew(i,j1,k) = lmbnew(i,1,k)

            difnew(i,0,k)  = difnew(i,jmax,k)
            difnew(i,j1,k) = difnew(i,1,k)

         END DO

c *** R-direction ***

         DO j=0,j1

            munew(0,j,k)  =   munew(1,j,k)
c            munew(i1,j,k) = - munew(imax,j,k)
            munew(i1,j,k) = munew(imax,j,k)


            lmbnew(0,j,k)  =   lmbnew(1,j,k)
            lmbnew(i1,j,k) = - lmbnew(imax,j,k)

            difnew(0,j,k)  =   difnew(1,j,k)
            difnew(i1,j,k) = - difnew(imax,j,k)

         END DO

      END DO

c *** Z-direction ***

      DO j=0,j1
        DO i=0,i1

           munew(i,j,0)  = munew(i,j,kmax)
           munew(i,j,k1) = munew(i,j,1)

           lmbnew(i,j,0)  = lmbnew(i,j,kmax)
           lmbnew(i,j,k1) = lmbnew(i,j,1)

           difnew(i,j,0)  = difnew(i,j,kmax)
           difnew(i,j,k1) = difnew(i,j,1)

        END DO
      END DO

      RETURN
      END

      SUBROUTINE chkdt

      IMPLICIT NONE

      INCLUDE 'param.txt'
      INCLUDE 'common.txt'

      REAL dr2,dz2,df,df2,kcoeff,tmp1,tmp2,tmp3,tmp4,tmp5
      REAL dt1,dt2

      REAL alpha,beta,preexp,incrho,rhoi

      COMMON /heatrl/ alpha,beta,preexp,incrho,rhoi

c------------------------------------------------------------------

      dt = dtmax
      dt1=dtmax
      dt2=dtmax

      DO k=1,kmax
         DO j=1,jmax
            DO i=1,imax

               df  = rp(i)*dphi
               df2 = df*df

               dr2 = dr(i) * dr(i)
               dz2 = dz(k) * dz(k)

               kcoeff = munew(i,j,k)

               tmp1 = ( abs(Unew(i,j,k)) / ( rp(i+1)-rp(i) ) ) +
     &             ( abs(Vnew(i,j,k)) /         df        ) +
     &             ( abs(Wnew(i,j,k)) /    ( zp(k+1)-zp(k) ) )


c *** explicit diffusion in 3-directions

               tmp2 = ( 1.0/dr2 + 1.0/df2 + 1.0/dz2 )
               tmp3 = 1.0 / ( 4.0 * tmp2 * kcoeff + tmp1 )

c *** explicit diffusion in 2-directions, implicit in 1-direction

               tmp4 = ( 1.0/dr2 + 1.0/dz2 )
               tmp5 = 1.0 / ( 4.0 * tmp4 * kcoeff + tmp1 )

c *** Security factor 0.5 according for non-linear instabilities:

c *** 10/02/1993 increased to 0.8 because in non-uniform grid, the time-
c *** is limited almost completely by the molecular diffusion in the
c *** first gridcell near the wall (dr(imax) which is extremely small!).
c *** Non-linear instabilities are related to the non-linear advection
c *** terms and not to the linear diffusion terms.
c *** Therefore, security factor increased to 0.8.
c pipe flow
c               tmp3 = 0.75 * tmp3

c jet flow

c               tmp3 = .3 * tmp3   ! constant, alpha=.4

               tmp3 = .55 * tmp3
               tmp5 = .55 * tmp5
               
               dt1 = MIN(dt1,tmp3)
               dt2 = MIN(dt2,tmp5)

            END DO

         END DO

      END DO

      dt=dt1

      print*,'dt1=',dt1
c      print*,'dt1=',dt1,'dt2=',dt2


      WRITE(18,150) istep,dt
 150  FORMAT('  istep : ',i6,'   dt : ',f12.8)

      RETURN
      END

      SUBROUTINE pipe(ijet)

      IMPLICIT NONE

      INCLUDE 'param.txt'
      INCLUDE 'param2.txt'

      INTEGER ijet

      REAL dummy(0:pi1,0:pj1,0:pk1)
      REAL winmax,vinmax,uinmax

      REAL upipe(0:pi1,0:pj1,0:pk1)
      REAL vpipe(0:pi1,0:pj1,0:pk1)
      REAL wpipe(0:pi1,0:pj1,0:pk1)
      REAL drpipe
      INTEGER aup(0:i1)

      COMMON /indata/ upipe,vpipe,wpipe,drpipe,aup

c------------------------------------------------------------------------

      IF(1.EQ.1) THEN

c         OPEN(15,FILE='isopipe.dat',FORM='UNFORMATTED')

c         DO k=0,pkmax-1
c
c            READ(15)
c     $           ( (upipe(i,j,k), j=0,pj1), i=0,ijet),
c     $           ( (vpipe(i,j,k), j=0,pj1), i=0,ijet),
c     $           ( (wpipe(i,j,k), j=0,pj1), i=0,ijet)
c            
c         END DO
c         
c         CLOSE(15)
      upipe=0
      vpipe=0
      wpipe=1

      END IF



c      IF(1.EQ.0)THEN
c
c         OPEN(15,FILE='isopipe.dat')

c         DO k=0,pkmax-1
c            DO j=0,pj1
c               DO i=0,ijet
c
c                  READ(15,10) upipe(i,j,k),vpipe(i,j,k),wpipe(i,j,k)
c 10               FORMAT(3(E16.6))
c
c               END DO
c            END DO
c         END DO
c         
c         CLOSE(15)

c      END IF


      IF(1.EQ.0)THEN

c ************* If in = 0 read data from file ************************


         OPEN(15,FILE='pipe.dat',FORM='unformatted')

         do 100 k=0,pk1

            read(15)
     &           ( (Upipe(i,j,k) , j=0,pj1) , i=0,pi1),
     &           ( (Vpipe(i,j,k) , j=0,pj1) , i=0,pi1),
     &           ( (Wpipe(i,j,k) , j=0,pj1) , i=0,pi1),
     &           ( (dummy(i,j,k) , j=0,pj1) , i=0,pi1),
     &           ( (dummy(i,j,k) , j=0,pj1) , i=0,pi1),
     &           ( (dummy(i,j,k) , j=0,pj1) , i=0,pi1),
     &           ( (dummy(i,j,k) , j=0,pj1) , i=0,pi1),
     &           ( (dummy(i,j,k) , j=0,pj1) , i=0,pi1),
     &           ( (dummy(i,j,k) , j=0,pj1) , i=0,pi1)

 100     continue
         
         close(15)

         
         winmax=0.0
         vinmax=0.0
         uinmax=0.0
         DO k=0,pk1
            DO j=0,pj1
               DO i=0,pi1
                  if(wpipe(i,j,k) .gt. winmax) winmax=wpipe(i,j,k)
                  if(vpipe(i,j,k) .gt. vinmax) vinmax=vpipe(i,j,k)
                  if(upipe(i,j,k) .gt. uinmax) uinmax=upipe(i,j,k)
               END DO
            END DO
         END DO

         DO k=0,pk1
            DO j=0,pj1
               DO i=0,pi1

                  wpipe(i,j,k) = 3.75*wpipe(i,j,k)/winmax
c               vpipe(i,j,k) = 1.75*vpipe(i,j,k)/winmax
c               upipe(i,j,k) = 1.75*upipe(i,j,k)/winmax

                  vpipe(i,j,k) = 3.75*vpipe(i,j,k)/vinmax
                  upipe(i,j,k) = 3.75*upipe(i,j,k)/uinmax

                  wpipe(i,j,k) = wpipe(i,j,k) + 1.0

               END DO
            END DO
         END DO

      END IF

      RETURN 
      END

      SUBROUTINE tec3d

      IMPLICIT NONE

      INCLUDE 'param.txt'
      INCLUDE 'param2.txt'
      INCLUDE 'common.txt'

      REAL react
      INTEGER ktmp,itmp

      REAL xr,yr
      REAL y(0:j1)

      REAL alpha,beta,preexp,incrho,rhoi

      COMMON /heatrl/ alpha,beta,preexp,incrho,rhoi

c-----------------------------------------------------------------------

      OPEN(15,file='tec3d.out')

      WRITE(15,*)
     $     'VARIABLES = "X","Y","Z","U","V","W","P","T","Yr","Rx","Rho"'
      WRITE(15,*) 'ZONE F=POINT, I=',i1, ', J=',j1, ',K=',kmax

      DO j=0,j1
         y(j)=j*2*3.14159/jmax
      END DO

      DO k=1,kmax
         DO j=0,jmax
            DO i=0,imax

               itmp=i
               if(i .eq. 0) itmp=1

               react=preexp*ynew(i,j,k)*EXP((-beta*(1.0-tnew(i
     $              ,j,k)))/(1-alpha*(1.0-tnew(i,j,k))))


               xr=ru(i)*cos(y(j))
               yr=ru(i)*sin(y(j))

               WRITE(15,10) xr,yr,zw(k),unew(i,j,k),vnew(i,j,k),wnew(i,j
     $              ,k),p(itmp,j,k),tnew(i,j,k),ynew(i,j,k),react
     $              ,rhonew(i,j,k)
 10            FORMAT(1x,11(e12.4))

            END DO
         END DO
      END DO

      CLOSE(15)

      RETURN

      END 

      SUBROUTINE bound(ub,vb,wb,tb,yb,rho,time,ijet,dt,zp,zw,advout,ru,rp)

      IMPLICIT NONE

      INCLUDE 'param.txt'
      INCLUDE 'param2.txt'

      REAL ub(0:i1,0:j1,0:k1)
      REAL vb(0:i1,0:j1,0:k1)
      REAL wb(0:i1,0:j1,0:k1)
      REAL tb(0:i1,0:j1,0:k1)
      REAL yb(0:i1,0:j1,0:k1)
      REAL rho(0:i1,0:j1,0:k1)

      REAL time,dt
      REAL zp(0:k1),zw(0:k1)
      REAL ru(0:i1),rp(0:i1)

      REAL alpha,beta,preexp,incrho,rhoi,wmean(imax)

      INTEGER advout

      INTEGER jtmp
      INTEGER iseed
      REAL*4 ran,ranf,tmp1,tmp2

      INTEGER ijet

      COMMON /heatrl/ alpha,beta,preexp,incrho,rhoi
c---------------------------------------------------------------

c*************************************************************
c
c     Set boundary conditions for i=0 and i=i1. For the boundary
c     conditions at i=0 we assume Neumann (no-flux) BC's. Mostly,
c     this B.C. is not used and hence, treated as dummies.

c*************************************************************
      wmean = 0
      do k=1,kmax
	 do j=1,jmax
	   do i=1,imax	
 	      wmean(i)=wmean(i)+wb(i,j,kmax)/(jmax*kmax)
           enddo
         enddo
      enddo

      DO k=1,kmax

         DO j=0,j1

            if ( j .le. jmax/2 ) then
               jtmp = j + jmax/2
            else
               jtmp = j - jmax/2
            endif

c *** Impermeability condition for the radial velocity component for
c *** i = imax:

            tb(0,j,k)    = tb(1,j,k)
            yb(0,j,k)    = yb(1,j,k)

            rho(0,j,k)   = rho(1,j,k)
            

            ub(0,j,k)    =   ub(1,j,k)
            vb(0,j,k)    =   vb(1,j,k)
            wb(0,j,k)    =   wb(1,j,k)



            tb(i1,j,k)   = tb(imax,j,k)
            yb(i1,j,k)   = yb(imax,j,k)

            rho(i1,j,k) = 1.0/((incrho*alpha/(1.0-incrho*alpha))*tb(i1,j
     $           ,k)+rhoi)

            ub(i1,j,k)   =  ub(imax,j,k)
            vb(i1,j,k)   =  vb(imax,j,k)
            wb(i1,j,k)   =  wb(imax,j,k)

         END DO

      END DO

c*************************************************************
c
c     Set boundary conditions for k=0 and k=k1.
c
c*************************************************************

      DO j=0,j1

         DO i=0,i1

            tb(i,j,0)  = 0.0 - tb(i,j,1)     ! t=zero
            yb(i,j,0)  = 0.0 - yb(i,j,1)     ! y=zero

            rho(i,j,0) = 1.0/((incrho*alpha/(1.0-incrho*alpha))*tb(i,j,0
     $           )+rhoi)

            ub(i,j,0)     = -ub(i,j,1)     ! zero velocity
            vb(i,j,0)     = -vb(i,j,1)     ! zero velocity
            wb(i,j,0)     = 0.0            ! zero velocity


            tb(i,j,k1)  =  0.0 - tb(i,j,kmax) 
            yb(i,j,k1)  = 0.0 - yb(i,j,kmax)  

            rho(i,j,k1) = 1.0/((incrho*alpha/(1.0-incrho*alpha))*tb(i,j
     $           ,k1)+rhoi)

c            ub(i,j,k1)    =  -ub(i,j,kmax) 
c            vb(i,j,k1)    =  -vb(i,j,kmax) 

            ub(i,j,k1)    =  ub(i,j,kmax) 
            vb(i,j,k1)    =  vb(i,j,kmax) 
            wb(i,j,kmax)  = wb(i,j,kmax)-dt*wmean(i)*(wb(i,j
     $              ,kmax)-wb(i,j,kmax-1))/(zw(kmax)-zw(kmax-1))


         END DO

      END DO

c.....conditions at lower and upper jet exits.....


c      CALL inlet(ub,vb,wb,yb,tb,rho,time,ru,rp,ijet)
cc      CALL jets(umb,vmb,wmb,ub,vb,wb,yb,tb,rho,time)

c.....conditions outside the lower jet exit....     

      DO i=i,i1
         DO j=0,j1
                  
            tb(i,j,0)  = 0.0 - tb(i,j,1) ! zero
            yb(i,j,0)  = 0.0 - yb(i,j,1) ! zero

            rho(i,j,0) = 1.0/((incrho*alpha/(1.0-incrho*alpha))
     $           *tb(i,j,0)+rhoi)

            wb(i,j,0)  = 0.

         END DO
      END DO

c.....conditions at the jet exit....     
      DO i=0,ijet
         DO j=0,j1

            tb(i,j,k1) =  tb(i,j,kmax)
            yb(i,j,k1) =  yb(i,j,kmax) 
            wb(i,j,0)  =  1.
            tb(i,j,0)  =  2 - tb(i,j,1)
            yb(i,j,0)  =  2 - yb(i,j,1)
            rho(i,j,0) = 1.0/((incrho*alpha/(1.0-incrho*alpha))
     $           *tb(i,j,0)+rhoi)
         ENDDO
      ENDDO
            

c*************************************************************************
c
c   boundary conditions on j=0 and j=j1 - periodic.
c
c
c*************************************************************************

      DO k=0,k1

         DO i=0,i1

            tb(i,0,k)  = tb(i,jmax,k)
            yb(i,0,k)  = yb(i,jmax,k)

            rho(i,0,k) = rho(i,jmax,k)

            ub(i,0,k) = ub(i,jmax,k)
            vb(i,0,k) = vb(i,jmax,k)
            wb(i,0,k) = wb(i,jmax,k)



            tb(i,j1,k) = tb(i,1,k)
            yb(i,j1,k) = yb(i,1,k)

            rho(i,j1,k) = rho(i,1,k)

            ub(i,j1,k) = ub(i,1,k)
            vb(i,j1,k) = vb(i,1,k)
            wb(i,j1,k) = wb(i,1,k)

         END DO

      END DO

      RETURN
      END

      SUBROUTINE scbndy(tb,yb,rho,ijet)

      IMPLICIT NONE
      
      INCLUDE 'param.txt'
      INCLUDE 'param2.txt'

      REAL tb(0:i1,0:j1,0:k1)
      REAL yb(0:i1,0:j1,0:k1)
      REAL rho(0:i1,0:j1,0:k1)

      REAL alpha,beta,preexp,incrho,rhoi

      INTEGER jtmp
      INTEGER ijet

      COMMON /heatrl/ alpha,beta,preexp,incrho,rhoi

c------------------------------------------------------------------------

c*************************************************************
c
c     Set boundary conditions for i=0 and i=i1. For the boundary
c     conditions at i=0 we assume Neumann (no-flux) BC's. Mostly,
c     this B.C. is not used and hence, treated as dummies.

c*************************************************************

      DO k=1,kmax

         DO j=0,j1

            if ( j .le. jmax/2 ) then
               jtmp = j + jmax/2
            else
               jtmp = j - jmax/2
            endif

c *** Impermeability condition for the radial velocity component for
c *** i = imax:

            tb(0,j,k)    = tb(1,j,k)

            rho(0,j,k)   = rho(1,j,k)

c            rho(0,j,k) = 1.0/((incrho*alpha/(1.0-incrho*alpha))*1.0+rhoi)


c            rho(0,j,k) = 1.0/((incrho*alpha/(1.0-incrho*alpha))*tb(0,j,k
c     $           )+rhoi)
            yb(0,j,k)    = yb(1,j,k)

            tb(i1,j,k)   = tb(imax,j,k)
            rho(i1,j,k) = 1.0/((incrho*alpha/(1.0-incrho*alpha))*tb(i1,j
     $           ,k)+rhoi)
            yb(i1,j,k)   = yb(imax,j,k)

         END DO

      END DO

c*************************************************************
c
c     Set boundary conditions for k=0 and k=k1.
c
c*************************************************************

      DO j=0,j1
         DO i=0,i1
            
            tb(i,j,k1)  =  0.0 - tb(i,j,kmax) 
            yb(i,j,k1)  =  0.0 - yb(i,j,kmax)  ! y=zero

            rho(i,j,k1) = 1.0/((incrho*alpha/(1.0-incrho*alpha))*tb(i,j
     $           ,k1)+rhoi)

         END DO
      END DO


c.....conditions at lower jet exit.....

      DO i=0,ijet
         DO j=0,j1
               
c            tb(i,j,0)=0.0-tb(i,j,1) ! cold inlet

            tb(i,j,0)=2.0-tb(i,j,1) ! hot inlet

            rho(i,j,0) = 1.0/((incrho*alpha/(1.0-incrho*alpha))*tb(i
     $           ,j,0)+rhoi)

            yb(i,j,0)=2.0-yb(i,j,1) 

         END DO
      END DO

c.....conditions outside the lower jet exit....     

      DO i=ijet+1,i1-15
         DO j=0,j1
            
            tb(i,j,0)  = 0.0-tb(i,j,1) ! zero
            rho(i,j,0) = 1.0/((incrho*alpha/(1.0-incrho*alpha))
     $           *tb(i,j,0)+rhoi)

            yb(i,j,0)  = 0.0-yb(i,j,1) ! zero

         END DO
      END DO

c....conditions at upper jet exit....

      DO i=0,ijet
         DO j=0,j1

            tb(i,j,k1) = 2.0 - tb(i,j,kmax)
            yb(i,j,k1) = 0.0 - yb(i,j,kmax)

            rho(i,j,k1) = 1.0/((incrho*alpha/(1.0-incrho*alpha))*tb(i
     $              ,j,k1)+rhoi)

         END DO
      END DO

c....conditions outside the upper jet exit...

      DO i=ijet+1,i1-15
         DO j=0,j1

            tb(i,j,k1) = 0.0 - tb(i,j,kmax)
            yb(i,j,k1) = 0.0 - yb(i,j,kmax)

            rho(i,j,k1) = 1.0/((incrho*alpha/(1.0-incrho*alpha))
     $           *tb(i,j,k1)+rhoi)

         END DO
      END DO

c*************************************************************************
c
c   boundary conditions on j=0 and j=j1 - periodic.
c
c*************************************************************************

      DO k=0,k1

         DO i=0,i1

            tb(i,0,k)  = tb(i,jmax,k)
            rho(i,0,k) = rho(i,jmax,k)
            yb(i,0,k)  = yb(i,jmax,k)

            tb(i,j1,k) = tb(i,1,k)
            rho(i,j1,k) = rho(i,1,k)
            yb(i,j1,k) = yb(i,1,k)

         END DO

      END DO

      RETURN
      END

      SUBROUTINE jets(umb,vmb,wmb,ub,vb,wb,yb,tb,rho,time)

      IMPLICIT NONE

      INCLUDE 'param2.txt'
      INCLUDE 'param.txt'

      REAL umb(0:i1,0:j1,0:k1)
      REAL vmb(0:i1,0:j1,0:k1)
      REAL wmb(0:i1,0:j1,0:k1)

      REAL ub(0:i1,0:j1,0:k1)
      REAL vb(0:i1,0:j1,0:k1)
      REAL wb(0:i1,0:j1,0:k1)
      REAL tb(0:i1,0:j1,0:k1)
      REAL yb(0:i1,0:j1,0:k1)
      REAL rho(0:i1,0:j1,0:k1)

      REAL time

      REAL alpha,beta,preexp,incrho,rhoi

      COMMON /heatrl/ alpha,beta,preexp,incrho,rhoi
c---------------------------------------------------------------------


c...test flow from pipe...

      IF(1.EQ.0)THEN
         DO i=0,i1
            DO j=0,j1
               wb(i,j,0) = 1.0
               ub(i,j,0) = 0.0
               vb(i,j,0) = 0.0
            END DO
         END DO
      END IF

c...at this stage, inflow velocity profiles from pipe database are
c   stored in arrays wb(i,j,0), ub(i,j,0), and vb(i,j,0)

      DO i=0,i1
         DO j=0,j1
            wb(i,j,0) = wb(i,j,0)
            ub(i,j,0) = -ub(i,j,1) + ub(i,j,0)
            vb(i,j,0) = -vb(i,j,1) + vb(i,j,0)
         END DO
      END DO

c...grid...take the pipe velocity profile and run it through the grid.


      IF(1.EQ.1)THEN

c...radial filter

c...fine mesh...

c         DO i=4,i1,5
c            DO j=0,j1
c               wb(i,j,0) = 0.0
c               ub(i,j,0) = -ub(i,j,1)
c               vb(i,j,0) = -vb(i,j,1)
c            END DO
c         END DO

         DO i=4,i1,3
            DO j=0,j1
               wb(i,j,0) = 0.0
               ub(i,j,0) = -ub(i,j,1)
               vb(i,j,0) = -vb(i,j,1)
            END DO
         END DO

c         DO i=5,i1,5
c            DO j=0,j1
c               wb(i,j,0) = 0.0
c               ub(i,j,0) = -ub(i,j,1)
c               vb(i,j,0) = -vb(i,j,1)
c            END DO
c         END DO

         DO j=0,j1
            wb(imax,j,0) = 0.0
            ub(imax,j,0) = -ub(i1,j,1)
            vb(imax,j,0) = -vb(i1,j,1)
            wb(i1,j,0) = 0.0
            ub(i1,j,0) = -ub(i1,j,1)
            vb(i1,j,0) = -vb(i1,j,1)
         END DO

      ELSE

c...coarse mesh...

         DO i=5,i1,8
            DO j=0,j1
               wb(i,j,0) = 0.0
               ub(i,j,0) = -ub(i,j,1)
               vb(i,j,0) = -vb(i,j,1)
            END DO
         END DO

         DO i=6,i1,8
            DO j=0,j1
               wb(i,j,0) = 0.0
               ub(i,j,0) = -ub(i,j,1)
               vb(i,j,0) = -vb(i,j,1)
            END DO
         END DO

         DO j=0,j1
            wb(imax,j,0) = 0.0
            ub(imax,j,0) = -ub(i1,j,1)
            vb(imax,j,0) = -vb(i1,j,1)
            wb(i1,j,0)   = 0.0
            ub(i1,j,0)   = -ub(i1,j,1)
            vb(i1,j,0)   = -vb(i1,j,1)
         END DO

      END IF
         
c...circumferential filter

      DO j=3,j1,8
         DO i=5,20
            wb(i,j,0) = 0.0
            ub(i,j,0) = -ub(i,j,1)
            vb(i,j,0) = -vb(i,j,1)
         END DO
      END DO


      DO j=3,j1,4
         DO i=21,i1
            wb(i,j,0) = 0.0
            ub(i,j,0) = -ub(i,j,1)
            vb(i,j,0) = -vb(i,j,1)
         END DO
      END DO

      RETURN
      END
